module:    Dylan-User
Synopsis:  FFI declarations translated from MacOS Carbon header files.
Copyright:    Original Code is Copyright (c) 1995-2004 Functional Objects, Inc.
              All rights reserved.
License:      Functional Objects Library Public License Version 1.0
Dual-license: GNU Lesser General Public License
Warranty:     Distributed WITHOUT WARRANTY OF ANY KIND


/* Automatically generated from "library.src"; do not edit. */


define library carbon-interface
  use functional-dylan;
  use c-ffi;

  export carbon-interface;
end library carbon-interface;

define module carbon-interface
  use functional-dylan;
  use c-ffi,
    export: {null-pointer, null-pointer?, pointer-address,
	     pointer-value, pointer-value-setter, size-of,
	     <C-void*>, <C-pointer>, <C-string>, <C-unicode-string>,
	     <C-string*>, <C-unicode-string*>,
	     pointer-cast, destroy,
	     pointer-value-address, c-type-cast,
	     c-callable-wrapper-definer, 
	     \with-c-string, \with-stack-structure } ;
  use machine-words,
    export: {%logior, %logand};

  // Handcoded types, etc. from special.dylan
  export
    \FOUR_CHAR_CODE, with-pascal-string, C-array-definer,
    <Str255>, <Str63>, <Str32>, <Str31>, <Str27>, <Str15>, <Str32Field>,
    <Bits16>, <FormatOrder>, <OffsetTable>, <CSpecArray>, <KeyMap>, <MCTable>, <ScrpSTTable>,
    <Handle*>, <TECInfoHandle*>, <EvQElPtr*>, <GDHandle*>, <PixMapHandle*>,
    <GrafPtr*>, <CGrafPtr*>, <AEEventHandlerUPP*>, <AliasHandle*>, <AuxWinHandle*>,
    <IconGetterUPP*>, <IconFamilyHandle*>, <C-void**>,
    <ControlHandle*>, <AuxCtlHandle*>, <MenuHandle*>, <ModalFilterUPP*>,
    <OpaqueCollection*>, <OpaqueDragReference*>, <OpaqueIconRef*>,
    <OpaqueCFragConnectionID*>, <OpaqueCFragClosureID*>, <OpaqueCFragContainerID*>,
    <OpaqueCFragContextID*>;

  //---*** NOTE: Need a way to do this automatically!
  export
    randSeed-address, thePort-address;

  //---*** NOTE: TEMPORARY: I don't feel like converting Sound.h today ...
  export
    SysBeep;

  //---*** NOTE: Need to do a proper 64-bit implementation ...
  export
    <SInt64>, <UInt64>;			 

  // %include ConditionalMacros.exp

  // from "MixedMode.h":
  export $kRoutineDescriptorVersion, $_MixedModeMagic,
	$kCurrentMixedModeStateRecord, <CallingConventionType>,
	<CallingConventionType*>, <CallingConventionType**>,
	$kPascalStackBased, $kCStackBased, $kRegisterBased,
	$kD0DispatchedPascalStackBased, $kD1DispatchedPascalStackBased,
	$kD0DispatchedCStackBased, $kStackDispatchedPascalStackBased,
	$kThinkCStackBased, <ISAType>, <ISAType*>, <ISAType**>, $kM68kISA,
	$kPowerPCISA, <RTAType>, <RTAType*>, <RTAType**>, $kOld68kRTA,
	$kPowerPCRTA, $kCFM68kRTA;
  export $kRegisterD0, $kRegisterD1, $kRegisterD2, $kRegisterD3,
	$kRegisterD4, $kRegisterD5, $kRegisterD6, $kRegisterD7, $kRegisterA0,
	$kRegisterA1, $kRegisterA2, $kRegisterA3, $kRegisterA4, $kRegisterA5,
	$kRegisterA6, $kCCRegisterCBit, $kCCRegisterVBit, $kCCRegisterZBit,
	$kCCRegisterNBit, $kCCRegisterXBit;
  export <registerSelectorType>, <registerSelectorType*>,
	<registerSelectorType**>, $kNoByteCode, $kOneByteCode, $kTwoByteCode,
	$kFourByteCode, <ProcInfoType>, <ProcInfoType*>, <ProcInfoType**>,
	<RoutineFlagsType>, <RoutineFlagsType*>, <RoutineFlagsType**>,
	$kProcDescriptorIsAbsolute, $kProcDescriptorIsRelative;
  export $kFragmentIsPrepared, $kFragmentNeedsPreparing;
  export $kUseCurrentISA, $kUseNativeISA;
  export $kPassSelector, $kDontPassSelector;
  export $kRoutineIsNotDispatchedDefaultRoutine,
	$kRoutineIsDispatchedDefaultRoutine;
  export $kProcDescriptorIsProcPtr, $kProcDescriptorIsIndex;
  export procInfo-value, procInfo-value-setter, reserved1-value,
	reserved1-value-setter, ISA-value, ISA-value-setter,
	routineFlags-value, routineFlags-value-setter, procDescriptor-value,
	procDescriptor-value-setter, reserved2-value, reserved2-value-setter,
	selector-value, selector-value-setter, <RoutineRecord>,
	<RoutineRecord*>, <RoutineRecord**>, <RoutineRecordPtr>,
	<RoutineRecordHandle>;
  export <RDFlagsType>, <RDFlagsType*>, <RDFlagsType**>,
	$kSelectorsAreNotIndexable, $kSelectorsAreIndexable,
	goMixedModeTrap-value, goMixedModeTrap-value-setter, version-value,
	version-value-setter, routineDescriptorFlags-value,
	routineDescriptorFlags-value-setter, reserved1-value,
	reserved1-value-setter, reserved2-value, reserved2-value-setter,
	selectorInfo-value, selectorInfo-value-setter, routineCount-value,
	routineCount-value-setter, routineRecords-array,
	routineRecords-array-setter, routineRecords-value,
	<RoutineDescriptor>, <RoutineDescriptor*>, <RoutineDescriptor**>,
	<RoutineDescriptorPtr>, <RoutineDescriptorHandle>, state1-value,
	state1-value-setter, state2-value, state2-value-setter, state3-value,
	state3-value-setter, state4-value, state4-value-setter,
	<MixedModeStateRecord>, <MixedModeStateRecord*>,
	<MixedModeStateRecord**>, $kCallingConventionWidth,
	$kCallingConventionPhase, $kCallingConventionMask, $kResultSizeWidth,
	$kResultSizePhase, $kResultSizeMask, $kStackParameterWidth,
	$kStackParameterPhase, $kStackParameterMask,
	$kRegisterResultLocationWidth, $kRegisterResultLocationPhase,
	$kRegisterParameterWidth, $kRegisterParameterPhase,
	$kRegisterParameterMask, $kRegisterParameterSizePhase,
	$kRegisterParameterSizeWidth, $kRegisterParameterWhichPhase,
	$kRegisterParameterWhichWidth, $kDispatchedSelectorSizeWidth,
	$kDispatchedSelectorSizePhase, $kDispatchedParameterPhase,
	$kSpecialCaseSelectorWidth, $kSpecialCaseSelectorPhase,
	$kSpecialCaseSelectorMask;
  export $kSpecialCase;
  export $kSpecialCaseHighHook, $kSpecialCaseCaretHook,
	$kSpecialCaseEOLHook, $kSpecialCaseWidthHook,
	$kSpecialCaseTextWidthHook, $kSpecialCaseNWidthHook,
	$kSpecialCaseDrawHook, $kSpecialCaseHitTestHook,
	$kSpecialCaseTEFindWord, $kSpecialCaseProtocolHandler,
	$kSpecialCaseSocketListener, $kSpecialCaseTERecalc,
	$kSpecialCaseTEDoText, $kSpecialCaseGNEFilterProc,
	$kSpecialCaseMBarHook;
  export NewRoutineDescriptor, DisposeRoutineDescriptor,
	NewFatRoutineDescriptor;

  // from "MacTypes.h":
  export <UInt8>, <UInt8*>, <UInt8**>, <SInt8>, <SInt8*>, <SInt8**>,
	<UInt16>, <UInt16*>, <UInt16**>, <SInt16>, <SInt16*>, <SInt16**>,
	<UInt32>, <UInt32*>, <UInt32**>, <SInt32>, <SInt32*>, <SInt32**>,
	hi-value, hi-value-setter, lo-value, lo-value-setter, <wide>,
	<wide*>, <wide**>, hi-value, hi-value-setter, lo-value,
	lo-value-setter, <UnsignedWide>, <UnsignedWide*>, <UnsignedWide**>;
  export <Fixed>, <Fixed*>, <Fixed**>, <FixedPtr>, <Fract>, <Fract*>,
	<Fract**>, <FractPtr>, <UnsignedFixed>, <UnsignedFixed*>,
	<UnsignedFixed**>, <ShortFixed>, <ShortFixed*>, <ShortFixed**>;
  export <Float32>, <Float32*>, <Float32**>, exp-value,
	exp-value-setter, man-array, man-array-setter, man-value, <Float80>,
	<Float80*>, <Float80**>, exp-array, exp-array-setter, exp-value,
	man-array, man-array-setter, man-value, <Float96>, <Float96*>,
	<Float96**>;
  export <Ptr>, <Ptr*>, <Ptr**>, <Handle>, <Size>, <Size*>, <Size**>,
	<OSErr>, <OSErr*>, <OSErr**>, <OSStatus>, <OSStatus*>, <OSStatus**>,
	<LogicalAddress>, <ConstLogicalAddress>, <PhysicalAddress>,
	<BytePtr>, <ByteCount>, <ByteCount*>, <ByteCount**>, <ByteOffset>,
	<ByteOffset*>, <ByteOffset**>, <Duration>, <Duration*>, <Duration**>,
	<AbsoluteTime>, <AbsoluteTime*>, <AbsoluteTime**>, <OptionBits>,
	<OptionBits*>, <OptionBits**>, <ItemCount>, <ItemCount*>,
	<ItemCount**>, <PBVersion>, <PBVersion*>, <PBVersion**>,
	<ScriptCode>, <ScriptCode*>, <ScriptCode**>, <LangCode>, <LangCode*>,
	<LangCode**>, <RegionCode>, <RegionCode*>, <RegionCode**>,
	<FourCharCode>, <FourCharCode*>, <FourCharCode**>, <OSType>,
	<OSType*>, <OSType**>, <ResType>, <ResType*>, <ResType**>,
	<OSTypePtr>, <ResTypePtr>, $false, $true;
  export <MacBoolean>, <MacBoolean*>, <MacBoolean**>;
  export <ProcPtr>, <Register68kProcPtr>, <UniversalProcPtr>,
	<UniversalProcPtr*>, <UniversalProcPtr**>;
  export <ProcHandle>, <UniversalProcHandle>;
  export $noErr;
  export $kNilOptions, $kInvalidID, $kVariableLengthArray;
  export $kUnknownType;
  export <UniChar>, <UniChar*>, <UniChar**>, <UniCharCount>,
	<UniCharCount*>, <UniCharCount**>, <StrFileName>, <StrFileName*>,
	<StrFileName**>;
  export <StringPtr>, <StringHandle>, <ConstStringPtr>,
	<ConstStr255Param>, <ConstStr63Param>, <ConstStr32Param>,
	<ConstStr31Param>, <ConstStr27Param>, <ConstStr15Param>,
	<ConstStrFileNameParam>, <ConstStrFileNameParam*>,
	<ConstStrFileNameParam**>, v-value, v-value-setter, h-value,
	h-value-setter, <Point>, <Point*>, <Point**>, <PointPtr>, top-value,
	top-value-setter, left-value, left-value-setter, bottom-value,
	bottom-value-setter, right-value, right-value-setter, <Rect>,
	<Rect*>, <Rect**>, <RectPtr>;
  export <CharParameter>, <CharParameter*>, <CharParameter**>,
	$normal, $bold, $italic, $underline, $outline, $shadow, $condense,
	$extend;
  export <Style>, <Style*>, <Style**>, <StyleParameter>,
	<StyleParameter*>, <StyleParameter**>, <StyleField>, <StyleField*>,
	<StyleField**>;
  export majorRev-value, majorRev-value-setter, minorAndBugRev-value,
	minorAndBugRev-value-setter, stage-value, stage-value-setter,
	nonRelRev-value, nonRelRev-value-setter, <NumVersion>, <NumVersion*>,
	<NumVersion**>;
  export $developStage, $alphaStage, $betaStage, $finalStage;
  export parts-value, parts-value-setter, whole-value,
	whole-value-setter, <NumVersionVariant>, <NumVersionVariant*>,
	<NumVersionVariant**>, numericVersion-value,
	numericVersion-value-setter, countryCode-value,
	countryCode-value-setter, shortVersion-value,
	shortVersion-value-setter, reserved-value, reserved-value-setter,
	<VersRec>, <VersRec*>, <VersRec**>, <VersRecPtr>, <VersRecHndl>;
  export <Byte>, <Byte*>, <Byte**>, <SignedByte>, <SignedByte*>,
	<SignedByte**>, <WidePtr>, <UnsignedWidePtr>, <extended80>,
	<extended80*>, <extended80**>, <extended96>, <extended96*>,
	<extended96**>, <VHSelect>, <VHSelect*>, <VHSelect**>, Debugger,
	DebugStr, SysDebug, SysDebugStr, SysBreak, SysBreakStr, SysBreakFunc;

  // from "Errors.h":
  export $paramErr, $noHardwareErr, $notEnoughHardwareErr,
	$userCanceledErr, $qErr, $vTypErr, $corErr, $unimpErr, $SlpTypeErr,
	$seNoDB, $controlErr, $statusErr, $readErr, $writErr, $badUnitErr,
	$unitEmptyErr, $openErr, $closErr, $dRemovErr, $dInstErr;
  export $abortErr, $iIOAbortErr, $notOpenErr, $unitTblFullErr,
	$dceExtErr, $slotNumErr, $gcrOnMFMErr, $dirFulErr, $dskFulErr,
	$nsvErr, $ioErr, $bdNamErr, $fnOpnErr, $eofErr, $posErr, $mFulErr,
	$tmfoErr, $fnfErr, $wPrErr, $fLckdErr;
  export $vLckdErr, $fBsyErr, $dupFNErr, $opWrErr, $rfNumErr, $gfpErr,
	$volOffLinErr, $permErr, $volOnLinErr, $nsDrvErr, $noMacDskErr,
	$extFSErr, $fsRnErr, $badMDBErr, $wrPermErr, $dirNFErr, $tmwdoErr,
	$badMovErr, $wrgVolTypErr, $volGoneErr;
  export $fidNotFound, $fidExists, $notAFileErr, $diffVolErr,
	$catChangedErr, $desktopDamagedErr, $sameFileErr, $badFidErr,
	$notARemountErr, $fileBoundsErr, $fsDataTooBigErr, $volVMBusyErr,
	$envNotPresent, $envBadVers, $envVersTooBig, $fontDecError,
	$fontNotDeclared, $fontSubErr, $fontNotOutlineErr, $firstDskErr,
	$lastDskErr, $noDriveErr, $offLinErr, $noNybErr;
  export $noAdrMkErr, $dataVerErr, $badCksmErr, $badBtSlpErr,
	$noDtaMkErr, $badDCksum, $badDBtSlp, $wrUnderrun, $cantStepErr,
	$tk0BadErr, $initIWMErr, $twoSideErr, $spdAdjErr, $seekErr,
	$sectNFErr, $fmt1Err, $fmt2Err, $verErr, $clkRdErr, $clkWrErr,
	$prWrErr, $prInitErr, $rcvrErr, $breakRecd;
  export $noScrapErr, $noTypeErr;
  export $eLenErr, $eMultiErr;
  export $ddpSktErr, $ddpLenErr, $noBridgeErr, $lapProtErr,
	$excessCollsns, $portNotPwr, $portInUse, $portNotCf;
  export $memROZWarn, $memROZError, $memROZErr, $memFullErr,
	$nilHandleErr, $memWZErr, $memPurErr, $memAdrErr, $memAZErr,
	$memPCErr, $memBCErr, $memSCErr, $memLockedErr;
  export $iMemFullErr, $iIOAbort;
  export $resourceInMemory, $writingPastEnd, $inputOutOfBounds,
	$resNotFound, $resFNotFound, $addResFailed, $addRefFailed,
	$rmvResFailed, $rmvRefFailed, $resAttrErr, $mapReadErr,
	$CantDecompress, $badExtResource, $noMemForPictPlaybackErr,
	$rgnOverflowErr, $rgnTooBigError, $pixMapTooDeepErr,
	$insufficientStackErr, $nsStackErr;
  export $evtNotEnb, $cMatchErr, $cTempMemErr, $cNoMemErr, $cRangeErr,
	$cProtectErr, $cDevErr, $cResErr, $cDepthErr, $rgnTooBigErr,
	$updPixMemErr, $pictInfoVersionErr, $pictInfoIDErr, $pictInfoVerbErr,
	$cantLoadPickMethodErr, $colorsRequestedErr, $pictureDataErr;
  export $noHardware, $notEnoughHardware, $queueFull, $resProblem,
	$badChannel, $badFormat, $notEnoughBufferSpace, $badFileFormat,
	$channelBusy, $buffersTooSmall, $channelNotBusy, $noMoreRealTime,
	$siNoSoundInHardware, $siBadSoundInDevice, $siNoBufferSpecified,
	$siInvalidCompression, $siHardDriveTooSlow, $siInvalidSampleRate,
	$siInvalidSampleSize, $siDeviceBusyErr, $siBadDeviceName,
	$siBadRefNum, $siInputDeviceErr, $siUnknownInfoType,
	$siUnknownQuality, $noSynthFound, $synthOpenFailed, $synthNotReady,
	$bufTooSmall, $voiceNotFound, $incompatibleVoice, $badDictFormat,
	$badInputText, $midiNoClientErr, $midiNoPortErr,
	$midiTooManyPortsErr, $midiTooManyConsErr, $midiVConnectErr,
	$midiVConnectMade, $midiVConnectRmvd, $midiNoConErr, $midiWriteErr,
	$midiNameLenErr, $midiDupIDErr, $midiInvalidCmdErr;
  export $nmTypErr;
  export $siInitSDTblErr, $siInitVBLQsErr, $siInitSPTblErr,
	$sdmJTInitErr, $sdmInitErr, $sdmSRTInitErr, $sdmPRAMInitErr,
	$sdmPriInitErr;
  export $smSDMInitErr, $smSRTInitErr, $smPRAMInitErr, $smPriInitErr,
	$smEmptySlot, $smCRCFail, $smFormatErr, $smRevisionErr, $smNoDir,
	$smDisabledSlot, $smNosInfoArray;
  export $smResrvErr, $smUnExBusErr, $smBLFieldBad, $smFHBlockRdErr,
	$smFHBlkDispErr, $smDisposePErr, $smNoBoardSRsrc, $smGetPRErr,
	$smNoBoardId, $smInitStatVErr, $smInitTblVErr, $smNoJmpTbl,
	$smReservedSlot, $smBadBoardId, $smBusErrTO, $svTempDisable,
	$svDisabled, $smBadRefId, $smBadsList, $smReservedErr, $smCodeRevErr;
  export $smCPUErr, $smsPointerNil, $smNilsBlockErr, $smSlotOOBErr,
	$smSelOOBErr, $smNewPErr, $smBlkMoveErr, $smCkStatusErr,
	$smGetDrvrNamErr, $smDisDrvrNamErr, $smNoMoresRsrcs, $smsGetDrvrErr,
	$smBadsPtrErr, $smByteLanesErr, $smOffsetErr, $smNoGoodOpens,
	$smSRTOvrFlErr, $smRecNotFnd;
  export $notBTree, $btNoSpace, $btDupRecErr, $btRecNotFnd,
	$btKeyLenErr, $btKeyAttrErr, $unknownInsertModeErr,
	$recordDataTooBigErr, $invalidIndexErr;
  export $editionMgrInitErr, $badSectionErr, $notRegisteredSectionErr,
	$badEditionFileErr, $badSubPartErr, $multiplePublisherWrn,
	$containerNotFoundWrn, $containerAlreadyOpenWrn, $notThePublisherWrn;
  export $teScrapSizeErr, $hwParamErr;
  export $procNotFound, $memFragErr, $appModeErr, $protocolErr,
	$hardwareConfigErr, $appMemFullErr, $appIsDaemon, $bufferIsSmall,
	$noOutstandingHLE, $connectionInvalid, $noUserInteractionAllowed,
	$threadTooManyReqsErr, $threadNotFoundErr, $threadProtocolErr,
	$notEnoughMemoryErr, $notHeldErr, $cannotMakeContiguousErr,
	$notLockedErr, $interruptsMaskedErr, $cannotDeferErr, $noMMUErr;
  export $rcDBNull, $rcDBValue, $rcDBError, $rcDBBadType, $rcDBBreak,
	$rcDBExec, $rcDBBadSessID, $rcDBBadSessNum, $rcDBBadDDEV,
	$rcDBAsyncNotSupp, $rcDBBadAsyncPB, $rcDBNoHandler,
	$rcDBWrongVersion, $rcDBPackNotInited;
  export $hmHelpDisabled, $hmBalloonAborted, $hmSameAsLastBalloon,
	$hmHelpManagerNotInited, $hmSkippedBalloon, $hmWrongVersion,
	$hmUnknownHelpType, $hmOperationUnsupported, $hmNoBalloonUp,
	$hmCloseViewActive;
  export $notInitErr, $nameTypeErr, $noPortErr, $noGlobalsErr,
	$localOnlyErr, $destPortErr, $sessTableErr, $noSessionErr,
	$badReqErr, $portNameExistsErr, $noUserNameErr, $userRejectErr,
	$noMachineNameErr, $noToolboxNameErr, $noResponseErr, $portClosedErr,
	$sessClosedErr, $badPortNameErr, $noDefaultUserErr, $notLoggedInErr,
	$noUserRefErr, $networkErr, $noInformErr, $authFailErr,
	$noUserRecErr, $badServiceMethodErr, $badLocNameErr,
	$guestNotAllowedErr;
  export $noMaskFoundErr;
  export $nbpBuffOvr, $nbpNoConfirm, $nbpConfDiff, $nbpDuplicate,
	$nbpNotFound, $nbpNISErr;
  export $aspBadVersNum, $aspBufTooSmall, $aspNoMoreSess,
	$aspNoServers, $aspParamErr, $aspServerBusy, $aspSessClosed,
	$aspSizeErr, $aspTooMany, $aspNoAck;
  export $reqFailed, $tooManyReqs, $tooManySkts, $badATPSkt,
	$badBuffNum, $noRelErr, $cbNotFound, $noSendResp, $noDataArea,
	$reqAborted, $errRefNum, $errAborted, $errState, $errOpening,
	$errAttention, $errFwdReset, $errDSPQueueSize, $errOpenDenied;
  export $errAECoercionFail, $errAEDescNotFound, $errAECorruptData,
	$errAEWrongDataType, $errAENotAEDesc, $errAEBadListItem,
	$errAENewerVersion, $errAENotAppleEvent, $errAEEventNotHandled,
	$errAEReplyNotValid, $errAEUnknownSendMode, $errAEWaitCanceled,
	$errAETimeout, $errAENoUserInteraction, $errAENotASpecialFunction,
	$errAEParamMissed, $errAEUnknownAddressType, $errAEHandlerNotFound,
	$errAEReplyNotArrived, $errAEIllegalIndex, $errAEImpossibleRange,
	$errAEWrongNumberArgs, $errAEAccessorNotFound, $errAENoSuchLogical,
	$errAEBadTestKey, $errAENotAnObjSpec, $errAENoSuchObject,
	$errAENegativeCount, $errAEEmptyListContainer,
	$errAEUnknownObjectType, $errAERecordingIsAlreadyOn,
	$errAEReceiveTerminate, $errAEReceiveEscapeCurrent,
	$errAEEventFiltered, $errAEDuplicateHandler, $errAEStreamBadNesting,
	$errAEStreamAlreadyConverted, $errAEDescIsNull;
  export $errOSASystemError, $errOSAInvalidID, $errOSABadStorageType,
	$errOSAScriptError, $errOSABadSelector, $errOSASourceNotAvailable,
	$errOSANoSuchDialect, $errOSADataFormatObsolete,
	$errOSADataFormatTooNew, $errOSACorruptData,
	$errOSARecordingIsAlreadyOn, $errOSAComponentMismatch,
	$errOSACantOpenComponent;
  export $errOffsetInvalid, $errOffsetIsOutsideOfView,
	$errTopOfDocument, $errTopOfBody, $errEndOfDocument, $errEndOfBody;
  export $badDragRefErr, $badDragItemErr, $badDragFlavorErr,
	$duplicateFlavorErr, $cantGetFlavorErr, $duplicateHandlerErr,
	$handlerNotFoundErr, $dragNotAcceptedErr, $unsupportedForPlatformErr,
	$noSuitableDisplaysErr, $badImageRgnErr, $badImageErr;
  export $couldNotResolveDataRef, $badImageDescription,
	$badPublicMovieAtom, $cantFindHandler, $cantOpenHandler,
	$badComponentType, $noMediaHandler, $noDataHandler, $invalidMedia,
	$invalidTrack, $invalidMovie, $invalidSampleTable, $invalidDataRef,
	$invalidHandler, $invalidDuration, $invalidTime,
	$cantPutPublicMovieAtom, $badEditList, $mediaTypesDontMatch,
	$progressProcAborted, $movieToolboxUninitialized, $noRecordOfApp,
	$wfFileNotFound, $cantCreateSingleForkFile, $invalidEditState,
	$nonMatchingEditState, $staleEditState, $userDataItemNotFound,
	$maxSizeToGrowTooSmall, $badTrackIndex, $trackIDNotFound,
	$trackNotInMovie, $timeNotInTrack, $timeNotInMedia, $badEditIndex,
	$internalQuickTimeError, $cantEnableTrack, $invalidRect,
	$invalidSampleNum, $invalidChunkNum, $invalidSampleDescIndex,
	$invalidChunkCache, $invalidSampleDescription, $dataNotOpenForRead,
	$dataNotOpenForWrite, $dataAlreadyOpenForWrite, $dataAlreadyClosed,
	$endOfDataReached, $dataNoDataRef, $noMovieFound,
	$invalidDataRefContainer, $badDataRefIndex, $noDefaultDataRef,
	$couldNotUseAnExistingSample, $featureUnsupported,
	$noVideoTrackInMovieErr, $noSoundTrackInMovieErr,
	$soundSupportNotAvailableErr, $unsupportedAuxiliaryImportData,
	$auxiliaryExportDataUnavailable, $samplesAlreadyInMediaErr,
	$noSourceTreeFoundErr, $sourceNotFoundErr, $movieTextNotFoundErr,
	$missingRequiredParameterErr, $invalidSpriteWorldPropertyErr,
	$invalidSpritePropertyErr, $gWorldsNotSameDepthAndSizeErr,
	$invalidSpriteIndexErr, $invalidImageIndexErr, $invalidSpriteIDErr;
  export $internalComponentErr, $notImplementedMusicOSErr,
	$cantSendToSynthesizerOSErr, $cantReceiveFromSynthesizerOSErr,
	$illegalVoiceAllocationOSErr, $illegalPartOSErr,
	$illegalChannelOSErr, $illegalKnobOSErr, $illegalKnobValueOSErr,
	$illegalInstrumentOSErr, $illegalControllerOSErr,
	$midiManagerAbsentOSErr, $synthesizerNotRespondingOSErr,
	$synthesizerOSErr, $illegalNoteChannelOSErr,
	$noteChannelNotAllocatedOSErr, $tunePlayerFullOSErr, $tuneParseOSErr,
	$noExportProcAvailableErr, $videoOutputInUseErr;
  export $componentDllLoadErr, $componentDllEntryNotFoundErr,
	$qtmlDllLoadErr, $qtmlDllEntryNotFoundErr, $qtmlUninitialized,
	$unsupportedOSErr, $unsupportedProcessorErr;
  export $cannotFindAtomErr, $notLeafAtomErr, $atomsNotOfSameTypeErr,
	$atomIndexInvalidErr, $duplicateAtomTypeAndIDErr, $invalidAtomErr,
	$invalidAtomContainerErr, $invalidAtomTypeErr, $cannotBeLeafAtomErr;
  export $digiUnimpErr, $qtParamErr, $matrixErr, $notExactMatrixErr,
	$noMoreKeyColorsErr, $notExactSizeErr, $badDepthErr, $noDMAErr,
	$badCallOrderErr;
  export $kernelIncompleteErr, $kernelCanceledErr, $kernelOptionsErr,
	$kernelPrivilegeErr, $kernelUnsupportedErr, $kernelObjectExistsErr,
	$kernelWritePermissionErr, $kernelReadPermissionErr,
	$kernelExecutePermissionErr, $kernelDeletePermissionErr,
	$kernelExecutionLevelErr, $kernelAttributeErr,
	$kernelAsyncSendLimitErr, $kernelAsyncReceiveLimitErr,
	$kernelTimeoutErr, $kernelInUseErr, $kernelTerminatedErr,
	$kernelExceptionErr, $kernelIDErr, $kernelAlreadyFreeErr,
	$kernelReturnValueErr, $kernelUnrecoverableErr;
  export $tsmComponentNoErr, $tsmUnsupScriptLanguageErr,
	$tsmInputMethodNotFoundErr, $tsmNotAnAppErr,
	$tsmAlreadyRegisteredErr, $tsmNeverRegisteredErr,
	$tsmInvalidDocIDErr, $tsmTSMDocBusyErr, $tsmDocNotActiveErr,
	$tsmNoOpenTSErr, $tsmCantOpenComponentErr,
	$tsmTextServiceNotFoundErr, $tsmDocumentOpenErr,
	$tsmUseInputWindowErr, $tsmTSHasNoMenuErr, $tsmTSNotOpenErr,
	$tsmComponentAlreadyOpenErr, $tsmInputMethodIsOldErr,
	$tsmScriptHasNoIMErr, $tsmUnsupportedTypeErr, $tsmUnknownErr,
	$tsmInvalidContext, $tsmNoHandler, $tsmNoMoreTokens, $tsmNoStem,
	$tsmDefaultIsNotInputMethodErr;
  export $mmInternalError, $nrLockedErr, $nrNotEnoughMemoryErr,
	$nrInvalidNodeErr, $nrNotFoundErr, $nrNotCreatedErr, $nrNameErr,
	$nrNotSlotDeviceErr, $nrDataTruncatedErr, $nrPowerErr,
	$nrPowerSwitchAbortErr, $nrTypeMismatchErr, $nrNotModifiedErr,
	$nrOverrunErr, $nrResultCodeBase, $nrPathNotFound,
	$nrPathBufferTooSmall, $nrInvalidEntryIterationOp,
	$nrPropertyAlreadyExists, $nrIterationDone, $nrExitedIteratorScope,
	$nrTransactionAborted, $errASCantConsiderAndIgnore,
	$errASCantCompareMoreThan32k, $errASTerminologyNestingTooDeep,
	$errASIllegalFormalParameter, $errASParameterNotForEvent,
	$errASNoResultReturned, $errASInconsistentNames;
  export $cfragFirstErrCode, $cfragContextIDErr,
	$cfragConnectionIDErr, $cfragNoSymbolErr, $cfragNoSectionErr,
	$cfragNoLibraryErr, $cfragDupRegistrationErr,
	$cfragFragmentFormatErr, $cfragUnresolvedErr, $cfragNoPositionErr,
	$cfragNoPrivateMemErr, $cfragNoClientMemErr, $cfragNoIDsErr,
	$cfragInitOrderErr, $cfragImportTooOldErr, $cfragImportTooNewErr,
	$cfragInitLoopErr, $cfragInitAtBootErr, $cfragLibConnErr,
	$cfragCFMStartupErr, $cfragCFMInternalErr, $cfragFragmentCorruptErr,
	$cfragInitFunctionErr, $cfragNoApplicationErr, $cfragArchitectureErr,
	$cfragFragmentUsageErr, $cfragFileSizeErr, $cfragNotClosureErr,
	$cfragNoRegistrationErr, $cfragContainerIDErr, $cfragClosureIDErr,
	$cfragAbortClosureErr, $cfragOutputLengthErr, $cfragLastErrCode,
	$invalidComponentID, $validInstancesExist, $componentNotCaptured,
	$componentDontRegister, $unresolvedComponentDLLErr,
	$invalidTranslationPathErr, $couldNotParseSourceFileErr,
	$noTranslationPathErr, $badTranslationSpecErr, $noPrefAppErr;
  export $buf2SmallErr, $noMPPErr, $ckSumErr, $extractErr, $readQErr,
	$atpLenErr, $atpBadRsp, $recNotFnd, $sktClosedErr;
  export $firstPickerError, $invalidPickerType,
	$requiredFlagsDontMatch, $pickerResourceError, $cantLoadPicker,
	$cantCreatePickerWindow, $cantLoadPackage, $pickerCantLive,
	$colorSyncNotInstalled, $badProfileError, $noHelpForItem;
  export $badFolderDescErr, $duplicateFolderDescErr,
	$noMoreFolderDescErr, $invalidFolderTypeErr, $duplicateRoutingErr,
	$routingNotFoundErr, $badRoutingSizeErr;
  export $afpAccessDenied, $afpAuthContinue, $afpBadUAM,
	$afpBadVersNum, $afpBitmapErr, $afpCantMove, $afpDenyConflict,
	$afpDirNotEmpty, $afpDiskFull, $afpEofError, $afpFileBusy,
	$afpFlatVol, $afpItemNotFound, $afpLockErr, $afpMiscErr,
	$afpNoMoreLocks, $afpNoServer, $afpObjectExists, $afpObjectNotFound,
	$afpParmErr, $afpRangeNotLocked, $afpRangeOverlap, $afpSessClosed,
	$afpUserNotAuth, $afpCallNotSupported, $afpObjectTypeErr,
	$afpTooManyFilesOpen, $afpServerGoingDown, $afpCantRename,
	$afpDirNotFound, $afpIconTypeError, $afpVolLocked, $afpObjectLocked,
	$afpContainsSharedErr, $afpIDNotFound, $afpIDExists, $afpDiffVolErr,
	$afpCatalogChanged, $afpSameObjectErr, $afpBadIDErr, $afpPwdSameErr,
	$afpPwdTooShortErr, $afpPwdExpiredErr, $afpInsideSharedErr,
	$afpInsideTrashErr, $afpPwdNeedsChangeErr, $afpPwdPolicyErr;
  export $afpBadDirIDType, $afpCantMountMoreSrvre, $afpAlreadyMounted,
	$afpSameNodeErr;
  export $errUnknownAttributeTag, $errMarginWilllNotFit,
	$errNotInImagingMode, $errAlreadyInImagingMode, $errEngineNotFound,
	$errIteratorReachedEnd, $errInvalidRange,
	$errOffsetNotOnElementBounday, $errNoHiliteText, $errEmptyScrap,
	$errReadOnlyText, $errUnknownElement, $errNonContiuousAttribute,
	$errCannotUndo;
  export $gestaltUnknownErr, $gestaltUndefSelectorErr,
	$gestaltDupSelectorErr, $gestaltLocationErr;
  export $collectionItemLockedErr, $collectionItemNotFoundErr,
	$collectionIndexRangeErr, $collectionVersionErr;
  export $kDMGenErr, $kDMMirroringOnAlready,
	$kDMWrongNumberOfDisplays, $kDMMirroringBlocked, $kDMCantBlock,
	$kDMMirroringNotOn, $kSysSWTooOld, $kDMSWNotInitializedErr,
	$kDMDriverNotDisplayMgrAwareErr, $kDMDisplayNotFoundErr,
	$kDMNotFoundErr, $kDMDisplayAlreadyInstalledErr,
	$kDMMainDisplayCannotMoveErr, $kDMNoDeviceTableclothErr,
	$kDMFoundErr;
  export $kTextUnsupportedEncodingErr, $kTextMalformedInputErr,
	$kTextUndefinedElementErr, $kTECMissingTableErr,
	$kTECTableChecksumErr, $kTECTableFormatErr, $kTECCorruptConverterErr,
	$kTECNoConversionPathErr, $kTECBufferBelowMinimumSizeErr,
	$kTECArrayFullErr, $kTECBadTextRunErr, $kTECPartialCharErr,
	$kTECUnmappableElementErr, $kTECIncompleteElementErr,
	$kTECDirectionErr, $kTECGlobalsUnavailableErr,
	$kTECItemUnavailableErr, $kTECUsedFallbacksStatus,
	$kTECNeedFlushStatus, $kTECOutputBufferFullStatus,
	$unicodeChecksumErr, $unicodeNoTableErr, $unicodeVariantErr,
	$unicodeFallbacksErr, $unicodePartConvertErr, $unicodeBufErr,
	$unicodeCharErr, $unicodeElementErr, $unicodeNotFoundErr,
	$unicodeTableFormatErr, $unicodeDirectionErr, $unicodeContextualErr,
	$unicodeTextEncodingDataErr;
  export $codecErr, $noCodecErr, $codecUnimpErr, $codecSizeErr,
	$codecScreenBufErr, $codecImageBufErr, $codecSpoolErr,
	$codecAbortErr, $codecWouldOffscreenErr, $codecBadDataErr,
	$codecDataVersErr, $codecExtensionNotFoundErr, $scTypeNotFoundErr,
	$codecConditionErr, $codecOpenErr, $codecCantWhenErr,
	$codecCantQueueErr, $codecNothingToBlitErr,
	$codecNoMemoryPleaseWaitErr, $codecDisabledErr,
	$codecNeedToFlushChainErr, $lockPortBitsBadSurfaceErr,
	$lockPortBitsWindowMovedErr, $lockPortBitsWindowResizedErr,
	$lockPortBitsWindowClippedErr, $lockPortBitsBadPortErr,
	$lockPortBitsSurfaceLostErr, $codecParameterDialogConfirm,
	$codecNeedAccessKeyErr, $codecOffscreenFailedErr,
	$codecDroppedFrameErr;
  export $noDeviceForChannel, $grabTimeComplete,
	$cantDoThatInCurrentMode, $notEnoughMemoryToGrab,
	$notEnoughDiskSpaceToGrab, $couldntGetRequiredComponent,
	$badSGChannel, $seqGrabInfoNotAvailable, $deviceCantMeetRequest,
	$badControllerHeight, $editingNotAllowed, $controllerBoundsNotExact,
	$cannotSetWidthOfAttachedController, $controllerHasFixedHeight,
	$cannotMoveAttachedController, $errAEBadKeyForm,
	$errAECantHandleClass, $errAECantSupplyType, $errAECantUndo,
	$errAEEventFailed, $errAEIndexTooLarge, $errAEInTransaction,
	$errAELocalOnly, $errAENoSuchTransaction, $errAENotAnElement,
	$errAENotASingleObject, $errAENotModifiable, $errAENoUserSelection,
	$errAEPrivilegeError, $errAEReadDenied, $errAETypeError,
	$errAEWriteDenied, $errAENotAnEnumMember, $errAECantPutThatThere,
	$errAEPropertiesClash, $telGenericError, $telNoErr, $telNoTools,
	$telBadTermErr, $telBadDNErr, $telBadCAErr, $telBadHandErr,
	$telBadProcErr, $telCAUnavail, $telNoMemErr, $telNoOpenErr,
	$telBadHTypeErr, $telHTypeNotSupp, $telBadLevelErr, $telBadVTypeErr,
	$telVTypeNotSupp, $telBadAPattErr, $telAPattNotSupp, $telBadIndex,
	$telIndexNotSupp, $telBadStateErr, $telStateNotSupp, $telBadIntExt,
	$telIntExtNotSupp, $telBadDNDType, $telDNDTypeNotSupp,
	$telFeatNotSub, $telFeatNotAvail, $telFeatActive, $telFeatNotSupp,
	$telConfLimitErr, $telConfNoLimit, $telConfErr, $telConfRej,
	$telTransferErr, $telTransferRej, $telCBErr, $telConfLimitExceeded,
	$telBadDNType, $telBadPageID, $telBadIntercomID, $telBadFeatureID,
	$telBadFwdType, $telBadPickupGroupID, $telBadParkID, $telBadSelect,
	$telBadBearerType, $telBadRate, $telDNTypeNotSupp,
	$telFwdTypeNotSupp, $telBadDisplayMode, $telDisplayModeNotSupp,
	$telNoCallbackRef, $telAlreadyOpen, $telStillNeeded, $telTermNotOpen,
	$telCANotAcceptable, $telCANotRejectable, $telCANotDeflectable,
	$telPBErr, $telBadFunction, $telNoSuchTool, $telUnknownErr,
	$telNoCommFolder, $telInitFailed, $telBadCodeResource,
	$telDeviceNotFound, $telBadProcID, $telValidateFailed,
	$telAutoAnsNotOn, $telDetAlreadyOn, $telBadSWErr, $telBadSampleRate,
	$telNotEnoughdspBW;
  export $pmBusyErr, $pmReplyTOErr, $pmSendStartErr, $pmSendEndErr,
	$pmRecvStartErr, $pmRecvEndErr, $printerStatusOpCodeNotSupportedErr,
	$kUCOutputBufferTooSmall, $kMPBlueBlockingErr,
	$kMPNanokernelNeedsMemoryErr, $kMPDeletedErr, $kMPTimeoutErr,
	$kMPTaskAbortedErr, $kMPInsufficientResourcesErr, $kMPInvalidIDErr;
  export $kCollateAttributesNotFoundErr, $kCollateInvalidOptions,
	$kCollateMissingUnicodeTableErr, $kCollateUnicodeConvertFailedErr,
	$kCollatePatternNotFoundErr, $kCollateInvalidChar,
	$kCollateBufferTooSmall, $kCollateInvalidCollationRef;
  export $textObjInvalidIndexErr, $textObjBufferTooSmallErr,
	$textObjObjectTooSmallErr, $textObjTextConversionFailedErr,
	$textObjMalformedObjectErr, $textObjAnnotationNotFoundErr,
	$textObjMoreAnnotationsErr, $textObjLanguageChangedErr,
	$textObjFontNotFoundErr, $localeNotFoundErr,
	$localeObjectAttributeNotAvailErr, $localeObjectNoNamesTableErr,
	$localeBadReferenceErr, $localeObjectNotFoundErr,
	$localeObjectInvalidReferenceErr, $localeObjectItemFoundIsLastErr,
	$localeObjectNameAttributeConflictErr,
	$localeObjectInvalidIteratorErr, $localeObjectNoNameErr,
	$localeObjectTagDataNotFoundErr,
	$localeObjectCannotDeleteSystemObjectErr,
	$localeCouldNotWriteLinkedObjectsErr, $localeDuplicateErr,
	$localeObjectDefaultValueNotAvailableErr,
	$localeNoAssociatedDataTagsErr, $kALMInternalErr,
	$kALMGroupNotFoundErr, $kALMNoSuchModuleErr,
	$kALMModuleCommunicationErr, $kALMDuplicateModuleErr,
	$kALMInstallationErr, $kALMDeferSwitchErr, $kALMRebootFlagsLevelErr;
  export $kALMLocationNotFoundErr, $notAQTVRMovieErr,
	$constraintReachedErr, $callNotSupportedByNodeErr,
	$selectorNotSupportedByNodeErr, $invalidNodeIDErr,
	$invalidViewStateErr, $timeNotInViewErr,
	$propertyNotSupportedByNodeErr, $settingNotSupportedByNodeErr,
	$limitReachedErr, $invalidNodeFormatErr, $invalidHotSpotIDErr,
	$noMemoryNodeFailedInitialize, $streamingNodeNotReadyErr;
  export $badComponentInstance, $badComponentSelector;
  export $dsBusError, $dsAddressErr, $dsIllInstErr, $dsZeroDivErr,
	$dsChkErr, $dsOvflowErr, $dsPrivErr, $dsTraceErr, $dsLineAErr,
	$dsLineFErr, $dsMiscErr, $dsCoreErr, $dsIrqErr, $dsIOCoreErr,
	$dsLoadErr, $dsFPErr, $dsNoPackErr, $dsNoPk1, $dsNoPk2;
  export $dsNoPk3, $dsNoPk4, $dsNoPk5, $dsNoPk6, $dsNoPk7,
	$dsMemFullErr, $dsBadLaunch, $dsFSErr, $dsStknHeap, $negZcbFreeErr,
	$dsFinderErr, $dsBadSlotInt, $dsBadSANEOpcode, $dsBadPatchHeader,
	$menuPrgErr, $dsMBarNFnd, $dsHMenuFindErr, $dsWDEFNotFound,
	$dsCDEFNotFound, $dsMDEFNotFound;
  export $dsNoFPU, $dsNoPatch, $dsBadPatch, $dsParityErr,
	$dsOldSystem, $ds32BitMode, $dsNeedToWriteBootBlocks,
	$dsNotEnoughRAMToBoot, $dsBufPtrTooLow, $dsVMDeferredFuncTableFull,
	$dsVMBadBackingStore, $dsCantHoldSystemHeap,
	$dsSystemRequiresPowerPC, $dsGibblyMovedToDisabledFolder,
	$dsUnBootableSystem, $dsWriteToSupervisorStackGuardPage, $dsReinsert,
	$shutDownAlert, $dsShutDownOrRestart, $dsSwitchOffOrRestart,
	$dsForcedQuit, $dsRemoveDisk, $dsDirtyDisk, $dsShutDownOrResume,
	$dsSCSIWarn, $dsMBSysError, $dsMBFlpySysError, $dsMBATASysError,
	$dsMBATAPISysError, $dsMBExternFlpySysError, $dsNoExtsMacsBug,
	$dsNoExtsDisassembler, $dsMacsBugInstalled, $dsDisassemblerInstalled,
	$dsExtensionsDisabled, $dsGreeting, $dsSysErr, $WDEFNFnd;
  export $CDEFNFnd, $dsNotThe1, $dsBadStartupDisk, $dsSystemFileErr,
	$dsHD20Installed, $mBarNFnd, $hMenuFindErr, $userBreak,
	$strUserBreak, $exUserBreak;
  export $dsBadLibrary, $dsMixedModeFailure;
  export SysError;

  // from "OSUtils.h":
  export $useFree, $useATalk, $useAsync, $useExtClk, $useMIDI;
  export $false32b, $true32b;
  export $sortsBefore, $sortsEqual, $sortsAfter;
  export $dummyType, $vType, $ioQType, $drvQType, $evType, $fsQType,
	$sIQType, $dtQType, $nmType;
  export <QTypes>, <QTypes*>, <QTypes**>, valid-value,
	valid-value-setter, aTalkA-value, aTalkA-value-setter, aTalkB-value,
	aTalkB-value-setter, config-value, config-value-setter, portA-value,
	portA-value-setter, portB-value, portB-value-setter, alarm-value,
	alarm-value-setter, font-value, font-value-setter, kbdPrint-value,
	kbdPrint-value-setter, volClik-value, volClik-value-setter,
	misc-value, misc-value-setter, <SysParmType>, <SysParmType*>,
	<SysParmType**>;
  export <SysPPtr>, qLink-value, qLink-value-setter, qType-value,
	qType-value-setter, qData-array, qData-array-setter, qData-value,
	<QElem>, <QElem*>, <QElem**>, <QElemPtr>, qFlags-value,
	qFlags-value-setter, qHead-value, qHead-value-setter, qTail-value,
	qTail-value-setter, <QHdr>, <QHdr*>, <QHdr**>, <QHdrPtr>;
  export <DeferredTaskProcPtr>, <DeferredTaskUPP>,
	$uppDeferredTaskProcInfo, qLink-value, qLink-value-setter,
	qType-value, qType-value-setter, dtFlags-value, dtFlags-value-setter,
	dtAddr-value, dtAddr-value-setter, dtParam-value,
	dtParam-value-setter, <DeferredTask>, <DeferredTask*>,
	<DeferredTask**>, <DeferredTaskPtr>, latitude-value,
	latitude-value-setter, longitude-value, longitude-value-setter,
	dlsDelta-value, dlsDelta-value-setter, gmtDelta-value,
	gmtDelta-value-setter, dlsDelta-value, dlsDelta-value-setter,
	gmtDelta-value, gmtDelta-value-setter, u-value, u-value-setter,
	<MachineLocation>, <MachineLocation*>, <MachineLocation**>, IsMetric,
	GetSysPPtr;
  export DTInstall;
  export Delay;
  export WriteParam, Enqueue, Dequeue, SetCurrentA5, SetA5, InitUtil;
  export MakeDataExecutable, FlushCodeCacheRange, ReadLocation;
  export WriteLocation;
  export $curSysEnvVers;
  export environsVersion-value, environsVersion-value-setter,
	machineType-value, machineType-value-setter, systemVersion-value,
	systemVersion-value-setter, processor-value, processor-value-setter,
	hasFPU-value, hasFPU-value-setter, hasColorQD-value,
	hasColorQD-value-setter, keyBoardType-value,
	keyBoardType-value-setter, atDrvrVersNum-value,
	atDrvrVersNum-value-setter, sysVRefNum-value,
	sysVRefNum-value-setter, <SysEnvRec>, <SysEnvRec*>, <SysEnvRec**>,
	$envMac, $envXL, $envMachUnknown, $env512KE, $envMacPlus, $envSE,
	$envMacII, $envMacIIx, $envMacIIcx, $envSE30, $envPortable,
	$envMacIIci, $envMacIIfx;
  export $envCPUUnknown, $env68000, $env68010, $env68020, $env68030,
	$env68040;
  export $envUnknownKbd, $envMacKbd, $envMacAndPad, $envMacPlusKbd,
	$envAExtendKbd, $envStandADBKbd, $envPrtblADBKbd, $envPrtblISOKbd,
	$envStdISOADBKbd, $envExtISOADBKbd, SysEnvirons;

  // from "DateTimeUtils.h":
  export $toggleUndefined, $toggleOK, $toggleBadField,
	$toggleBadDelta, $toggleBadChar, $toggleUnknown, $toggleBadNum,
	$toggleOutOfRange, $toggleErr3, $toggleErr4, $toggleErr5;
  export $smallDateBit, $togChar12HourBit, $togCharZCycleBit,
	$togDelta12HourBit, $genCdevRangeBit, $validDateFields,
	$maxDateField;
  export $eraMask, $yearMask, $monthMask, $dayMask, $hourMask,
	$minuteMask, $secondMask, $dayOfWeekMask, $dayOfYearMask,
	$weekOfYearMask, $pmMask, $dateStdMask;
  export $eraField, $yearField, $monthField, $dayField, $hourField,
	$minuteField, $secondField, $dayOfWeekField, $dayOfYearField,
	$weekOfYearField, $pmField, $res1Field, $res2Field, $res3Field;
  export <LongDateField>, <LongDateField*>, <LongDateField**>,
	$shortDate, $longDate, $abbrevDate;
  export <DateForm>, <DateForm*>, <DateForm**>, $fatalDateTime,
	$longDateFound, $leftOverChars, $sepNotIntlSep, $fieldOrderNotIntl,
	$extraneousStrings, $tooManySeps, $sepNotConsistent, $tokenErr,
	$cantReadUtilities, $dateTimeNotFound, $dateTimeInvalid;
  export <StringToDateStatus>, <StringToDateStatus*>,
	<StringToDateStatus**>, <String2DateStatus>, <String2DateStatus*>,
	<String2DateStatus**>, hidden-array, hidden-array-setter,
	hidden-value, <DateCacheRecord>, <DateCacheRecord*>,
	<DateCacheRecord**>;
  export <DateCachePtr>, year-value, year-value-setter, month-value,
	month-value-setter, day-value, day-value-setter, hour-value,
	hour-value-setter, minute-value, minute-value-setter, second-value,
	second-value-setter, dayOfWeek-value, dayOfWeek-value-setter,
	<DateTimeRec>, <DateTimeRec*>, <DateTimeRec**>;
  export <LongDateTime>, <LongDateTime*>, <LongDateTime**>, c-value,
	c-value-setter, lHigh-value, lHigh-value-setter, lLow-value,
	lLow-value-setter, lHigh-value, lHigh-value-setter, lLow-value,
	lLow-value-setter, hl-value, <LongDateCvt>, <LongDateCvt*>,
	<LongDateCvt**>, era-value, era-value-setter, year-value,
	year-value-setter, month-value, month-value-setter, day-value,
	day-value-setter, hour-value, hour-value-setter, minute-value,
	minute-value-setter, second-value, second-value-setter,
	dayOfWeek-value, dayOfWeek-value-setter, dayOfYear-value,
	dayOfYear-value-setter, weekOfYear-value, weekOfYear-value-setter,
	pm-value, pm-value-setter, res1-value, res1-value-setter, res2-value,
	res2-value-setter, res3-value, res3-value-setter, era-value,
	era-value-setter, year-value, year-value-setter, month-value,
	month-value-setter, day-value, day-value-setter, hour-value,
	hour-value-setter, minute-value, minute-value-setter, second-value,
	second-value-setter, dayOfWeek-value, dayOfWeek-value-setter,
	dayOfYear-value, dayOfYear-value-setter, weekOfYear-value,
	weekOfYear-value-setter, pm-value, pm-value-setter, res1-value,
	res1-value-setter, res2-value, res2-value-setter, res3-value,
	res3-value-setter, ld-value, list-array, list-array-setter,
	list-value, eraAlt-value, eraAlt-value-setter, oldDate-value,
	oldDate-value-setter, eraAlt-value, eraAlt-value-setter,
	oldDate-value, oldDate-value-setter, od-value, <LongDateRec>,
	<LongDateRec*>, <LongDateRec**>;
  export <DateDelta>, <DateDelta*>, <DateDelta**>, togFlags-value,
	togFlags-value-setter, amChars-value, amChars-value-setter,
	pmChars-value, pmChars-value-setter, reserved-array,
	reserved-array-setter, reserved-value, <TogglePB>, <TogglePB*>,
	<TogglePB**>;
  export <ToggleResults>, <ToggleResults*>, <ToggleResults**>,
	InitDateCache, StringToDate, StringToTime, IUDateString,
	IUTimeString, IUDatePString, IUTimePString, IULDateString,
	IULTimeString;
  export LongDateToSeconds, LongSecondsToDate, ToggleDate, ValidDate,
	ReadDateTime, GetDateTime, SetDateTime, SetTime, GetTime,
	DateToSeconds, SecondsToDate;

  // from "TextCommon.h":
  export <TextEncodingBase>, <TextEncodingBase*>,
	<TextEncodingBase**>, $kTextEncodingMacRoman,
	$kTextEncodingMacJapanese, $kTextEncodingMacChineseTrad,
	$kTextEncodingMacKorean, $kTextEncodingMacArabic,
	$kTextEncodingMacHebrew, $kTextEncodingMacGreek,
	$kTextEncodingMacCyrillic, $kTextEncodingMacDevanagari,
	$kTextEncodingMacGurmukhi, $kTextEncodingMacGujarati,
	$kTextEncodingMacOriya, $kTextEncodingMacBengali,
	$kTextEncodingMacTamil, $kTextEncodingMacTelugu,
	$kTextEncodingMacKannada, $kTextEncodingMacMalayalam,
	$kTextEncodingMacSinhalese, $kTextEncodingMacBurmese,
	$kTextEncodingMacKhmer, $kTextEncodingMacThai,
	$kTextEncodingMacLaotian, $kTextEncodingMacGeorgian,
	$kTextEncodingMacArmenian, $kTextEncodingMacChineseSimp,
	$kTextEncodingMacTibetan, $kTextEncodingMacMongolian,
	$kTextEncodingMacEthiopic, $kTextEncodingMacCentralEurRoman,
	$kTextEncodingMacVietnamese, $kTextEncodingMacExtArabic,
	$kTextEncodingMacSymbol, $kTextEncodingMacDingbats,
	$kTextEncodingMacTurkish, $kTextEncodingMacCroatian,
	$kTextEncodingMacIcelandic, $kTextEncodingMacRomanian,
	$kTextEncodingMacCeltic, $kTextEncodingMacGaelic,
	$kTextEncodingMacUnicode, $kTextEncodingMacFarsi,
	$kTextEncodingMacUkrainian, $kTextEncodingMacInuit,
	$kTextEncodingMacVT100, $kTextEncodingMacHFS,
	$kTextEncodingUnicodeDefault, $kTextEncodingUnicodeV1-1,
	$kTextEncodingISO10646-1993, $kTextEncodingUnicodeV2-0,
	$kTextEncodingUnicodeV2-1, $kTextEncodingISOLatin1,
	$kTextEncodingISOLatin2, $kTextEncodingISOLatin3,
	$kTextEncodingISOLatin4, $kTextEncodingISOLatinCyrillic,
	$kTextEncodingISOLatinArabic, $kTextEncodingISOLatinGreek,
	$kTextEncodingISOLatinHebrew, $kTextEncodingISOLatin5,
	$kTextEncodingDOSLatinUS, $kTextEncodingDOSGreek,
	$kTextEncodingDOSBalticRim, $kTextEncodingDOSLatin1,
	$kTextEncodingDOSGreek1, $kTextEncodingDOSLatin2,
	$kTextEncodingDOSCyrillic, $kTextEncodingDOSTurkish,
	$kTextEncodingDOSPortuguese, $kTextEncodingDOSIcelandic,
	$kTextEncodingDOSHebrew, $kTextEncodingDOSCanadianFrench,
	$kTextEncodingDOSArabic, $kTextEncodingDOSNordic,
	$kTextEncodingDOSRussian, $kTextEncodingDOSGreek2,
	$kTextEncodingDOSThai, $kTextEncodingDOSJapanese,
	$kTextEncodingDOSChineseSimplif, $kTextEncodingDOSKorean,
	$kTextEncodingDOSChineseTrad, $kTextEncodingWindowsLatin1,
	$kTextEncodingWindowsANSI, $kTextEncodingWindowsLatin2,
	$kTextEncodingWindowsCyrillic, $kTextEncodingWindowsGreek,
	$kTextEncodingWindowsLatin5, $kTextEncodingWindowsHebrew,
	$kTextEncodingWindowsArabic, $kTextEncodingWindowsBalticRim,
	$kTextEncodingWindowsVietnamese, $kTextEncodingWindowsKoreanJohab,
	$kTextEncodingUS-ASCII, $kTextEncodingJIS-X0201-76,
	$kTextEncodingJIS-X0208-83, $kTextEncodingJIS-X0208-90,
	$kTextEncodingJIS-X0212-90, $kTextEncodingJIS-C6226-78,
	$kTextEncodingGB-2312-80, $kTextEncodingGBK-95,
	$kTextEncodingKSC-5601-87, $kTextEncodingKSC-5601-92-Johab,
	$kTextEncodingCNS-11643-92-P1, $kTextEncodingCNS-11643-92-P2,
	$kTextEncodingCNS-11643-92-P3, $kTextEncodingISO-2022-JP,
	$kTextEncodingISO-2022-JP-2, $kTextEncodingISO-2022-CN,
	$kTextEncodingISO-2022-CN-EXT, $kTextEncodingISO-2022-KR,
	$kTextEncodingEUC-JP, $kTextEncodingEUC-CN, $kTextEncodingEUC-TW,
	$kTextEncodingEUC-KR, $kTextEncodingShiftJIS, $kTextEncodingKOI8-R,
	$kTextEncodingBig5, $kTextEncodingMacRomanLatin1,
	$kTextEncodingHZ-GB-2312, $kTextEncodingNextStepLatin,
	$kTextEncodingEBCDIC-US, $kTextEncodingEBCDIC-CP037,
	$kTextEncodingMultiRun, $kTextEncodingMacTradChinese,
	$kTextEncodingMacRSymbol, $kTextEncodingMacSimpChinese,
	$kTextEncodingMacGeez, $kTextEncodingMacEastEurRoman,
	$kTextEncodingMacUninterp, <TextEncodingVariant>,
	<TextEncodingVariant*>, <TextEncodingVariant**>,
	$kTextEncodingDefaultVariant, $kMacRomanStandardVariant,
	$kMacRomanCurrencySignVariant, $kMacIcelandicStandardVariant,
	$kMacIcelandicTrueTypeVariant, $kMacJapaneseStandardVariant,
	$kMacJapaneseStdNoVerticalsVariant, $kMacJapaneseBasicVariant,
	$kMacJapanesePostScriptScrnVariant,
	$kMacJapanesePostScriptPrintVariant,
	$kMacJapaneseVertAtKuPlusTenVariant, $kMacArabicStandardVariant,
	$kMacArabicTrueTypeVariant, $kMacArabicThuluthVariant,
	$kMacArabicAlBayanVariant, $kMacFarsiStandardVariant,
	$kMacFarsiTrueTypeVariant, $kMacHebrewStandardVariant,
	$kMacHebrewFigureSpaceVariant, $kUnicodeNoSubset,
	$kUnicodeCanonicalDecompVariant, $kBig5-BasicVariant,
	$kBig5-StandardVariant, $kBig5-ETenVariant,
	$kUnicodeNoCompatibilityVariant, $kUnicodeNoComposedVariant,
	$kUnicodeNoCorporateVariant, $kJapaneseStandardVariant,
	$kJapaneseStdNoVerticalsVariant, $kJapaneseBasicVariant,
	$kJapanesePostScriptScrnVariant, $kJapanesePostScriptPrintVariant,
	$kJapaneseVertAtKuPlusTenVariant, $kHebrewStandardVariant,
	$kHebrewFigureSpaceVariant, $kUnicodeMaxDecomposedVariant,
	$kJapaneseNoOneByteKanaOption, $kJapaneseUseAsciiBackslashOption,
	<TextEncodingFormat>, <TextEncodingFormat*>, <TextEncodingFormat**>,
	$kTextEncodingDefaultFormat, $kUnicode16BitFormat,
	$kUnicodeUTF7Format, $kUnicodeUTF8Format, $kUnicode32BitFormat,
	<TextEncoding>, <TextEncoding*>, <TextEncoding**>,
	<TextEncodingNameSelector>, <TextEncodingNameSelector*>,
	<TextEncodingNameSelector**>, $kTextEncodingFullName,
	$kTextEncodingBaseName, $kTextEncodingVariantName,
	$kTextEncodingFormatName, offset-value, offset-value-setter,
	textEncoding-value, textEncoding-value-setter, <TextEncodingRun>,
	<TextEncodingRun*>, <TextEncodingRun**>, <TextEncodingRunPtr>;
  export <ConstTextEncodingRunPtr>, offset-value, offset-value-setter,
	script-value, script-value-setter, <ScriptCodeRun>, <ScriptCodeRun*>,
	<ScriptCodeRun**>, <ScriptCodeRunPtr>;
  export <ConstScriptCodeRunPtr>, <TextPtr>, <ConstTextPtr>,
	<UniCharArrayPtr>, <ConstUniCharArrayPtr>, $kTextScriptDontCare,
	$kTextLanguageDontCare, $kTextRegionDontCare;
  export format-value, format-value-setter, tecVersion-value,
	tecVersion-value-setter, tecTextConverterFeatures-value,
	tecTextConverterFeatures-value-setter,
	tecUnicodeConverterFeatures-value,
	tecUnicodeConverterFeatures-value-setter,
	tecTextCommonFeatures-value, tecTextCommonFeatures-value-setter,
	tecTextEncodingsFolderName-value,
	tecTextEncodingsFolderName-value-setter, tecExtensionFileName-value,
	tecExtensionFileName-value-setter, <TECInfo>, <TECInfo*>,
	<TECInfo**>, <TECInfoPtr>, <TECInfoHandle>, $kTECInfoCurrentFormat;
  export $kTECKeepInfoFixBit, $kTECFallbackTextLengthFixBit,
	$kTECTextRunBitClearFixBit, $kTECTextToUnicodeScanFixBit,
	$kTECAddForceASCIIChangesBit, $kTECPreferredEncodingFixBit;
  export $kTECKeepInfoFixMask, $kTECFallbackTextLengthFixMask,
	$kTECTextRunBitClearFixMask, $kTECTextToUnicodeScanFixMask,
	$kTECAddForceASCIIChangesMask, $kTECPreferredEncodingFixMask,
	CreateTextEncoding, GetTextEncodingBase, GetTextEncodingVariant,
	GetTextEncodingFormat, ResolveDefaultTextEncoding,
	GetTextEncodingName, TECGetInfo;
  export UpgradeScriptInfoToTextEncoding,
	RevertTextEncodingToScriptInfo;

  // from "QuickdrawText.h":
  export StandardGlyphs;
  export $leftCaret, $rightCaret, $kHilite, $smLeftCaret,
	$smRightCaret, $smHilite;
  export $onlyStyleRun, $leftStyleRun, $rightStyleRun,
	$middleStyleRun, $smOnlyStyleRun, $smLeftStyleRun, $smRightStyleRun,
	$smMiddleStyleRun, <JustStyleCode>, <JustStyleCode*>,
	<JustStyleCode**>, ascent-value, ascent-value-setter, descent-value,
	descent-value-setter, widMax-value, widMax-value-setter,
	leading-value, leading-value-setter, <FontInfo>, <FontInfo*>,
	<FontInfo**>;
  export <FormatOrderPtr>, offFirst-value, offFirst-value-setter,
	offSecond-value, offSecond-value-setter, <OffPair>, <OffPair*>,
	<OffPair**>;
  export <StyleRunDirectionProcPtr>, <StyleRunDirectionUPP>,
	$uppStyleRunDirectionProcInfo, Pixel2Char, Char2Pixel, PixelToChar,
	CharToPixel, DrawJustified, MeasureJustified, PortionLine,
	HiliteText, DrawJust, MeasureJust, PortionText, VisibleLength,
	GetFormatOrder;
  export TextFont, TextFace, TextMode, TextSize, SpaceExtra, DrawChar,
	DrawString, MacDrawText, CharWidth, StringWidth, TextWidth,
	MeasureText, GetFontInfo, CharExtra, StdText, StdTxMeas;

  // from "QDOffscreen.h":
  export $pixPurgeBit, $noNewDeviceBit, $useTempMemBit, $keepLocalBit,
	$pixelsPurgeableBit, $pixelsLockedBit, $mapPixBit, $newDepthBit,
	$alignPixBit, $newRowBytesBit, $reallocPixBit, $clipPixBit,
	$stretchPixBit, $ditherPixBit, $gwFlagErrBit;
  export $pixPurge, $noNewDevice, $useTempMem, $keepLocal,
	$pixelsPurgeable, $pixelsLocked, $kAllocDirectDrawSurface, $mapPix,
	$newDepth, $alignPix, $newRowBytes, $reallocPix, $clipPix,
	$stretchPix, $ditherPix, $gwFlagErr;
  export <GWorldFlags>, <GWorldFlags*>, <GWorldFlags**>, <GWorldPtr>,
	<GWorldPtr*>, <GWorldPtr**>, NewGWorld, LockPixels, UnlockPixels,
	UpdateGWorld, DisposeGWorld, GetGWorld, SetGWorld, CTabChanged,
	PixPatChanged, PortChanged, GDeviceChanged, AllowPurgePixels,
	NoPurgePixels, GetPixelsState, SetPixelsState, GetPixBaseAddr,
	GetPixRowBytes, NewScreenBuffer, DisposeScreenBuffer,
	GetGWorldDevice, QDDone, OffscreenVersion, NewTempScreenBuffer,
	PixMap32Bit, GetGWorldPixMap;

  // from "Quickdraw.h":
  export $invalColReq;
  export $srcCopy, $srcOr, $srcXor, $srcBic, $notSrcCopy, $notSrcOr,
	$notSrcXor, $notSrcBic, $patCopy, $patOr, $patXor, $patBic,
	$notPatCopy, $notPatOr, $notPatXor, $notPatBic, $grayishTextOr,
	$hilitetransfermode, $hilite, $blend, $addPin, $addOver, $subPin,
	$addMax, $adMax, $subOver, $adMin, $ditherCopy, $transparent;
  export $italicBit, $ulineBit, $outlineBit, $shadowBit, $condenseBit,
	$extendBit;
  export $normalBit, $inverseBit, $redBit, $greenBit, $blueBit,
	$cyanBit, $magentaBit, $yellowBit, $blackBit;
  export $blackColor, $whiteColor, $redColor, $greenColor, $blueColor,
	$cyanColor, $magentaColor, $yellowColor;
  export $picLParen, $picRParen, $clutType, $fixedType, $directType,
	$gdDevType;
  export $interlacedDevice, $roundedDevice, $hasAuxMenuBar,
	$burstDevice, $ext32Device, $ramInit, $mainScreen, $allInit,
	$screenDevice, $noDriver, $screenActive, $hiliteBit, $pHiliteBit,
	$defQDColors, $RGBDirect, $baseAddr32;
  export $sysPatListID, $iBeamCursor, $crossCursor, $plusCursor,
	$watchCursor;
  export $kQDGrafVerbFrame, $kQDGrafVerbPaint, $kQDGrafVerbErase,
	$kQDGrafVerbInvert, $kQDGrafVerbFill;
  export <GrafVerb>, <GrafVerb*>, <GrafVerb**>, $chunky,
	$chunkyPlanar, $planar;
  export <PixelType>, <PixelType*>, <PixelType**>, pat-array,
	pat-array-setter, pat-value, <Pattern>, <Pattern*>, <Pattern**>;
  export <ConstPatternParam>, <PatPtr>, <PatHandle>, <QDByte>,
	<QDByte*>, <QDByte**>, <QDPtr>, <QDHandle>, <QDErr>, <QDErr*>,
	<QDErr**>, $singleDevicesBit, $dontMatchSeedsBit, $allDevicesBit;
  export $singleDevices, $dontMatchSeeds, $allDevices;
  export <DeviceLoopFlags>, <DeviceLoopFlags*>, <DeviceLoopFlags**>;
  export <PrinterStatusOpcode>, <PrinterStatusOpcode*>,
	<PrinterStatusOpcode**>, $kPrinterFontStatus, $kPrinterScalingStatus;
  export oResult-value, oResult-value-setter, iFondID-value,
	iFondID-value-setter, iStyle-value, iStyle-value-setter,
	<PrinterFontStatus>, <PrinterFontStatus*>, <PrinterFontStatus**>,
	oScalingFactors-value, oScalingFactors-value-setter,
	<PrinterScalingStatus>, <PrinterScalingStatus*>,
	<PrinterScalingStatus**>, baseAddr-value, baseAddr-value-setter,
	rowBytes-value, rowBytes-value-setter, bounds-value,
	bounds-value-setter, <BitMap>, <BitMap*>, <BitMap**>, <BitMapPtr>,
	<BitMapHandle>, data-value, data-value-setter, mask-value,
	mask-value-setter, hotSpot-value, hotSpot-value-setter, <Cursor>,
	<Cursor*>, <Cursor**>;
  export <CursPtr>, <CursHandle>, pnLoc-value, pnLoc-value-setter,
	pnSize-value, pnSize-value-setter, pnMode-value, pnMode-value-setter,
	pnPat-value, pnPat-value-setter, <PenState>, <PenState*>,
	<PenState**>, rgnSize-value, rgnSize-value-setter, rgnBBox-value,
	rgnBBox-value-setter, <MacRegion>, <MacRegion*>, <MacRegion**>,
	<Region>, <Region*>, <Region**>;
  export <RgnPtr>, <RgnHandle>, picSize-value, picSize-value-setter,
	picFrame-value, picFrame-value-setter, <Picture>, <Picture*>,
	<Picture**>;
  export <PicPtr>, <PicHandle>, polySize-value, polySize-value-setter,
	polyBBox-value, polyBBox-value-setter, polyPoints-array,
	polyPoints-array-setter, polyPoints-value, <MacPolygon>,
	<MacPolygon*>, <MacPolygon**>, <Polygon>, <Polygon*>, <Polygon**>;
  export <PolyPtr>, <PolyHandle>, <QDTextProcPtr>, <QDLineProcPtr>,
	<QDRectProcPtr>, <QDRRectProcPtr>, <QDOvalProcPtr>, <QDArcProcPtr>,
	<QDPolyProcPtr>, <QDRgnProcPtr>, <QDBitsProcPtr>, <QDCommentProcPtr>,
	<QDTxMeasProcPtr>, <QDGetPicProcPtr>, <QDPutPicProcPtr>,
	<QDOpcodeProcPtr>, <QDStdGlyphsProcPtr>, <QDJShieldCursorProcPtr>,
	<QDTextUPP>, <QDLineUPP>, <QDRectUPP>, <QDRRectUPP>, <QDOvalUPP>,
	<QDArcUPP>, <QDPolyUPP>, <QDRgnUPP>, <QDBitsUPP>, <QDCommentUPP>,
	<QDTxMeasUPP>, <QDGetPicUPP>, <QDPutPicUPP>, <QDOpcodeUPP>,
	<QDStdGlyphsUPP>, <QDJShieldCursorUPP>, textProc-value,
	textProc-value-setter, lineProc-value, lineProc-value-setter,
	rectProc-value, rectProc-value-setter, rRectProc-value,
	rRectProc-value-setter, ovalProc-value, ovalProc-value-setter,
	arcProc-value, arcProc-value-setter, polyProc-value,
	polyProc-value-setter, rgnProc-value, rgnProc-value-setter,
	bitsProc-value, bitsProc-value-setter, commentProc-value,
	commentProc-value-setter, txMeasProc-value, txMeasProc-value-setter,
	getPicProc-value, getPicProc-value-setter, putPicProc-value,
	putPicProc-value-setter, <QDProcs>, <QDProcs*>, <QDProcs**>,
	<QDProcsPtr>, $uppQDTextProcInfo, $uppQDLineProcInfo,
	$uppQDRectProcInfo, $uppQDRRectProcInfo, $uppQDOvalProcInfo,
	$uppQDArcProcInfo, $uppQDPolyProcInfo, $uppQDRgnProcInfo,
	$uppQDBitsProcInfo, $uppQDCommentProcInfo, $uppQDTxMeasProcInfo,
	$uppQDGetPicProcInfo, $uppQDPutPicProcInfo, $uppQDOpcodeProcInfo,
	$uppQDStdGlyphsProcInfo, $uppQDJShieldCursorProcInfo, device-value,
	device-value-setter, portBits-value, portBits-value-setter,
	portRect-value, portRect-value-setter, visRgn-value,
	visRgn-value-setter, clipRgn-value, clipRgn-value-setter,
	bkPat-value, bkPat-value-setter, fillPat-value, fillPat-value-setter,
	pnLoc-value, pnLoc-value-setter, pnSize-value, pnSize-value-setter,
	pnMode-value, pnMode-value-setter, pnPat-value, pnPat-value-setter,
	pnVis-value, pnVis-value-setter, txFont-value, txFont-value-setter,
	txFace-value, txFace-value-setter, txMode-value, txMode-value-setter,
	txSize-value, txSize-value-setter, spExtra-value,
	spExtra-value-setter, fgColor-value, fgColor-value-setter,
	bkColor-value, bkColor-value-setter, colrBit-value,
	colrBit-value-setter, patStretch-value, patStretch-value-setter,
	picSave-value, picSave-value-setter, rgnSave-value,
	rgnSave-value-setter, polySave-value, polySave-value-setter,
	grafProcs-value, grafProcs-value-setter, <GrafPort>, <GrafPort*>,
	<GrafPort**>;
  export <GrafPtr>, <WindowPtr>, <WindowPtr*>, <WindowPtr**>,
	<DialogPtr>, <DialogPtr*>, <DialogPtr**>, <WindowRef>, <WindowRef*>,
	<WindowRef**>, <DragConstraint>, <DragConstraint*>,
	<DragConstraint**>, $kNoConstraint, $kVerticalConstraint,
	$kHorizontalConstraint;
  export <DragGrayRgnProcPtr>;
  export red-value, red-value-setter, green-value, green-value-setter,
	blue-value, blue-value-setter, <RGBColor>, <RGBColor*>, <RGBColor**>,
	<RGBColorPtr>, <RGBColorHdl>, <ColorSearchProcPtr>,
	<ColorComplementProcPtr>, <DragGrayRgnUPP>, <ColorSearchUPP>,
	<ColorComplementUPP>, $uppDragGrayRgnProcInfo,
	$uppColorSearchProcInfo, $uppColorComplementProcInfo, value-value,
	value-value-setter, rgb-value, rgb-value-setter, <ColorSpec>,
	<ColorSpec*>, <ColorSpec**>, <ColorSpecPtr>;
  export ctSeed-value, ctSeed-value-setter, ctFlags-value,
	ctFlags-value-setter, ctSize-value, ctSize-value-setter,
	ctTable-value, ctTable-value-setter, <ColorTable>, <ColorTable*>,
	<ColorTable**>;
  export <CTabPtr>, <CTabHandle>, value-value, value-value-setter,
	rgb-value, rgb-value-setter, xalpha-value, xalpha-value-setter,
	<xColorSpec>, <xColorSpec*>, <xColorSpec**>, <xColorSpecPtr>;
  export red-value, red-value-setter, green-value, green-value-setter,
	blue-value, blue-value-setter, matchData-value,
	matchData-value-setter, <MatchRec>, <MatchRec*>, <MatchRec**>,
	$OLDPIXMAPSTRUCT;
  export $k1MonochromePixelFormat, $k2IndexedPixelFormat,
	$k4IndexedPixelFormat, $k8IndexedPixelFormat, $k16BE555PixelFormat,
	$k24RGBPixelFormat, $k32ARGBPixelFormat, $k1IndexedGrayPixelFormat,
	$k2IndexedGrayPixelFormat, $k4IndexedGrayPixelFormat,
	$k8IndexedGrayPixelFormat;
  export $k16LE555PixelFormat, $k16BE565PixelFormat,
	$k16LE565PixelFormat, $k24BGRPixelFormat, $k32BGRAPixelFormat,
	$k32ABGRPixelFormat, $k32RGBAPixelFormat, $kYUVSPixelFormat,
	$kYUVUPixelFormat, $kYVU9PixelFormat, $kYUV411PixelFormat,
	$kYVYU422PixelFormat, $kUYVY422PixelFormat, $kYUV211PixelFormat;
  export extSize-value, extSize-value-setter, pmBits-value,
	pmBits-value-setter, pmGD-value, pmGD-value-setter, pmSeed-value,
	pmSeed-value-setter, reserved0-value, reserved0-value-setter,
	reserved1-value, reserved1-value-setter, reserved2-value,
	reserved2-value-setter, longRowBytes-value,
	longRowBytes-value-setter, <PixMapExtension>, <PixMapExtension*>,
	<PixMapExtension**>;
  export <PixMapExtPtr>, <PixMapExtHandle>;
  export baseAddr-value, baseAddr-value-setter, rowBytes-value,
	rowBytes-value-setter, bounds-value, bounds-value-setter,
	pmVersion-value, pmVersion-value-setter, packType-value,
	packType-value-setter, packSize-value, packSize-value-setter,
	hRes-value, hRes-value-setter, vRes-value, vRes-value-setter,
	pixelType-value, pixelType-value-setter, pixelSize-value,
	pixelSize-value-setter, cmpCount-value, cmpCount-value-setter,
	cmpSize-value, cmpSize-value-setter, pixelFormat-value,
	pixelFormat-value-setter, pmTable-value, pmTable-value-setter,
	pmExt-value, pmExt-value-setter, <PixMap>, <PixMap*>, <PixMap**>,
	<PixMapPtr>, <PixMapHandle>, patType-value, patType-value-setter,
	patMap-value, patMap-value-setter, patData-value,
	patData-value-setter, patXData-value, patXData-value-setter,
	patXValid-value, patXValid-value-setter, patXMap-value,
	patXMap-value-setter, pat1Data-value, pat1Data-value-setter,
	<PixPat>, <PixPat*>, <PixPat**>, <PixPatPtr>, <PixPatHandle>,
	crsrType-value, crsrType-value-setter, crsrMap-value,
	crsrMap-value-setter, crsrData-value, crsrData-value-setter,
	crsrXData-value, crsrXData-value-setter, crsrXValid-value,
	crsrXValid-value-setter, crsrXHandle-value, crsrXHandle-value-setter,
	crsr1Data-value, crsr1Data-value-setter, crsrMask-value,
	crsrMask-value-setter, crsrHotSpot-value, crsrHotSpot-value-setter,
	crsrXTable-value, crsrXTable-value-setter, crsrID-value,
	crsrID-value-setter, <CCrsr>, <CCrsr*>, <CCrsr**>, <CCrsrPtr>,
	<CCrsrHandle>;
  export gVersion-value, gVersion-value-setter, gType-value,
	gType-value-setter, gFormulaSize-value, gFormulaSize-value-setter,
	gChanCnt-value, gChanCnt-value-setter, gDataCnt-value,
	gDataCnt-value-setter, gDataWidth-value, gDataWidth-value-setter,
	gFormulaData-array, gFormulaData-array-setter, gFormulaData-value,
	<GammaTbl>, <GammaTbl*>, <GammaTbl**>, <GammaTblPtr>,
	<GammaTblHandle>, iTabSeed-value, iTabSeed-value-setter,
	iTabRes-value, iTabRes-value-setter, iTTable-array,
	iTTable-array-setter, iTTable-value, <ITab>, <ITab*>, <ITab**>,
	<ITabPtr>, <ITabHandle>, nxtSrch-value, nxtSrch-value-setter,
	srchProc-value, srchProc-value-setter, <SProcRec>, <SProcRec*>,
	<SProcRec**>;
  export <SProcPtr>, <SProcHndl>, nxtComp-value, nxtComp-value-setter,
	compProc-value, compProc-value-setter, <CProcRec>, <CProcRec*>,
	<CProcRec**>;
  export <CProcPtr>, <CProcHndl>, $OLDGDEVICESTRUCT, <GDevice*>,
	<GDevice**>, <GDPtr>, <GDHandle>, gdRefNum-value,
	gdRefNum-value-setter, gdID-value, gdID-value-setter, gdType-value,
	gdType-value-setter, gdITable-value, gdITable-value-setter,
	gdResPref-value, gdResPref-value-setter, gdSearchProc-value,
	gdSearchProc-value-setter, gdCompProc-value, gdCompProc-value-setter,
	gdFlags-value, gdFlags-value-setter, gdPMap-value,
	gdPMap-value-setter, gdRefCon-value, gdRefCon-value-setter,
	gdNextGD-value, gdNextGD-value-setter, gdRect-value,
	gdRect-value-setter, gdMode-value, gdMode-value-setter,
	gdCCBytes-value, gdCCBytes-value-setter, gdCCDepth-value,
	gdCCDepth-value-setter, gdCCXData-value, gdCCXData-value-setter,
	gdCCXMask-value, gdCCXMask-value-setter, gdExt-value,
	gdExt-value-setter, <GDevice>;
  export rgbOpColor-value, rgbOpColor-value-setter,
	rgbHiliteColor-value, rgbHiliteColor-value-setter, pmFgColor-value,
	pmFgColor-value-setter, pmFgIndex-value, pmFgIndex-value-setter,
	pmBkColor-value, pmBkColor-value-setter, pmBkIndex-value,
	pmBkIndex-value-setter, pmFlags-value, pmFlags-value-setter,
	<GrafVars>, <GrafVars*>, <GrafVars**>;
  export <GVarPtr>, <GVarHandle>;
  export <CGrafPort*>, <CGrafPort**>, <CGrafPtr>,
	<QDPrinterStatusProcPtr>, <QDPrinterStatusUPP>;
  export textProc-value, textProc-value-setter, lineProc-value,
	lineProc-value-setter, rectProc-value, rectProc-value-setter,
	rRectProc-value, rRectProc-value-setter, ovalProc-value,
	ovalProc-value-setter, arcProc-value, arcProc-value-setter,
	polyProc-value, polyProc-value-setter, rgnProc-value,
	rgnProc-value-setter, bitsProc-value, bitsProc-value-setter,
	commentProc-value, commentProc-value-setter, txMeasProc-value,
	txMeasProc-value-setter, getPicProc-value, getPicProc-value-setter,
	putPicProc-value, putPicProc-value-setter, opcodeProc-value,
	opcodeProc-value-setter, newProc1-value, newProc1-value-setter,
	glyphsProc-value, glyphsProc-value-setter, printerStatusProc-value,
	printerStatusProc-value-setter, newProc4-value,
	newProc4-value-setter, newProc5-value, newProc5-value-setter,
	newProc6-value, newProc6-value-setter, <CQDProcs>, <CQDProcs*>,
	<CQDProcs**>, <CQDProcsPtr>, device-value, device-value-setter,
	portPixMap-value, portPixMap-value-setter, portVersion-value,
	portVersion-value-setter, grafVars-value, grafVars-value-setter,
	chExtra-value, chExtra-value-setter, pnLocHFrac-value,
	pnLocHFrac-value-setter, portRect-value, portRect-value-setter,
	visRgn-value, visRgn-value-setter, clipRgn-value,
	clipRgn-value-setter, bkPixPat-value, bkPixPat-value-setter,
	rgbFgColor-value, rgbFgColor-value-setter, rgbBkColor-value,
	rgbBkColor-value-setter, pnLoc-value, pnLoc-value-setter,
	pnSize-value, pnSize-value-setter, pnMode-value, pnMode-value-setter,
	pnPixPat-value, pnPixPat-value-setter, fillPixPat-value,
	fillPixPat-value-setter, pnVis-value, pnVis-value-setter,
	txFont-value, txFont-value-setter, txFace-value, txFace-value-setter,
	txMode-value, txMode-value-setter, txSize-value, txSize-value-setter,
	spExtra-value, spExtra-value-setter, fgColor-value,
	fgColor-value-setter, bkColor-value, bkColor-value-setter,
	colrBit-value, colrBit-value-setter, patStretch-value,
	patStretch-value-setter, picSave-value, picSave-value-setter,
	rgnSave-value, rgnSave-value-setter, polySave-value,
	polySave-value-setter, grafProcs-value, grafProcs-value-setter,
	<CGrafPort>;
  export <CWindowPtr>, <CWindowPtr*>, <CWindowPtr**>, reqLSize-value,
	reqLSize-value-setter, reqLData-array, reqLData-array-setter,
	reqLData-value, <ReqListRec>, <ReqListRec*>, <ReqListRec**>,
	srcRect-value, srcRect-value-setter, hRes-value, hRes-value-setter,
	vRes-value, vRes-value-setter, version-value, version-value-setter,
	reserved1-value, reserved1-value-setter, reserved2-value,
	reserved2-value-setter, <OpenCPicParams>, <OpenCPicParams*>,
	<OpenCPicParams**>, $kCursorImageMajorVersion,
	$kCursorImageMinorVersion;
  export majorVersion-value, majorVersion-value-setter,
	minorVersion-value, minorVersion-value-setter, cursorPixMap-value,
	cursorPixMap-value-setter, cursorBitMask-value,
	cursorBitMask-value-setter, <CursorImageRec>, <CursorImageRec*>,
	<CursorImageRec**>;
  export <CursorImagePtr>, <DeviceLoopDrawingProcPtr>,
	<DeviceLoopDrawingUPP>, $uppDeviceLoopDrawingProcInfo,
	privates-array, privates-array-setter, privates-value,
	randSeed-value, randSeed-value-setter, screenBits-value,
	screenBits-value-setter, arrow-value, arrow-value-setter,
	dkGray-value, dkGray-value-setter, ltGray-value, ltGray-value-setter,
	gray-value, gray-value-setter, black-value, black-value-setter,
	white-value, white-value-setter, thePort-value, thePort-value-setter,
	<QDGlobals>, <QDGlobals*>, <QDGlobals**>, <QDGlobalsPtr>,
	<QDGlobalsHdl>;
  export InitGraf, OpenPort, InitPort, ClosePort;
  export SetPort, GetPort, GrafDevice, SetPortBits, PortSize,
	MovePortTo, SetOrigin, SetClip, GetClip, ClipRect, BackPat,
	InitCursor, SetCursor, HideCursor, ShowCursor, ObscureCursor,
	HidePen, ShowPen, GetPen, GetPenState, SetPenState, PenSize, PenMode,
	PenPat, PenNormal, MoveTo, Move, LineTo, Line, ForeColor, BackColor,
	ColorBit, SetRect, OffsetRect, InsetRect, SectRect, UnionRect,
	EqualRect, EmptyRect, FrameRect, PaintRect, EraseRect, InvertRect,
	FillRect, FrameOval, PaintOval, EraseOval, InvertOval, FillOval,
	FrameRoundRect, PaintRoundRect, EraseRoundRect, InvertRoundRect,
	FillRoundRect, FrameArc, PaintArc, EraseArc, InvertArc, FillArc,
	NewRgn, OpenRgn, CloseRgn, BitMapToRegion, DisposeRgn, CopyRgn,
	SetEmptyRgn, SetRectRgn, RectRgn, OffsetRgn, InsetRgn, SectRgn,
	UnionRgn, DiffRgn, XorRgn, RectInRgn, EqualRgn, EmptyRgn, FrameRgn,
	PaintRgn, EraseRgn, InvertRgn, FillRgn, ScrollRect, SeedFill,
	CalcMask, CopyMask, OpenPicture, PicComment, ClosePicture,
	DrawPicture, KillPicture, OpenPoly, ClosePoly, KillPoly, OffsetPoly,
	FramePoly, PaintPoly, ErasePoly, InvertPoly, FillPoly, SetPt,
	LocalToGlobal, GlobalToLocal, Random, StuffHex, GetPixel, ScalePt,
	MapPt, MapRect, MapRgn, MapPoly, SetStdProcs, StdRect, StdRRect,
	StdOval, StdArc, StdPoly, StdRgn, StdBits, StdComment, StdGetPic,
	StdPutPic, StdOpcode, AddPt, EqualPt, PtInRect, Pt2Rect, PtToAngle,
	SubPt, PtInRgn, StdLine, OpenCPort, InitCPort, CloseCPort, NewPixMap,
	DisposePixMap, CopyPixMap, NewPixPat, DisposePixPat, CopyPixPat,
	PenPixPat, BackPixPat, GetPixPat, MakeRGBPat, FillCRect, FillCOval,
	FillCRoundRect, FillCArc, FillCRgn, FillCPoly, RGBForeColor,
	RGBBackColor, SetCPixel, SetPortPix, GetCPixel, GetForeColor,
	GetBackColor, SeedCFill, CalcCMask, OpenCPicture, OpColor,
	HiliteColor, DisposeCTable, GetCTable, GetCCursor, SetCCursor,
	AllocCursor, DisposeCCursor, SetStdCProcs, GetMaxDevice, GetCTSeed,
	GetDeviceList, GetMainDevice, GetNextDevice, TestDeviceAttribute,
	SetDeviceAttribute, InitGDevice, NewGDevice, DisposeGDevice,
	SetGDevice, GetGDevice, Color2Index, Index2Color, InvertColor,
	RealColor, GetSubTable, MakeITable, AddSearch, AddComp, DelSearch,
	DelComp, SetClientID, ProtectEntry, ReserveEntry, SetEntries,
	SaveEntries, RestoreEntries, QDError, DeviceLoop;
  export GetMaskTable, GetPattern, GetCursor, GetPicture, DeltaPoint,
	ShieldCursor, ScreenRes, GetIndPattern;
  export PackBits, UnpackBits, SlopeFromAngle, AngleFromSlope;

  // from "Fonts.h":
  export $systemFont, $applFont, $kPlatformDefaultGuiFontID,
	$kFontIDNewYork, $kFontIDGeneva, $kFontIDMonaco, $kFontIDVenice,
	$kFontIDLondon, $kFontIDAthens, $kFontIDSanFrancisco,
	$kFontIDToronto, $kFontIDCairo, $kFontIDLosAngeles, $kFontIDTimes,
	$kFontIDHelvetica, $kFontIDCourier, $kFontIDSymbol, $kFontIDMobile;
  export $commandMark, $checkMark, $diamondMark, $appleMark;
  export $propFont, $prpFntH, $prpFntW, $prpFntHW, $fixedFont,
	$fxdFntH, $fxdFntW, $fxdFntHW, $fontWid;
  export family-value, family-value-setter, size-value,
	size-value-setter, face-value, face-value-setter, needBits-value,
	needBits-value-setter, device-value, device-value-setter,
	numer-value, numer-value-setter, denom-value, denom-value-setter,
	<FMInput>, <FMInput*>, <FMInput**>, errNum-value,
	errNum-value-setter, fontHandle-value, fontHandle-value-setter,
	boldPixels-value, boldPixels-value-setter, italicPixels-value,
	italicPixels-value-setter, ulOffset-value, ulOffset-value-setter,
	ulShadow-value, ulShadow-value-setter, ulThick-value,
	ulThick-value-setter, shadowPixels-value, shadowPixels-value-setter,
	extra-value, extra-value-setter, ascent-value, ascent-value-setter,
	descent-value, descent-value-setter, widMax-value,
	widMax-value-setter, leading-value, leading-value-setter,
	curStyle-value, curStyle-value-setter, numer-value,
	numer-value-setter, denom-value, denom-value-setter, <FMOutput>,
	<FMOutput*>, <FMOutput**>;
  export <FMOutPtr>, <FMOutputPtr>, fontType-value,
	fontType-value-setter, firstChar-value, firstChar-value-setter,
	lastChar-value, lastChar-value-setter, widMax-value,
	widMax-value-setter, kernMax-value, kernMax-value-setter,
	nDescent-value, nDescent-value-setter, fRectWidth-value,
	fRectWidth-value-setter, fRectHeight-value, fRectHeight-value-setter,
	owTLoc-value, owTLoc-value-setter, ascent-value, ascent-value-setter,
	descent-value, descent-value-setter, leading-value,
	leading-value-setter, rowWords-value, rowWords-value-setter,
	<FontRec>, <FontRec*>, <FontRec**>, <FontRecPtr>, <FontRecHdl>,
	ascent-value, ascent-value-setter, descent-value,
	descent-value-setter, leading-value, leading-value-setter,
	widMax-value, widMax-value-setter, wTabHandle-value,
	wTabHandle-value-setter, <FMetricRec>, <FMetricRec*>, <FMetricRec**>,
	<FMetricRecPtr>, <FMetricRecHandle>, widStyle-value,
	widStyle-value-setter, <WidEntry>, <WidEntry*>, <WidEntry**>,
	numWidths-value, numWidths-value-setter, <WidTable>, <WidTable*>,
	<WidTable**>, fontSize-value, fontSize-value-setter, fontStyle-value,
	fontStyle-value-setter, fontID-value, fontID-value-setter,
	<AsscEntry>, <AsscEntry*>, <AsscEntry**>, numAssoc-value,
	numAssoc-value-setter, <FontAssoc>, <FontAssoc*>, <FontAssoc**>,
	fontClass-value, fontClass-value-setter, offset-value,
	offset-value-setter, reserved-value, reserved-value-setter,
	indexes-array, indexes-array-setter, indexes-value, <StyleTable>,
	<StyleTable*>, <StyleTable**>, stringCount-value,
	stringCount-value-setter, baseFontName-value,
	baseFontName-value-setter, <NameTable>, <NameTable*>, <NameTable**>,
	kernFirst-value, kernFirst-value-setter, kernSecond-value,
	kernSecond-value-setter, kernWidth-value, kernWidth-value-setter,
	<KernPair>, <KernPair*>, <KernPair**>, kernStyle-value,
	kernStyle-value-setter, kernLength-value, kernLength-value-setter,
	<KernEntry>, <KernEntry*>, <KernEntry**>, numKerns-value,
	numKerns-value-setter, <KernTable>, <KernTable*>, <KernTable**>,
	tabData-array, tabData-array-setter, tabData-value, tabFont-value,
	tabFont-value-setter, sExtra-value, sExtra-value-setter, style-value,
	style-value-setter, fID-value, fID-value-setter, fSize-value,
	fSize-value-setter, face-value, face-value-setter, device-value,
	device-value-setter, inNumer-value, inNumer-value-setter,
	inDenom-value, inDenom-value-setter, aFID-value, aFID-value-setter,
	fHand-value, fHand-value-setter, usedFam-value, usedFam-value-setter,
	aFace-value, aFace-value-setter, vOutput-value, vOutput-value-setter,
	hOutput-value, hOutput-value-setter, vFactor-value,
	vFactor-value-setter, hFactor-value, hFactor-value-setter,
	aSize-value, aSize-value-setter, tabSize-value, tabSize-value-setter,
	<WidthTable>, <WidthTable*>, <WidthTable**>, <WidthTablePtr>,
	<WidthTableHdl>;
  export ffFlags-value, ffFlags-value-setter, ffFamID-value,
	ffFamID-value-setter, ffFirstChar-value, ffFirstChar-value-setter,
	ffLastChar-value, ffLastChar-value-setter, ffAscent-value,
	ffAscent-value-setter, ffDescent-value, ffDescent-value-setter,
	ffLeading-value, ffLeading-value-setter, ffWidMax-value,
	ffWidMax-value-setter, ffWTabOff-value, ffWTabOff-value-setter,
	ffKernOff-value, ffKernOff-value-setter, ffStylOff-value,
	ffStylOff-value-setter, ffProperty-array, ffProperty-array-setter,
	ffProperty-value, ffIntl-array, ffIntl-array-setter, ffIntl-value,
	ffVersion-value, ffVersion-value-setter, <FamRec>, <FamRec*>,
	<FamRec**>;
  export <FontPointSize>, <FontPointSize*>, <FontPointSize**>,
	<FontFamilyID>, <FontFamilyID*>, <FontFamilyID**>, InitFonts,
	GetFontName, GetFNum, RealFont, SetFontLock, FMSwapFont,
	SetFScaleDisable, FontMetrics, SetFractEnable, GetDefFontSize,
	IsOutline, SetOutlinePreferred, GetOutlinePreferred, OutlineMetrics,
	SetPreserveGlyph, GetPreserveGlyph, FlushFonts, GetSysFont,
	GetAppFont, SetAntiAliasedTextEnabled, IsAntiAliasedTextEnabled,
	QDTextBounds, FetchFontInfo;

  // from "Events.h":
  export <EventKind>, <EventKind*>, <EventKind**>, <EventMask>,
	<EventMask*>, <EventMask**>, $nullEvent, $mouseDown, $mouseUp,
	$keyDown, $keyUp, $autoKey, $updateEvt, $diskEvt, $activateEvt,
	$osEvt, $kHighLevelEvent;
  export $mDownMask, $mUpMask, $keyDownMask, $keyUpMask, $autoKeyMask,
	$updateMask, $diskMask, $activMask, $highLevelEventMask, $osMask,
	$everyEvent;
  export $charCodeMask, $keyCodeMask, $adbAddrMask, $osEvtMessageMask;
  export $mouseMovedMessage, $suspendResumeMessage;
  export $resumeFlag, $convertClipboardFlag;
  export <EventModifiers>, <EventModifiers*>, <EventModifiers**>,
	$activeFlagBit, $btnStateBit, $cmdKeyBit, $shiftKeyBit,
	$alphaLockBit, $optionKeyBit, $controlKeyBit, $rightShiftKeyBit,
	$rightOptionKeyBit, $rightControlKeyBit;
  export $activeFlag, $btnState, $cmdKey, $shiftKey, $alphaLock,
	$optionKey, $controlKey, $rightShiftKey, $rightOptionKey,
	$rightControlKey;
  export $kNullCharCode, $kHomeCharCode, $kEnterCharCode,
	$kEndCharCode, $kHelpCharCode, $kBellCharCode, $kBackspaceCharCode,
	$kTabCharCode, $kLineFeedCharCode, $kVerticalTabCharCode,
	$kPageUpCharCode, $kFormFeedCharCode, $kPageDownCharCode,
	$kReturnCharCode, $kFunctionKeyCharCode, $kEscapeCharCode,
	$kClearCharCode, $kLeftArrowCharCode, $kRightArrowCharCode,
	$kUpArrowCharCode, $kDownArrowCharCode, $kDeleteCharCode,
	$kNonBreakingSpaceCharCode;
  export what-value, what-value-setter, message-value,
	message-value-setter, when-value, when-value-setter, where-value,
	where-value-setter, modifiers-value, modifiers-value-setter,
	<EventRecord>, <EventRecord*>, <EventRecord**>;
  export <FKEYProcPtr>, <FKEYUPP>, $uppFKEYProcInfo, GetMouse, Button,
	StillDown, WaitMouseUp, TickCount, KeyTranslate, GetCaretTime;
  export GetKeys;
  export $networkEvt, $driverEvt, $app1Evt, $app2Evt, $app3Evt,
	$app4Evt, $networkMask, $driverMask, $app1Mask, $app2Mask, $app3Mask,
	$app4Mask;
  export qLink-value, qLink-value-setter, qType-value,
	qType-value-setter, evtQWhat-value, evtQWhat-value-setter,
	evtQMessage-value, evtQMessage-value-setter, evtQWhen-value,
	evtQWhen-value-setter, evtQWhere-value, evtQWhere-value-setter,
	evtQModifiers-value, evtQModifiers-value-setter, <EvQEl>, <EvQEl*>,
	<EvQEl**>, <EvQElPtr>, <GetNextEventFilterProcPtr>,
	<GetNextEventFilterUPP>, $uppGetNextEventFilterProcInfo,
	<GNEFilterUPP>, <GNEFilterUPP*>, <GNEFilterUPP**>, GetEvQHdr,
	GetDblTime, SetEventMask, PPostEvent, GetNextEvent, EventAvail;
  export PostEvent, OSEventAvail, GetOSEvent, FlushEvents,
	SystemClick, SystemTask, SystemEvent;

  // from "Notification.h":
  export <NMRec*>, <NMRec**>, <NMRecPtr>, <NMProcPtr>, <NMUPP>,
	qLink-value, qLink-value-setter, qType-value, qType-value-setter,
	nmFlags-value, nmFlags-value-setter, nmPrivate-value,
	nmPrivate-value-setter, nmMark-value, nmMark-value-setter,
	nmIcon-value, nmIcon-value-setter, nmSound-value,
	nmSound-value-setter, nmStr-value, nmStr-value-setter, nmResp-value,
	nmResp-value-setter, nmRefCon-value, nmRefCon-value-setter, <NMRec>,
	$uppNMProcInfo, NMInstall, NMRemove;

  // from "AEDataModel.h":
  export $typeBoolean, $typeChar, $typeSInt16, $typeSInt32,
	$typeUInt32, $typeSInt64, $typeIEEE32BitFloatingPoint,
	$typeIEEE64BitFloatingPoint, $type128BitFloatingPoint,
	$typeDecimalStruct, $typeSMInt, $typeShortInteger, $typeInteger,
	$typeLongInteger, $typeMagnitude, $typeComp, $typeSMFloat,
	$typeShortFloat, $typeFloat, $typeLongFloat, $typeExtended,
	$typeAEList, $typeAERecord, $typeAppleEvent, $typeEventRecord,
	$typeTrue, $typeFalse, $typeAlias, $typeEnumerated, $typeType,
	$typeAppParameters, $typeProperty, $typeFSS, $typeKeyword,
	$typeSectionH, $typeWildCard, $typeApplSignature, $typeQDRectangle,
	$typeFixed, $typeSessionID, $typeTargetID, $typeProcessSerialNumber,
	$typeKernelProcessID, $typeDispatcherID, $typeNull,
	$keyTransactionIDAttr, $keyReturnIDAttr, $keyEventClassAttr,
	$keyEventIDAttr, $keyAddressAttr, $keyOptionalKeywordAttr,
	$keyTimeoutAttr, $keyInteractLevelAttr, $keyEventSourceAttr,
	$keyMissedKeywordAttr, $keyOriginalAddressAttr;
  export $kAEDescListFactorNone, $kAEDescListFactorType,
	$kAEDescListFactorTypeAndSize, $kAutoGenerateReturnID,
	$kAnyTransactionID, <DescType>, <DescType*>, <DescType**>,
	<AEKeyword>, <AEKeyword*>, <AEKeyword**>, descriptorType-value,
	descriptorType-value-setter, dataHandle-value,
	dataHandle-value-setter, <AEDesc>, <AEDesc*>, <AEDesc**>,
	<AEDescPtr>, descKey-value, descKey-value-setter, descContent-value,
	descContent-value-setter, <AEKeyDesc>, <AEKeyDesc*>, <AEKeyDesc**>;
  export <AEDescList>, <AEDescList*>, <AEDescList**>, <AERecord>,
	<AERecord*>, <AERecord**>, <AEAddressDesc>, <AEAddressDesc*>,
	<AEAddressDesc**>, <AppleEvent>, <AppleEvent*>, <AppleEvent**>,
	<AppleEventPtr>, <AEReturnID>, <AEReturnID*>, <AEReturnID**>,
	<AETransactionID>, <AETransactionID*>, <AETransactionID**>,
	<AEEventClass>, <AEEventClass*>, <AEEventClass**>, <AEEventID>,
	<AEEventID*>, <AEEventID**>, <AEArrayType>, <AEArrayType*>,
	<AEArrayType**>, $kAEDataArray, $kAEPackedArray, $kAEDescArray,
	$kAEKeyDescArray;
  export $kAEHandleArray;
  export kAEDataArray-array, kAEDataArray-array-setter,
	kAEDataArray-value, kAEPackedArray-array,
	kAEPackedArray-array-setter, kAEPackedArray-value,
	kAEHandleArray-array, kAEHandleArray-array-setter,
	kAEHandleArray-value, kAEDescArray-array, kAEDescArray-array-setter,
	kAEDescArray-value, kAEKeyDescArray-array,
	kAEKeyDescArray-array-setter, kAEKeyDescArray-value, <AEArrayData>,
	<AEArrayData*>, <AEArrayData**>, <AEArrayDataPointer>,
	<AECoerceDescProcPtr>, <AECoercePtrProcPtr>, <AECoerceDescUPP>,
	<AECoercePtrUPP>, $uppAECoerceDescProcInfo, $uppAECoercePtrProcInfo,
	<AECoercionHandlerUPP>, <AECoercionHandlerUPP*>,
	<AECoercionHandlerUPP**>, AEInstallCoercionHandler,
	AERemoveCoercionHandler, AEGetCoercionHandler, AECoercePtr,
	AECoerceDesc;
  export AECreateDesc, AEDisposeDesc, AEDuplicateDesc;
  export AECreateList, AECountItems, AEPutPtr, AEPutDesc, AEGetNthPtr,
	AEGetNthDesc, AESizeOfNthItem, AEGetArray, AEPutArray, AEDeleteItem;
  export AECreateAppleEvent;
  export AEPutParamPtr, AEPutParamDesc, AEGetParamPtr, AEGetParamDesc,
	AESizeOfParam, AEDeleteParam;
  export AEGetAttributePtr, AEGetAttributeDesc, AESizeOfAttribute,
	AEPutAttributePtr, AEPutAttributeDesc;

  // from "AppleEvents.h":
  export $keyDirectObject, $keyErrorNumber, $keyErrorString,
	$keyProcessSerialNumber, $keyPreDispatch, $keySelectProc,
	$keyAERecorderCount, $keyAEVersion, $kCoreEventClass,
	$kAEOpenApplication, $kAEOpenDocuments, $kAEPrintDocuments,
	$kAEQuitApplication, $kAEAnswer, $kAEApplicationDied,
	$kAEStartRecording, $kAEStopRecording, $kAENotifyStartRecording,
	$kAENotifyStopRecording, $kAENotifyRecording;
  export <AESendOptions>, <AESendOptions*>, <AESendOptions**>,
	$kAENeverInteract, $kAECanInteract, $kAEAlwaysInteract,
	$kAECanSwitchLayer, $kAEDontRecord, $kAEDontExecute,
	$kAEProcessNonReplyEvents;
  export <AESendMode>, <AESendMode*>, <AESendMode**>, $kAENoReply,
	$kAEQueueReply, $kAEWaitReply, $kAEDontReconnect, $kAEWantReceipt;
  export $kAEDefaultTimeout, $kNoTimeOut;
  export <AESendPriority>, <AESendPriority*>, <AESendPriority**>,
	$kAENormalPriority, $kAEHighPriority;
  export <AEEventSource>, <AEEventSource*>, <AEEventSource**>,
	$kAEUnknownSource, $kAEDirectCall, $kAESameProcess, $kAELocalProcess,
	$kAERemoteProcess;
  export <AEEventHandlerProcPtr>, <AEIdleProcPtr>, <AEFilterProcPtr>,
	<AEEventHandlerUPP>, <AEIdleUPP>, <AEFilterUPP>,
	$uppAEEventHandlerProcInfo, $uppAEIdleProcInfo, $uppAEFilterProcInfo,
	AESend, AEProcessAppleEvent;
  export AEResetTimer;
  export <AEInteractAllowed>, <AEInteractAllowed*>,
	<AEInteractAllowed**>, $kAEInteractWithSelf, $kAEInteractWithLocal,
	$kAEInteractWithAll, AEGetInteractionAllowed,
	AESetInteractionAllowed, AEInteractWithUser;
  export AEInstallEventHandler, AERemoveEventHandler,
	AEGetEventHandler;
  export AESuspendTheCurrentEvent, $kAEDoNotIgnoreHandler,
	$kAEIgnoreAppPhacHandler, $kAEIgnoreAppEventHandler,
	$kAEIgnoreSysPhacHandler, $kAEIgnoreSysEventHandler,
	$kAEIngoreBuiltInEventHandler, $kAEDontDisposeOnResume,
	$kAENoDispatch, $kAEUseStandardDispatch, AEResumeTheCurrentEvent,
	AEGetTheCurrentEvent, AESetTheCurrentEvent;
  export AEInstallSpecialHandler, AERemoveSpecialHandler,
	AEGetSpecialHandler;
  export AEManagerInfo;

  // from "Finder.h":
  export $kClippingCreator, $kClippingPictureType, $kClippingTextType,
	$kClippingSoundType, $kClippingUnknownType;
  export $kInternetLocationCreator, $kInternetLocationHTTP,
	$kInternetLocationFTP, $kInternetLocationFile,
	$kInternetLocationMail, $kInternetLocationNNTP,
	$kInternetLocationAFP, $kInternetLocationAppleTalk,
	$kInternetLocationGeneric;
  export $kCustomIconResource, $kCustomBadgeResourceType,
	$kCustomBadgeResourceID, $kCustomBadgeResourceVersion;
  export version-value, version-value-setter,
	customBadgeResourceID-value, customBadgeResourceID-value-setter,
	customBadgeType-value, customBadgeType-value-setter,
	customBadgeCreator-value, customBadgeCreator-value-setter,
	windowBadgeType-value, windowBadgeType-value-setter,
	windowBadgeCreator-value, windowBadgeCreator-value-setter,
	overrideType-value, overrideType-value-setter, overrideCreator-value,
	overrideCreator-value-setter, <CustomBadgeResource>,
	<CustomBadgeResource*>, <CustomBadgeResource**>,
	<CustomBadgeResourcePtr>, <CustomBadgeResourceHandle>,
	$kRoutingResourceType, $kRoutingResourceID;
  export creator-value, creator-value-setter, fileType-value,
	fileType-value-setter, targetFolder-value, targetFolder-value-setter,
	destinationFolder-value, destinationFolder-value-setter,
	reserved-value, reserved-value-setter, <RoutingResourceEntry>,
	<RoutingResourceEntry*>, <RoutingResourceEntry**>;
  export <RoutingResourcePtr>, <RoutingResourceHandle>,
	$kContainerFolderAliasType, $kContainerTrashAliasType,
	$kContainerHardDiskAliasType, $kContainerFloppyAliasType,
	$kContainerServerAliasType, $kApplicationAliasType,
	$kContainerAliasType, $kDesktopPrinterAliasType,
	$kContainerCDROMAliasType, $kSystemFolderAliasType,
	$kAppleMenuFolderAliasType, $kStartupFolderAliasType,
	$kPrintMonitorDocsFolderAliasType, $kPreferencesFolderAliasType,
	$kControlPanelFolderAliasType, $kExtensionFolderAliasType,
	$kExportedFolderAliasType, $kDropFolderAliasType,
	$kSharedFolderAliasType, $kMountedFolderAliasType, $kIsOnDesk,
	$kColor, $kIsShared, $kHasNoINITs, $kHasBeenInited, $kHasCustomIcon,
	$kIsStationery, $kNameLocked, $kHasBundle, $kIsInvisible, $kIsAlias,
	$fOnDesk, $fHasBundle, $fInvisible, $fTrash, $fDesktop, $fDisk,
	$kExtendedFlagsAreInvalid, $kExtendedFlagHasCustomBadge,
	$kExtendedFlagHasRoutingInfo;
  export $kMagicBusyCreationDate;
  export fileType-value, fileType-value-setter, fileCreator-value,
	fileCreator-value-setter, finderFlags-value,
	finderFlags-value-setter, location-value, location-value-setter,
	reserved-value, reserved-value-setter, <FileInfo>, <FileInfo*>,
	<FileInfo**>, windowBounds-value, windowBounds-value-setter,
	finderFlags-value, finderFlags-value-setter, location-value,
	location-value-setter, reserved-value, reserved-value-setter,
	<FolderInfo>, <FolderInfo*>, <FolderInfo**>, reserved-array,
	reserved-array-setter, reserved-value, extendedFinderFlags-value,
	extendedFinderFlags-value-setter, reserved2-value,
	reserved2-value-setter, putAwayFolderID-value,
	putAwayFolderID-value-setter, <ExtendedFileInfo>,
	<ExtendedFileInfo*>, <ExtendedFileInfo**>, scrollPosition-value,
	scrollPosition-value-setter, reserved-value, reserved-value-setter,
	extendedFinderFlags-value, extendedFinderFlags-value-setter,
	reserved2-value, reserved2-value-setter, putAwayFolderID-value,
	putAwayFolderID-value-setter, <ExtendedFolderInfo>,
	<ExtendedFolderInfo*>, <ExtendedFolderInfo**>, fdType-value,
	fdType-value-setter, fdCreator-value, fdCreator-value-setter,
	fdFlags-value, fdFlags-value-setter, fdLocation-value,
	fdLocation-value-setter, fdFldr-value, fdFldr-value-setter, <FInfo>,
	<FInfo*>, <FInfo**>, fdIconID-value, fdIconID-value-setter,
	fdReserved-array, fdReserved-array-setter, fdReserved-value,
	fdScript-value, fdScript-value-setter, fdXFlags-value,
	fdXFlags-value-setter, fdComment-value, fdComment-value-setter,
	fdPutAway-value, fdPutAway-value-setter, <FXInfo>, <FXInfo*>,
	<FXInfo**>, frRect-value, frRect-value-setter, frFlags-value,
	frFlags-value-setter, frLocation-value, frLocation-value-setter,
	frView-value, frView-value-setter, <DInfo>, <DInfo*>, <DInfo**>,
	frScroll-value, frScroll-value-setter, frOpenChain-value,
	frOpenChain-value-setter, frScript-value, frScript-value-setter,
	frXFlags-value, frXFlags-value-setter, frComment-value,
	frComment-value-setter, frPutAway-value, frPutAway-value-setter,
	<DXInfo>, <DXInfo*>, <DXInfo**>, $initDev, $hitDev, $closeDev,
	$nulDev, $updateDev, $activDev, $deactivDev, $keyEvtDev, $macDev,
	$undoDev, $cutDev, $copyDev, $pasteDev, $clearDev, $cursorDev;
  export $cdevGenErr, $cdevMemErr, $cdevResErr, $cdevUnset,
	<ControlPanelDefProcPtr>, <ControlPanelDefUPP>,
	$uppControlPanelDefProcInfo;

  // from "Files.h":
  export $fsCurPerm, $fsRdPerm, $fsWrPerm, $fsRdWrPerm, $fsRdWrShPerm,
	$fsRdDenyPerm, $fsWrDenyPerm;
  export $ioDirFlg, $ioDirMask;
  export $fsRtParID, $fsRtDirID;
  export $fsAtMark, $fsFromStart, $fsFromLEOF, $fsFromMark;
  export $pleaseCacheBit, $pleaseCacheMask, $noCacheBit, $noCacheMask,
	$rdVerifyBit, $rdVerifyMask, $rdVerify, $newLineBit, $newLineMask,
	$newLineCharMask;
  export $fsSBPartialName, $fsSBFullName, $fsSBFlAttrib,
	$fsSBFlFndrInfo, $fsSBFlLgLen, $fsSBFlPyLen, $fsSBFlRLgLen,
	$fsSBFlRPyLen, $fsSBFlCrDat, $fsSBFlMdDat, $fsSBFlBkDat,
	$fsSBFlXFndrInfo, $fsSBFlParID, $fsSBNegate, $fsSBDrUsrWds,
	$fsSBDrNmFls, $fsSBDrCrDat, $fsSBDrMdDat, $fsSBDrBkDat,
	$fsSBDrFndrInfo, $fsSBDrParID;
  export $fsSBPartialNameBit, $fsSBFullNameBit, $fsSBFlAttribBit,
	$fsSBFlFndrInfoBit, $fsSBFlLgLenBit, $fsSBFlPyLenBit,
	$fsSBFlRLgLenBit, $fsSBFlRPyLenBit, $fsSBFlCrDatBit, $fsSBFlMdDatBit,
	$fsSBFlBkDatBit, $fsSBFlXFndrInfoBit, $fsSBFlParIDBit,
	$fsSBNegateBit, $fsSBDrUsrWdsBit, $fsSBDrNmFlsBit, $fsSBDrCrDatBit,
	$fsSBDrMdDatBit, $fsSBDrBkDatBit, $fsSBDrFndrInfoBit,
	$fsSBDrParIDBit;
  export $bLimitFCBs, $bLocalWList, $bNoMiniFndr, $bNoVNEdit,
	$bNoLclSync, $bTrshOffLine, $bNoSwitchTo, $bNoDeskItems,
	$bNoBootBlks, $bAccessCntl, $bNoSysDir, $bHasExtFSVol, $bHasOpenDeny,
	$bHasCopyFile, $bHasMoveRename, $bHasDesktopMgr, $bHasShortName,
	$bHasFolderLock, $bHasPersonalAccessPrivileges, $bHasUserGroupList,
	$bHasCatSearch, $bHasFileIDs, $bHasBTreeMgr,
	$bHasBlankAccessPrivileges, $bSupportsAsyncRequests,
	$bSupportsTrashVolumeCache;
  export $kLargeIcon, $kLarge4BitIcon, $kLarge8BitIcon, $kSmallIcon,
	$kSmall4BitIcon, $kSmall8BitIcon;
  export $kLargeIconSize, $kLarge4BitIconSize, $kLarge8BitIconSize,
	$kSmallIconSize, $kSmall4BitIconSize, $kSmall8BitIconSize;
  export $fsUnixPriv;
  export $kNoUserAuthentication, $kPassword, $kEncryptPassword,
	$kTwoWayEncryptPassword;
  export $kOwnerID2Name, $kGroupID2Name, $kOwnerName2ID,
	$kGroupName2ID, $kReturnNextUser, $kReturnNextGroup, $kReturnNextUG;
  export $kfullPrivileges, $kownerPrivileges, $knoUser,
	$kadministratorUser;
  export $knoGroup;
  export vMVersion-value, vMVersion-value-setter, vMAttrib-value,
	vMAttrib-value-setter, vMLocalHand-value, vMLocalHand-value-setter,
	vMServerAdr-value, vMServerAdr-value-setter, vMVolumeGrade-value,
	vMVolumeGrade-value-setter, vMForeignPrivID-value,
	vMForeignPrivID-value-setter, <GetVolParmsInfoBuffer>,
	<GetVolParmsInfoBuffer*>, <GetVolParmsInfoBuffer**>,
	<ParamBlockRec*>, <ParamBlockRec**>;
  export <ParmBlkPtr>, <IOCompletionProcPtr>, <IOCompletionUPP>,
	qLink-value, qLink-value-setter, qType-value, qType-value-setter,
	ioTrap-value, ioTrap-value-setter, ioCmdAddr-value,
	ioCmdAddr-value-setter, ioCompletion-value,
	ioCompletion-value-setter, ioResult-value, ioResult-value-setter,
	ioNamePtr-value, ioNamePtr-value-setter, ioVRefNum-value,
	ioVRefNum-value-setter, ioRefNum-value, ioRefNum-value-setter,
	ioVersNum-value, ioVersNum-value-setter, ioPermssn-value,
	ioPermssn-value-setter, ioMisc-value, ioMisc-value-setter,
	ioBuffer-value, ioBuffer-value-setter, ioReqCount-value,
	ioReqCount-value-setter, ioActCount-value, ioActCount-value-setter,
	ioPosMode-value, ioPosMode-value-setter, ioPosOffset-value,
	ioPosOffset-value-setter, <IOParam>, <IOParam*>, <IOParam**>,
	<IOParamPtr>, qLink-value, qLink-value-setter, qType-value,
	qType-value-setter, ioTrap-value, ioTrap-value-setter,
	ioCmdAddr-value, ioCmdAddr-value-setter, ioCompletion-value,
	ioCompletion-value-setter, ioResult-value, ioResult-value-setter,
	ioNamePtr-value, ioNamePtr-value-setter, ioVRefNum-value,
	ioVRefNum-value-setter, ioFRefNum-value, ioFRefNum-value-setter,
	ioFVersNum-value, ioFVersNum-value-setter, filler1-value,
	filler1-value-setter, ioFDirIndex-value, ioFDirIndex-value-setter,
	ioFlAttrib-value, ioFlAttrib-value-setter, ioFlVersNum-value,
	ioFlVersNum-value-setter, ioFlFndrInfo-value,
	ioFlFndrInfo-value-setter, ioFlNum-value, ioFlNum-value-setter,
	ioFlStBlk-value, ioFlStBlk-value-setter, ioFlLgLen-value,
	ioFlLgLen-value-setter, ioFlPyLen-value, ioFlPyLen-value-setter,
	ioFlRStBlk-value, ioFlRStBlk-value-setter, ioFlRLgLen-value,
	ioFlRLgLen-value-setter, ioFlRPyLen-value, ioFlRPyLen-value-setter,
	ioFlCrDat-value, ioFlCrDat-value-setter, ioFlMdDat-value,
	ioFlMdDat-value-setter, <FileParam>, <FileParam*>, <FileParam**>,
	<FileParamPtr>, qLink-value, qLink-value-setter, qType-value,
	qType-value-setter, ioTrap-value, ioTrap-value-setter,
	ioCmdAddr-value, ioCmdAddr-value-setter, ioCompletion-value,
	ioCompletion-value-setter, ioResult-value, ioResult-value-setter,
	ioNamePtr-value, ioNamePtr-value-setter, ioVRefNum-value,
	ioVRefNum-value-setter, filler2-value, filler2-value-setter,
	ioVolIndex-value, ioVolIndex-value-setter, ioVCrDate-value,
	ioVCrDate-value-setter, ioVLsBkUp-value, ioVLsBkUp-value-setter,
	ioVAtrb-value, ioVAtrb-value-setter, ioVNmFls-value,
	ioVNmFls-value-setter, ioVDirSt-value, ioVDirSt-value-setter,
	ioVBlLn-value, ioVBlLn-value-setter, ioVNmAlBlks-value,
	ioVNmAlBlks-value-setter, ioVAlBlkSiz-value,
	ioVAlBlkSiz-value-setter, ioVClpSiz-value, ioVClpSiz-value-setter,
	ioAlBlSt-value, ioAlBlSt-value-setter, ioVNxtFNum-value,
	ioVNxtFNum-value-setter, ioVFrBlk-value, ioVFrBlk-value-setter,
	<VolumeParam>, <VolumeParam*>, <VolumeParam**>, <VolumeParamPtr>,
	qLink-value, qLink-value-setter, qType-value, qType-value-setter,
	ioTrap-value, ioTrap-value-setter, ioCmdAddr-value,
	ioCmdAddr-value-setter, ioCompletion-value,
	ioCompletion-value-setter, ioResult-value, ioResult-value-setter,
	ioNamePtr-value, ioNamePtr-value-setter, ioVRefNum-value,
	ioVRefNum-value-setter, ioCRefNum-value, ioCRefNum-value-setter,
	csCode-value, csCode-value-setter, csParam-array,
	csParam-array-setter, csParam-value, <CntrlParam>, <CntrlParam*>,
	<CntrlParam**>, <CntrlParamPtr>, qLink-value, qLink-value-setter,
	qType-value, qType-value-setter, ioTrap-value, ioTrap-value-setter,
	ioCmdAddr-value, ioCmdAddr-value-setter, ioCompletion-value,
	ioCompletion-value-setter, ioResult-value, ioResult-value-setter,
	ioNamePtr-value, ioNamePtr-value-setter, ioVRefNum-value,
	ioVRefNum-value-setter, ioSRefNum-value, ioSRefNum-value-setter,
	ioSVersNum-value, ioSVersNum-value-setter, ioSPermssn-value,
	ioSPermssn-value-setter, ioSMix-value, ioSMix-value-setter,
	ioSFlags-value, ioSFlags-value-setter, ioSlot-value,
	ioSlot-value-setter, ioID-value, ioID-value-setter, <SlotDevParam>,
	<SlotDevParam*>, <SlotDevParam**>, <SlotDevParamPtr>, qLink-value,
	qLink-value-setter, qType-value, qType-value-setter, ioTrap-value,
	ioTrap-value-setter, ioCmdAddr-value, ioCmdAddr-value-setter,
	ioCompletion-value, ioCompletion-value-setter, ioResult-value,
	ioResult-value-setter, ioNamePtr-value, ioNamePtr-value-setter,
	ioVRefNum-value, ioVRefNum-value-setter, ioMRefNum-value,
	ioMRefNum-value-setter, ioMVersNum-value, ioMVersNum-value-setter,
	ioMPermssn-value, ioMPermssn-value-setter, ioMMix-value,
	ioMMix-value-setter, ioMFlags-value, ioMFlags-value-setter,
	ioSEBlkPtr-value, ioSEBlkPtr-value-setter, <MultiDevParam>,
	<MultiDevParam*>, <MultiDevParam**>, <MultiDevParamPtr>,
	ioParam-value, ioParam-value-setter, fileParam-value,
	fileParam-value-setter, volumeParam-value, volumeParam-value-setter,
	cntrlParam-value, cntrlParam-value-setter, slotDevParam-value,
	slotDevParam-value-setter, multiDevParam-value,
	multiDevParam-value-setter, <ParamBlockRec>;
  export qLink-value, qLink-value-setter, qType-value,
	qType-value-setter, ioTrap-value, ioTrap-value-setter,
	ioCmdAddr-value, ioCmdAddr-value-setter, ioCompletion-value,
	ioCompletion-value-setter, ioResult-value, ioResult-value-setter,
	ioNamePtr-value, ioNamePtr-value-setter, ioVRefNum-value,
	ioVRefNum-value-setter, ioFRefNum-value, ioFRefNum-value-setter,
	ioFVersNum-value, ioFVersNum-value-setter, filler1-value,
	filler1-value-setter, ioFDirIndex-value, ioFDirIndex-value-setter,
	ioFlAttrib-value, ioFlAttrib-value-setter, ioACUser-value,
	ioACUser-value-setter, ioFlFndrInfo-value, ioFlFndrInfo-value-setter,
	ioDirID-value, ioDirID-value-setter, ioFlStBlk-value,
	ioFlStBlk-value-setter, ioFlLgLen-value, ioFlLgLen-value-setter,
	ioFlPyLen-value, ioFlPyLen-value-setter, ioFlRStBlk-value,
	ioFlRStBlk-value-setter, ioFlRLgLen-value, ioFlRLgLen-value-setter,
	ioFlRPyLen-value, ioFlRPyLen-value-setter, ioFlCrDat-value,
	ioFlCrDat-value-setter, ioFlMdDat-value, ioFlMdDat-value-setter,
	ioFlBkDat-value, ioFlBkDat-value-setter, ioFlXFndrInfo-value,
	ioFlXFndrInfo-value-setter, ioFlParID-value, ioFlParID-value-setter,
	ioFlClpSiz-value, ioFlClpSiz-value-setter, <HFileInfo>, <HFileInfo*>,
	<HFileInfo**>, qLink-value, qLink-value-setter, qType-value,
	qType-value-setter, ioTrap-value, ioTrap-value-setter,
	ioCmdAddr-value, ioCmdAddr-value-setter, ioCompletion-value,
	ioCompletion-value-setter, ioResult-value, ioResult-value-setter,
	ioNamePtr-value, ioNamePtr-value-setter, ioVRefNum-value,
	ioVRefNum-value-setter, ioFRefNum-value, ioFRefNum-value-setter,
	ioFVersNum-value, ioFVersNum-value-setter, filler1-value,
	filler1-value-setter, ioFDirIndex-value, ioFDirIndex-value-setter,
	ioFlAttrib-value, ioFlAttrib-value-setter, ioACUser-value,
	ioACUser-value-setter, ioDrUsrWds-value, ioDrUsrWds-value-setter,
	ioDrDirID-value, ioDrDirID-value-setter, ioDrNmFls-value,
	ioDrNmFls-value-setter, filler3-array, filler3-array-setter,
	filler3-value, ioDrCrDat-value, ioDrCrDat-value-setter,
	ioDrMdDat-value, ioDrMdDat-value-setter, ioDrBkDat-value,
	ioDrBkDat-value-setter, ioDrFndrInfo-value,
	ioDrFndrInfo-value-setter, ioDrParID-value, ioDrParID-value-setter,
	<DirInfo>, <DirInfo*>, <DirInfo**>, hFileInfo-value,
	hFileInfo-value-setter, dirInfo-value, dirInfo-value-setter,
	<CInfoPBRec>, <CInfoPBRec*>, <CInfoPBRec**>;
  export <CInfoPBPtr>, qLink-value, qLink-value-setter, qType-value,
	qType-value-setter, ioTrap-value, ioTrap-value-setter,
	ioCmdAddr-value, ioCmdAddr-value-setter, ioCompletion-value,
	ioCompletion-value-setter, ioResult-value, ioResult-value-setter,
	ioNamePtr-value, ioNamePtr-value-setter, ioVRefNum-value,
	ioVRefNum-value-setter, filler1-value, filler1-value-setter,
	ioShortNamePtr-value, ioShortNamePtr-value-setter, filler2-value,
	filler2-value-setter, ioPDType-value, ioPDType-value-setter,
	ioPDAuxType-value, ioPDAuxType-value-setter, filler3-array,
	filler3-array-setter, filler3-value, ioDirID-value,
	ioDirID-value-setter, <XCInfoPBRec>, <XCInfoPBRec*>, <XCInfoPBRec**>;
  export <XCInfoPBPtr>, initialize-value, initialize-value-setter,
	priv-array, priv-array-setter, priv-value, <CatPositionRec>,
	<CatPositionRec*>, <CatPositionRec**>, vRefNum-value,
	vRefNum-value-setter, parID-value, parID-value-setter, name-value,
	name-value-setter, <FSSpec>, <FSSpec*>, <FSSpec**>, <FSSpecPtr>,
	<FSSpecHandle>, <FSSpecArrayPtr>, <FSSpecArrayPtr*>,
	<FSSpecArrayPtr**>;
  export <ConstFSSpecPtr>, <VolumeType>, <VolumeType*>,
	<VolumeType**>, $AppleShareMediaType, length-value,
	length-value-setter, media-value, media-value-setter,
	<VolMountInfoHeader>, <VolMountInfoHeader*>, <VolMountInfoHeader**>;
  export <VolMountInfoPtr>, length-value, length-value-setter,
	media-value, media-value-setter, flags-value, flags-value-setter,
	<VolumeMountInfoHeader>, <VolumeMountInfoHeader*>,
	<VolumeMountInfoHeader**>, <VolumeMountInfoHeaderPtr>,
	$volMountNoLoginMsgFlagBit, $volMountNoLoginMsgFlagMask,
	$volMountExtendedFlagsBit, $volMountExtendedFlagsMask,
	$volMountInteractBit, $volMountInteractMask, $volMountChangedBit,
	$volMountChangedMask, $volMountFSReservedMask,
	$volMountSysReservedMask;
  export length-value, length-value-setter, media-value,
	media-value-setter, flags-value, flags-value-setter,
	nbpInterval-value, nbpInterval-value-setter, nbpCount-value,
	nbpCount-value-setter, uamType-value, uamType-value-setter,
	zoneNameOffset-value, zoneNameOffset-value-setter,
	serverNameOffset-value, serverNameOffset-value-setter,
	volNameOffset-value, volNameOffset-value-setter,
	userNameOffset-value, userNameOffset-value-setter,
	userPasswordOffset-value, userPasswordOffset-value-setter,
	volPasswordOffset-value, volPasswordOffset-value-setter,
	AFPData-array, AFPData-array-setter, AFPData-value,
	<AFPVolMountInfo>, <AFPVolMountInfo*>, <AFPVolMountInfo**>,
	<AFPVolMountInfoPtr>;
  export length-value, length-value-setter, media-value,
	media-value-setter, flags-value, flags-value-setter,
	nbpInterval-value, nbpInterval-value-setter, nbpCount-value,
	nbpCount-value-setter, uamType-value, uamType-value-setter,
	zoneNameOffset-value, zoneNameOffset-value-setter,
	serverNameOffset-value, serverNameOffset-value-setter,
	volNameOffset-value, volNameOffset-value-setter,
	userNameOffset-value, userNameOffset-value-setter,
	userPasswordOffset-value, userPasswordOffset-value-setter,
	volPasswordOffset-value, volPasswordOffset-value-setter,
	extendedFlags-value, extendedFlags-value-setter, uamNameOffset-value,
	uamNameOffset-value-setter, alternateAddressOffset-value,
	alternateAddressOffset-value-setter, AFPData-array,
	AFPData-array-setter, AFPData-value, <AFPXVolMountInfo>,
	<AFPXVolMountInfo*>, <AFPXVolMountInfo**>, <AFPXVolMountInfoPtr>,
	$kAFPExtendedFlagsAlternateAddressMask;
  export $kAFPTagTypeIP, $kAFPTagTypeIPPort, $kAFPTagTypeDDP;
  export $kAFPTagLengthIP, $kAFPTagLengthIPPort, $kAFPTagLengthDDP;
  export fLength-value, fLength-value-setter, fType-value,
	fType-value-setter, fData-array, fData-array-setter, fData-value,
	<AFPTagData>, <AFPTagData*>, <AFPTagData**>, fAddressCount-value,
	fAddressCount-value-setter, fAddressList-array,
	fAddressList-array-setter, fAddressList-value, <AFPAlternateAddress>,
	<AFPAlternateAddress*>, <AFPAlternateAddress**>;
  export qLink-value, qLink-value-setter, qType-value,
	qType-value-setter, ioTrap-value, ioTrap-value-setter,
	ioCmdAddr-value, ioCmdAddr-value-setter, ioCompletion-value,
	ioCompletion-value-setter, ioResult-value, ioResult-value-setter,
	ioNamePtr-value, ioNamePtr-value-setter, ioVRefNum-value,
	ioVRefNum-value-setter, ioDTRefNum-value, ioDTRefNum-value-setter,
	ioIndex-value, ioIndex-value-setter, ioTagInfo-value,
	ioTagInfo-value-setter, ioDTBuffer-value, ioDTBuffer-value-setter,
	ioDTReqCount-value, ioDTReqCount-value-setter, ioDTActCount-value,
	ioDTActCount-value-setter, ioFiller1-value, ioFiller1-value-setter,
	ioIconType-value, ioIconType-value-setter, ioFiller2-value,
	ioFiller2-value-setter, ioDirID-value, ioDirID-value-setter,
	ioFileCreator-value, ioFileCreator-value-setter, ioFileType-value,
	ioFileType-value-setter, ioFiller3-value, ioFiller3-value-setter,
	ioDTLgLen-value, ioDTLgLen-value-setter, ioDTPyLen-value,
	ioDTPyLen-value-setter, ioFiller4-array, ioFiller4-array-setter,
	ioFiller4-value, ioAPPLParID-value, ioAPPLParID-value-setter,
	<DTPBRec>, <DTPBRec*>, <DTPBRec**>;
  export <DTPBPtr>, qLink-value, qLink-value-setter, qType-value,
	qType-value-setter, ioTrap-value, ioTrap-value-setter,
	ioCmdAddr-value, ioCmdAddr-value-setter, ioCompletion-value,
	ioCompletion-value-setter, ioResult-value, ioResult-value-setter,
	ioNamePtr-value, ioNamePtr-value-setter, ioVRefNum-value,
	ioVRefNum-value-setter, ioRefNum-value, ioRefNum-value-setter,
	ioVersNum-value, ioVersNum-value-setter, ioPermssn-value,
	ioPermssn-value-setter, ioMisc-value, ioMisc-value-setter,
	ioBuffer-value, ioBuffer-value-setter, ioReqCount-value,
	ioReqCount-value-setter, ioActCount-value, ioActCount-value-setter,
	ioPosMode-value, ioPosMode-value-setter, ioPosOffset-value,
	ioPosOffset-value-setter, <HIOParam>, <HIOParam*>, <HIOParam**>,
	<HIOParamPtr>, qLink-value, qLink-value-setter, qType-value,
	qType-value-setter, ioTrap-value, ioTrap-value-setter,
	ioCmdAddr-value, ioCmdAddr-value-setter, ioCompletion-value,
	ioCompletion-value-setter, ioResult-value, ioResult-value-setter,
	ioNamePtr-value, ioNamePtr-value-setter, ioVRefNum-value,
	ioVRefNum-value-setter, ioFRefNum-value, ioFRefNum-value-setter,
	ioFVersNum-value, ioFVersNum-value-setter, filler1-value,
	filler1-value-setter, ioFDirIndex-value, ioFDirIndex-value-setter,
	ioFlAttrib-value, ioFlAttrib-value-setter, ioFlVersNum-value,
	ioFlVersNum-value-setter, ioFlFndrInfo-value,
	ioFlFndrInfo-value-setter, ioDirID-value, ioDirID-value-setter,
	ioFlStBlk-value, ioFlStBlk-value-setter, ioFlLgLen-value,
	ioFlLgLen-value-setter, ioFlPyLen-value, ioFlPyLen-value-setter,
	ioFlRStBlk-value, ioFlRStBlk-value-setter, ioFlRLgLen-value,
	ioFlRLgLen-value-setter, ioFlRPyLen-value, ioFlRPyLen-value-setter,
	ioFlCrDat-value, ioFlCrDat-value-setter, ioFlMdDat-value,
	ioFlMdDat-value-setter, <HFileParam>, <HFileParam*>, <HFileParam**>,
	<HFileParamPtr>, qLink-value, qLink-value-setter, qType-value,
	qType-value-setter, ioTrap-value, ioTrap-value-setter,
	ioCmdAddr-value, ioCmdAddr-value-setter, ioCompletion-value,
	ioCompletion-value-setter, ioResult-value, ioResult-value-setter,
	ioNamePtr-value, ioNamePtr-value-setter, ioVRefNum-value,
	ioVRefNum-value-setter, filler2-value, filler2-value-setter,
	ioVolIndex-value, ioVolIndex-value-setter, ioVCrDate-value,
	ioVCrDate-value-setter, ioVLsMod-value, ioVLsMod-value-setter,
	ioVAtrb-value, ioVAtrb-value-setter, ioVNmFls-value,
	ioVNmFls-value-setter, ioVBitMap-value, ioVBitMap-value-setter,
	ioAllocPtr-value, ioAllocPtr-value-setter, ioVNmAlBlks-value,
	ioVNmAlBlks-value-setter, ioVAlBlkSiz-value,
	ioVAlBlkSiz-value-setter, ioVClpSiz-value, ioVClpSiz-value-setter,
	ioAlBlSt-value, ioAlBlSt-value-setter, ioVNxtCNID-value,
	ioVNxtCNID-value-setter, ioVFrBlk-value, ioVFrBlk-value-setter,
	ioVSigWord-value, ioVSigWord-value-setter, ioVDrvInfo-value,
	ioVDrvInfo-value-setter, ioVDRefNum-value, ioVDRefNum-value-setter,
	ioVFSID-value, ioVFSID-value-setter, ioVBkUp-value,
	ioVBkUp-value-setter, ioVSeqNum-value, ioVSeqNum-value-setter,
	ioVWrCnt-value, ioVWrCnt-value-setter, ioVFilCnt-value,
	ioVFilCnt-value-setter, ioVDirCnt-value, ioVDirCnt-value-setter,
	ioVFndrInfo-array, ioVFndrInfo-array-setter, ioVFndrInfo-value,
	<HVolumeParam>, <HVolumeParam*>, <HVolumeParam**>, <HVolumeParamPtr>,
	$kWidePosOffsetBit, $kUseWidePositioning, $kMaximumBlocksIn4GB;
  export qLink-value, qLink-value-setter, qType-value,
	qType-value-setter, ioTrap-value, ioTrap-value-setter,
	ioCmdAddr-value, ioCmdAddr-value-setter, ioCompletion-value,
	ioCompletion-value-setter, ioResult-value, ioResult-value-setter,
	ioNamePtr-value, ioNamePtr-value-setter, ioVRefNum-value,
	ioVRefNum-value-setter, ioRefNum-value, ioRefNum-value-setter,
	ioVersNum-value, ioVersNum-value-setter, ioPermssn-value,
	ioPermssn-value-setter, ioMisc-value, ioMisc-value-setter,
	ioBuffer-value, ioBuffer-value-setter, ioReqCount-value,
	ioReqCount-value-setter, ioActCount-value, ioActCount-value-setter,
	ioPosMode-value, ioPosMode-value-setter, ioWPosOffset-value,
	ioWPosOffset-value-setter, <XIOParam>, <XIOParam*>, <XIOParam**>,
	<XIOParamPtr>, qLink-value, qLink-value-setter, qType-value,
	qType-value-setter, ioTrap-value, ioTrap-value-setter,
	ioCmdAddr-value, ioCmdAddr-value-setter, ioCompletion-value,
	ioCompletion-value-setter, ioResult-value, ioResult-value-setter,
	ioNamePtr-value, ioNamePtr-value-setter, ioVRefNum-value,
	ioVRefNum-value-setter, ioXVersion-value, ioXVersion-value-setter,
	ioVolIndex-value, ioVolIndex-value-setter, ioVCrDate-value,
	ioVCrDate-value-setter, ioVLsMod-value, ioVLsMod-value-setter,
	ioVAtrb-value, ioVAtrb-value-setter, ioVNmFls-value,
	ioVNmFls-value-setter, ioVBitMap-value, ioVBitMap-value-setter,
	ioAllocPtr-value, ioAllocPtr-value-setter, ioVNmAlBlks-value,
	ioVNmAlBlks-value-setter, ioVAlBlkSiz-value,
	ioVAlBlkSiz-value-setter, ioVClpSiz-value, ioVClpSiz-value-setter,
	ioAlBlSt-value, ioAlBlSt-value-setter, ioVNxtCNID-value,
	ioVNxtCNID-value-setter, ioVFrBlk-value, ioVFrBlk-value-setter,
	ioVSigWord-value, ioVSigWord-value-setter, ioVDrvInfo-value,
	ioVDrvInfo-value-setter, ioVDRefNum-value, ioVDRefNum-value-setter,
	ioVFSID-value, ioVFSID-value-setter, ioVBkUp-value,
	ioVBkUp-value-setter, ioVSeqNum-value, ioVSeqNum-value-setter,
	ioVWrCnt-value, ioVWrCnt-value-setter, ioVFilCnt-value,
	ioVFilCnt-value-setter, ioVDirCnt-value, ioVDirCnt-value-setter,
	ioVFndrInfo-array, ioVFndrInfo-array-setter, ioVFndrInfo-value,
	ioVTotalBytes-value, ioVTotalBytes-value-setter, ioVFreeBytes-value,
	ioVFreeBytes-value-setter, <XVolumeParam>, <XVolumeParam*>,
	<XVolumeParam**>, <XVolumeParamPtr>, qLink-value, qLink-value-setter,
	qType-value, qType-value-setter, ioTrap-value, ioTrap-value-setter,
	ioCmdAddr-value, ioCmdAddr-value-setter, ioCompletion-value,
	ioCompletion-value-setter, ioResult-value, ioResult-value-setter,
	ioNamePtr-value, ioNamePtr-value-setter, ioVRefNum-value,
	ioVRefNum-value-setter, filler3-value, filler3-value-setter,
	ioDenyModes-value, ioDenyModes-value-setter, filler4-value,
	filler4-value-setter, filler5-value, filler5-value-setter,
	ioACUser-value, ioACUser-value-setter, filler6-value,
	filler6-value-setter, ioACOwnerID-value, ioACOwnerID-value-setter,
	ioACGroupID-value, ioACGroupID-value-setter, ioACAccess-value,
	ioACAccess-value-setter, ioDirID-value, ioDirID-value-setter,
	<AccessParam>, <AccessParam*>, <AccessParam**>, <AccessParamPtr>,
	qLink-value, qLink-value-setter, qType-value, qType-value-setter,
	ioTrap-value, ioTrap-value-setter, ioCmdAddr-value,
	ioCmdAddr-value-setter, ioCompletion-value,
	ioCompletion-value-setter, ioResult-value, ioResult-value-setter,
	ioNamePtr-value, ioNamePtr-value-setter, ioVRefNum-value,
	ioVRefNum-value-setter, filler7-value, filler7-value-setter,
	ioObjType-value, ioObjType-value-setter, ioObjNamePtr-value,
	ioObjNamePtr-value-setter, ioObjID-value, ioObjID-value-setter,
	<ObjParam>, <ObjParam*>, <ObjParam**>, <ObjParamPtr>, qLink-value,
	qLink-value-setter, qType-value, qType-value-setter, ioTrap-value,
	ioTrap-value-setter, ioCmdAddr-value, ioCmdAddr-value-setter,
	ioCompletion-value, ioCompletion-value-setter, ioResult-value,
	ioResult-value-setter, ioNamePtr-value, ioNamePtr-value-setter,
	ioVRefNum-value, ioVRefNum-value-setter, ioDstVRefNum-value,
	ioDstVRefNum-value-setter, filler8-value, filler8-value-setter,
	ioNewName-value, ioNewName-value-setter, ioCopyName-value,
	ioCopyName-value-setter, ioNewDirID-value, ioNewDirID-value-setter,
	filler14-value, filler14-value-setter, filler15-value,
	filler15-value-setter, ioDirID-value, ioDirID-value-setter,
	<CopyParam>, <CopyParam*>, <CopyParam**>, <CopyParamPtr>,
	qLink-value, qLink-value-setter, qType-value, qType-value-setter,
	ioTrap-value, ioTrap-value-setter, ioCmdAddr-value,
	ioCmdAddr-value-setter, ioCompletion-value,
	ioCompletion-value-setter, ioResult-value, ioResult-value-setter,
	ioNamePtr-value, ioNamePtr-value-setter, ioVRefNum-value,
	ioVRefNum-value-setter, filler9-value, filler9-value-setter,
	ioWDIndex-value, ioWDIndex-value-setter, ioWDProcID-value,
	ioWDProcID-value-setter, ioWDVRefNum-value, ioWDVRefNum-value-setter,
	filler10-value, filler10-value-setter, filler11-value,
	filler11-value-setter, filler12-value, filler12-value-setter,
	filler13-value, filler13-value-setter, ioWDDirID-value,
	ioWDDirID-value-setter, <WDParam>, <WDParam*>, <WDParam**>,
	<WDParamPtr>, qLink-value, qLink-value-setter, qType-value,
	qType-value-setter, ioTrap-value, ioTrap-value-setter,
	ioCmdAddr-value, ioCmdAddr-value-setter, ioCompletion-value,
	ioCompletion-value-setter, ioResult-value, ioResult-value-setter,
	ioNamePtr-value, ioNamePtr-value-setter, ioVRefNum-value,
	ioVRefNum-value-setter, filler14-value, filler14-value-setter,
	ioDestNamePtr-value, ioDestNamePtr-value-setter, filler15-value,
	filler15-value-setter, ioDestDirID-value, ioDestDirID-value-setter,
	filler16-value, filler16-value-setter, filler17-value,
	filler17-value-setter, ioSrcDirID-value, ioSrcDirID-value-setter,
	filler18-value, filler18-value-setter, ioFileID-value,
	ioFileID-value-setter, <FIDParam>, <FIDParam*>, <FIDParam**>,
	<FIDParamPtr>, qLink-value, qLink-value-setter, qType-value,
	qType-value-setter, ioTrap-value, ioTrap-value-setter,
	ioCmdAddr-value, ioCmdAddr-value-setter, ioCompletion-value,
	ioCompletion-value-setter, ioResult-value, ioResult-value-setter,
	ioNamePtr-value, ioNamePtr-value-setter, ioVRefNum-value,
	ioVRefNum-value-setter, ioFiller21-value, ioFiller21-value-setter,
	ioFiller22-value, ioFiller22-value-setter, ioForeignPrivBuffer-value,
	ioForeignPrivBuffer-value-setter, ioForeignPrivActCount-value,
	ioForeignPrivActCount-value-setter, ioForeignPrivReqCount-value,
	ioForeignPrivReqCount-value-setter, ioFiller23-value,
	ioFiller23-value-setter, ioForeignPrivDirID-value,
	ioForeignPrivDirID-value-setter, ioForeignPrivInfo1-value,
	ioForeignPrivInfo1-value-setter, ioForeignPrivInfo2-value,
	ioForeignPrivInfo2-value-setter, ioForeignPrivInfo3-value,
	ioForeignPrivInfo3-value-setter, ioForeignPrivInfo4-value,
	ioForeignPrivInfo4-value-setter, <ForeignPrivParam>,
	<ForeignPrivParam*>, <ForeignPrivParam**>, <ForeignPrivParamPtr>,
	qLink-value, qLink-value-setter, qType-value, qType-value-setter,
	ioTrap-value, ioTrap-value-setter, ioCmdAddr-value,
	ioCmdAddr-value-setter, ioCompletion-value,
	ioCompletion-value-setter, ioResult-value, ioResult-value-setter,
	ioNamePtr-value, ioNamePtr-value-setter, ioVRefNum-value,
	ioVRefNum-value-setter, ioMatchPtr-value, ioMatchPtr-value-setter,
	ioReqMatchCount-value, ioReqMatchCount-value-setter,
	ioActMatchCount-value, ioActMatchCount-value-setter,
	ioSearchBits-value, ioSearchBits-value-setter, ioSearchInfo1-value,
	ioSearchInfo1-value-setter, ioSearchInfo2-value,
	ioSearchInfo2-value-setter, ioSearchTime-value,
	ioSearchTime-value-setter, ioCatPosition-value,
	ioCatPosition-value-setter, ioOptBuffer-value,
	ioOptBuffer-value-setter, ioOptBufSize-value,
	ioOptBufSize-value-setter, <CSParam>, <CSParam*>, <CSParam**>,
	<CSParamPtr>;
  export ioParam-value, ioParam-value-setter, fileParam-value,
	fileParam-value-setter, volumeParam-value, volumeParam-value-setter,
	accessParam-value, accessParam-value-setter, objParam-value,
	objParam-value-setter, copyParam-value, copyParam-value-setter,
	wdParam-value, wdParam-value-setter, fidParam-value,
	fidParam-value-setter, csParam-value, csParam-value-setter,
	foreignPrivParam-value, foreignPrivParam-value-setter,
	<HParamBlockRec>, <HParamBlockRec*>, <HParamBlockRec**>;
  export <HParmBlkPtr>;
  export qLink-value, qLink-value-setter, qType-value,
	qType-value-setter, ioTrap-value, ioTrap-value-setter,
	ioCmdAddr-value, ioCmdAddr-value-setter, ioCompletion-value,
	ioCompletion-value-setter, ioResult-value, ioResult-value-setter,
	ioNamePtr-value, ioNamePtr-value-setter, ioVRefNum-value,
	ioVRefNum-value-setter, filler1-value, filler1-value-setter,
	ioNewName-value, ioNewName-value-setter, filler2-value,
	filler2-value-setter, ioNewDirID-value, ioNewDirID-value-setter,
	filler3-array, filler3-array-setter, filler3-value, ioDirID-value,
	ioDirID-value-setter, <CMovePBRec>, <CMovePBRec*>, <CMovePBRec**>;
  export <CMovePBPtr>, qLink-value, qLink-value-setter, qType-value,
	qType-value-setter, ioTrap-value, ioTrap-value-setter,
	ioCmdAddr-value, ioCmdAddr-value-setter, ioCompletion-value,
	ioCompletion-value-setter, ioResult-value, ioResult-value-setter,
	ioNamePtr-value, ioNamePtr-value-setter, ioVRefNum-value,
	ioVRefNum-value-setter, filler1-value, filler1-value-setter,
	ioWDIndex-value, ioWDIndex-value-setter, ioWDProcID-value,
	ioWDProcID-value-setter, ioWDVRefNum-value, ioWDVRefNum-value-setter,
	filler2-array, filler2-array-setter, filler2-value, ioWDDirID-value,
	ioWDDirID-value-setter, <WDPBRec>, <WDPBRec*>, <WDPBRec**>;
  export <WDPBPtr>, qLink-value, qLink-value-setter, qType-value,
	qType-value-setter, ioTrap-value, ioTrap-value-setter,
	ioCmdAddr-value, ioCmdAddr-value-setter, ioCompletion-value,
	ioCompletion-value-setter, ioResult-value, ioResult-value-setter,
	ioNamePtr-value, ioNamePtr-value-setter, ioVRefNum-value,
	ioVRefNum-value-setter, ioRefNum-value, ioRefNum-value-setter,
	filler-value, filler-value-setter, ioFCBIndx-value,
	ioFCBIndx-value-setter, filler1-value, filler1-value-setter,
	ioFCBFlNm-value, ioFCBFlNm-value-setter, ioFCBFlags-value,
	ioFCBFlags-value-setter, ioFCBStBlk-value, ioFCBStBlk-value-setter,
	ioFCBEOF-value, ioFCBEOF-value-setter, ioFCBPLen-value,
	ioFCBPLen-value-setter, ioFCBCrPs-value, ioFCBCrPs-value-setter,
	ioFCBVRefNum-value, ioFCBVRefNum-value-setter, ioFCBClpSiz-value,
	ioFCBClpSiz-value-setter, ioFCBParID-value, ioFCBParID-value-setter,
	<FCBPBRec>, <FCBPBRec*>, <FCBPBRec**>;
  export <FCBPBPtr>, qLink-value, qLink-value-setter, qType-value,
	qType-value-setter, vcbFlags-value, vcbFlags-value-setter,
	vcbSigWord-value, vcbSigWord-value-setter, vcbCrDate-value,
	vcbCrDate-value-setter, vcbLsMod-value, vcbLsMod-value-setter,
	vcbAtrb-value, vcbAtrb-value-setter, vcbNmFls-value,
	vcbNmFls-value-setter, vcbVBMSt-value, vcbVBMSt-value-setter,
	vcbAllocPtr-value, vcbAllocPtr-value-setter, vcbNmAlBlks-value,
	vcbNmAlBlks-value-setter, vcbAlBlkSiz-value,
	vcbAlBlkSiz-value-setter, vcbClpSiz-value, vcbClpSiz-value-setter,
	vcbAlBlSt-value, vcbAlBlSt-value-setter, vcbNxtCNID-value,
	vcbNxtCNID-value-setter, vcbFreeBks-value, vcbFreeBks-value-setter,
	vcbVN-value, vcbVN-value-setter, vcbDrvNum-value,
	vcbDrvNum-value-setter, vcbDRefNum-value, vcbDRefNum-value-setter,
	vcbFSID-value, vcbFSID-value-setter, vcbVRefNum-value,
	vcbVRefNum-value-setter, vcbMAdr-value, vcbMAdr-value-setter,
	vcbBufAdr-value, vcbBufAdr-value-setter, vcbMLen-value,
	vcbMLen-value-setter, vcbDirIndex-value, vcbDirIndex-value-setter,
	vcbDirBlk-value, vcbDirBlk-value-setter, vcbVolBkUp-value,
	vcbVolBkUp-value-setter, vcbVSeqNum-value, vcbVSeqNum-value-setter,
	vcbWrCnt-value, vcbWrCnt-value-setter, vcbXTClpSiz-value,
	vcbXTClpSiz-value-setter, vcbCTClpSiz-value,
	vcbCTClpSiz-value-setter, vcbNmRtDirs-value,
	vcbNmRtDirs-value-setter, vcbFilCnt-value, vcbFilCnt-value-setter,
	vcbDirCnt-value, vcbDirCnt-value-setter, vcbFndrInfo-array,
	vcbFndrInfo-array-setter, vcbFndrInfo-value, vcbVCSize-value,
	vcbVCSize-value-setter, vcbVBMCSiz-value, vcbVBMCSiz-value-setter,
	vcbCtlCSiz-value, vcbCtlCSiz-value-setter, vcbXTAlBlks-value,
	vcbXTAlBlks-value-setter, vcbCTAlBlks-value,
	vcbCTAlBlks-value-setter, vcbXTRef-value, vcbXTRef-value-setter,
	vcbCTRef-value, vcbCTRef-value-setter, vcbCtlBuf-value,
	vcbCtlBuf-value-setter, vcbDirIDM-value, vcbDirIDM-value-setter,
	vcbOffsM-value, vcbOffsM-value-setter, <VCB>, <VCB*>, <VCB**>,
	<VCBPtr>, qLink-value, qLink-value-setter, qType-value,
	qType-value-setter, dQDrive-value, dQDrive-value-setter,
	dQRefNum-value, dQRefNum-value-setter, dQFSID-value,
	dQFSID-value-setter, dQDrvSz-value, dQDrvSz-value-setter,
	dQDrvSz2-value, dQDrvSz2-value-setter, <DrvQEl>, <DrvQEl*>,
	<DrvQEl**>, <DrvQElPtr>, $uppIOCompletionProcInfo, PBGetVInfoSync,
	PBGetVInfoAsync, PBXGetVolInfoSync, PBXGetVolInfoAsync, PBGetVolSync,
	PBGetVolAsync, PBSetVolSync, PBSetVolAsync, PBFlushVolSync,
	PBFlushVolAsync, PBHTrashVolumeCachesSync, PBCreateSync,
	PBCreateAsync, PBDeleteSync, PBDeleteAsync, PBOpenDFSync,
	PBOpenDFAsync, PBOpenRFSync, PBOpenRFAsync, PBRenameSync,
	PBRenameAsync, PBGetFInfoSync, PBGetFInfoAsync, PBSetFInfoSync,
	PBSetFInfoAsync, PBSetFLockSync, PBSetFLockAsync, PBRstFLockSync,
	PBRstFLockAsync, PBSetFVersSync, PBSetFVersAsync, PBAllocateSync,
	PBAllocateAsync, PBGetEOFSync, PBGetEOFAsync, PBSetEOFSync,
	PBSetEOFAsync, PBGetFPosSync, PBGetFPosAsync, PBSetFPosSync,
	PBSetFPosAsync, PBFlushFileSync, PBFlushFileAsync, PBMountVol,
	PBUnmountVol, PBUnmountVolImmed, PBEject, PBOffLine, PBCatSearchSync,
	PBCatSearchAsync, SetVol, UnmountVol, Eject, FlushVol, HSetVol,
	FSOpen, OpenDF, FSClose, FSRead, FSWrite, GetVInfo, GetFInfo, GetVol,
	Create, FSDelete, OpenRF, Rename, SetFInfo, SetFLock, RstFLock,
	Allocate, GetEOF, SetEOF, GetFPos, SetFPos, GetVRefNum, PBOpenWDSync,
	PBOpenWDAsync, PBCloseWDSync, PBCloseWDAsync, PBHSetVolSync,
	PBHSetVolAsync, PBHGetVolSync, PBHGetVolAsync, PBCatMoveSync,
	PBCatMoveAsync, PBDirCreateSync, PBDirCreateAsync, PBGetWDInfoSync,
	PBGetWDInfoAsync, PBGetFCBInfoSync, PBGetFCBInfoAsync,
	PBGetCatInfoSync, PBGetCatInfoAsync, PBSetCatInfoSync,
	PBSetCatInfoAsync, PBAllocContigSync, PBAllocContigAsync,
	PBLockRangeSync, PBLockRangeAsync, PBUnlockRangeSync,
	PBUnlockRangeAsync, PBSetVInfoSync, PBSetVInfoAsync, PBHGetVInfoSync,
	PBHGetVInfoAsync, PBHOpenSync, PBHOpenAsync, PBHOpenRFSync,
	PBHOpenRFAsync, PBHOpenDFSync, PBHOpenDFAsync, PBHCreateSync,
	PBHCreateAsync, PBHDeleteSync, PBHDeleteAsync, PBHRenameSync,
	PBHRenameAsync, PBHRstFLockSync, PBHRstFLockAsync, PBHSetFLockSync,
	PBHSetFLockAsync, PBHGetFInfoSync, PBHGetFInfoAsync, PBHSetFInfoSync,
	PBHSetFInfoAsync, PBMakeFSSpecSync, PBMakeFSSpecAsync, FInitQueue;
  export GetFSQHdr, GetVCBQHdr, HGetVol, HOpen, HOpenDF, HOpenRF,
	AllocContig, HCreate, DirCreate, HDelete, HGetFInfo, HSetFInfo,
	HSetFLock, HRstFLock, HRename, CatMove, OpenWD, CloseWD, GetWDInfo,
	PBHGetVolParmsSync, PBHGetVolParmsAsync, PBHGetLogInInfoSync,
	PBHGetLogInInfoAsync, PBHGetDirAccessSync, PBHGetDirAccessAsync,
	PBHSetDirAccessSync, PBHSetDirAccessAsync, PBHMapIDSync,
	PBHMapIDAsync, PBHMapNameSync, PBHMapNameAsync, PBHCopyFileSync,
	PBHCopyFileAsync, PBHMoveRenameSync, PBHMoveRenameAsync,
	PBHOpenDenySync, PBHOpenDenyAsync, PBHOpenRFDenySync,
	PBHOpenRFDenyAsync, PBGetXCatInfoSync, PBGetXCatInfoAsync,
	PBExchangeFilesSync, PBExchangeFilesAsync, PBCreateFileIDRefSync,
	PBCreateFileIDRefAsync, PBResolveFileIDRefSync,
	PBResolveFileIDRefAsync, PBDeleteFileIDRefSync,
	PBDeleteFileIDRefAsync, PBGetForeignPrivsSync,
	PBGetForeignPrivsAsync, PBSetForeignPrivsSync,
	PBSetForeignPrivsAsync, PBDTGetPath, PBDTCloseDown, PBDTAddIconSync,
	PBDTAddIconAsync, PBDTGetIconSync, PBDTGetIconAsync,
	PBDTGetIconInfoSync, PBDTGetIconInfoAsync, PBDTAddAPPLSync,
	PBDTAddAPPLAsync, PBDTRemoveAPPLSync, PBDTRemoveAPPLAsync,
	PBDTGetAPPLSync, PBDTGetAPPLAsync, PBDTSetCommentSync,
	PBDTSetCommentAsync, PBDTRemoveCommentSync, PBDTRemoveCommentAsync,
	PBDTGetCommentSync, PBDTGetCommentAsync, PBDTFlushSync,
	PBDTFlushAsync, PBDTResetSync, PBDTResetAsync, PBDTGetInfoSync,
	PBDTGetInfoAsync, PBDTOpenInform, PBDTDeleteSync, PBDTDeleteAsync,
	PBGetVolMountInfoSize, PBGetVolMountInfo, PBVolumeMount,
	FSMakeFSSpec, FSpOpenDF, FSpOpenRF, FSpCreate, FSpDirCreate,
	FSpDelete, FSpGetFInfo, FSpSetFInfo, FSpSetFLock, FSpRstFLock,
	FSpRename, FSpCatMove, FSpExchangeFiles;
  export PBShareSync, PBShareAsync, PBUnshareSync, PBUnshareAsync,
	PBGetUGEntrySync, PBGetUGEntryAsync;

  // from "Processes.h":
  export highLongOfPSN-value, highLongOfPSN-value-setter,
	lowLongOfPSN-value, lowLongOfPSN-value-setter, <ProcessSerialNumber>,
	<ProcessSerialNumber*>, <ProcessSerialNumber**>,
	<ProcessSerialNumberPtr>, $kNoProcess, $kSystemProcess,
	$kCurrentProcess;
  export <LaunchFlags>, <LaunchFlags*>, <LaunchFlags**>,
	$launchContinue, $launchNoFileFlags, $launchUseMinimum,
	$launchDontSwitch, $launchAllow24Bit, $launchInhibitDaemon,
	theMsgEvent-value, theMsgEvent-value-setter, eventRefCon-value,
	eventRefCon-value-setter, messageLength-value,
	messageLength-value-setter, <AppParameters>, <AppParameters*>,
	<AppParameters**>, <AppParametersPtr>, reserved1-value,
	reserved1-value-setter, reserved2-value, reserved2-value-setter,
	launchBlockID-value, launchBlockID-value-setter,
	launchEPBLength-value, launchEPBLength-value-setter,
	launchFileFlags-value, launchFileFlags-value-setter,
	launchControlFlags-value, launchControlFlags-value-setter,
	launchAppSpec-value, launchAppSpec-value-setter,
	launchProcessSN-value, launchProcessSN-value-setter,
	launchPreferredSize-value, launchPreferredSize-value-setter,
	launchMinimumSize-value, launchMinimumSize-value-setter,
	launchAvailableSize-value, launchAvailableSize-value-setter,
	launchAppParameters-value, launchAppParameters-value-setter,
	<LaunchParamBlockRec>, <LaunchParamBlockRec*>,
	<LaunchParamBlockRec**>;
  export <LaunchPBPtr>, $extendedBlock, $extendedBlockLen;
  export $modeLaunchDontSwitch, $modeDeskAccessory, $modeMultiLaunch,
	$modeNeedSuspendResume, $modeCanBackground,
	$modeDoesActivateOnFGSwitch, $modeOnlyBackground,
	$modeGetFrontClicks, $modeGetAppDiedMsg, $mode32BitCompatible,
	$modeHighLevelEventAware, $modeLocalAndRemoteHLEvents,
	$modeStationeryAware, $modeUseTextEditServices,
	$modeDisplayManagerAware, $modeGuardPageAware,
	processInfoLength-value, processInfoLength-value-setter,
	processName-value, processName-value-setter, processNumber-value,
	processNumber-value-setter, processType-value,
	processType-value-setter, processSignature-value,
	processSignature-value-setter, processMode-value,
	processMode-value-setter, processLocation-value,
	processLocation-value-setter, processSize-value,
	processSize-value-setter, processFreeMem-value,
	processFreeMem-value-setter, processLauncher-value,
	processLauncher-value-setter, processLaunchDate-value,
	processLaunchDate-value-setter, processActiveTime-value,
	processActiveTime-value-setter, processAppSpec-value,
	processAppSpec-value-setter, <ProcessInfoRec>, <ProcessInfoRec*>,
	<ProcessInfoRec**>, <ProcessInfoRecPtr>, LaunchApplication,
	LaunchDeskAccessory, MacGetCurrentProcess, GetFrontProcess,
	GetNextProcess, GetProcessInformation, SetFrontProcess,
	WakeUpProcess, SameProcess;
  export ExitToShell;

  // from "AppleTalk.h":
  export $mppUnitNum, $atpUnitNum, $xppUnitNum;
  export $mppRefNum, $atpRefNum, $xppRefNum;
  export $lookupReply, $writeLAP, $detachPH, $attachPH, $writeDDP,
	$closeSkt, $openSkt, $loadNBP, $lastResident, $confirmName,
	$lookupName, $removeName, $registerName, $killNBP, $unloadNBP,
	$setSelfSend, $SetMyZone, $GetATalkInfo, $ATalkClosePrep;
  export $nSendRequest, $relRspCB, $closeATPSkt, $addResponse,
	$sendResponse, $getRequest, $openATPSkt, $sendRequest, $relTCB,
	$killGetReq, $killSendReq, $killAllGetReq;
  export $openSess, $closeSess, $userCommand, $userWrite, $getStatus,
	$afpCall, $getParms, $abortOS, $closeAll, $xCall;
  export $ATTransOpen, $ATTransClose, $ATTransClosePrep,
	$ATTransCancelClose;
  export $afpByteRangeLock, $afpVolClose, $afpDirClose, $afpForkClose,
	$afpCopyFile, $afpDirCreate, $afpFileCreate, $afpDelete,
	$afpEnumerate, $afpFlush, $afpForkFlush, $afpGetDirParms,
	$afpGetFileParms, $afpGetForkParms, $afpGetSInfo, $afpGetSParms,
	$afpGetVolParms, $afpLogin, $afpContLogin, $afpLogout, $afpMapID,
	$afpMapName, $afpMove, $afpOpenVol, $afpOpenDir, $afpOpenFork,
	$afpRead, $afpRename, $afpSetDirParms, $afpSetFileParms,
	$afpSetForkParms, $afpSetVolParms, $afpWrite, $afpGetFlDrParms,
	$afpSetFlDrParms, $afpDTOpen, $afpDTClose, $afpGetIcon,
	$afpGtIcnInfo, $afpAddAPPL, $afpRmvAPPL, $afpGetAPPL, $afpAddCmt,
	$afpRmvCmt, $afpGetCmt, $afpAddIcon;
  export $xppLoadedBit, $scbMemSize, $xppFlagClr;
  export $xppFlagSet;
  export $lapSize, $ddpSize, $nbpSize, $atpSize;
  export $atpXOvalue, $atpEOMvalue, $atpSTSvalue, $atpTIDValidvalue,
	$atpSendChkvalue;
  export $zipGetLocalZones, $zipGetZoneList, $zipGetMyZone;
  export $LAPMgrPtr;
  export $LAPMgrCall, $LAddAEQ, $LRmvAEQ, $tLAPRead, $tLAPWrite,
	$tDDPRead, $tDDPWrite, $tNBPLookup, $tNBPConfirm, $tNBPRegister,
	$tATPSndRequest, $tATPGetRequest, $tATPSdRsp, $tATPAddRsp,
	$tATPRequest, $tATPResponse;
  export <ABCallType>, <ABCallType*>, <ABCallType**>, $lapProto,
	$ddpProto, $nbpProto, $atpProto;
  export <ABProtoType>, <ABProtoType*>, <ABProtoType**>, <ABByte>,
	<ABByte*>, <ABByte**>, dstNodeID-value, dstNodeID-value-setter,
	srcNodeID-value, srcNodeID-value-setter, lapProtType-value,
	lapProtType-value-setter, filler-value, filler-value-setter,
	<LAPAdrBlock>, <LAPAdrBlock*>, <LAPAdrBlock**>, <ATQEntry*>,
	<ATQEntry**>;
  export <ATQEntryPtr>, <ATalkTransitionEventProcPtr>,
	<ATalkTransitionEventUPP>, <ATalkTransitionEvent>,
	<ATalkTransitionEvent*>, <ATalkTransitionEvent**>, qLink-value,
	qLink-value-setter, qType-value, qType-value-setter, CallAddr-value,
	CallAddr-value-setter, <ATQEntry>, objStr-value, objStr-value-setter,
	typeStr-value, typeStr-value-setter, zoneStr-value,
	zoneStr-value-setter, <EntityName>, <EntityName*>, <EntityName**>;
  export <EntityPtr>, aNet-value, aNet-value-setter, aNode-value,
	aNode-value-setter, aSocket-value, aSocket-value-setter, <AddrBlock>,
	<AddrBlock*>, <AddrBlock**>, retransInterval-value,
	retransInterval-value-setter, retransCount-value,
	retransCount-value-setter, <RetransType>, <RetransType*>,
	<RetransType**>, buffSize-value, buffSize-value-setter,
	buffPtr-value, buffPtr-value-setter, dataSize-value,
	dataSize-value-setter, userBytes-value, userBytes-value-setter,
	<BDSElement>, <BDSElement*>, <BDSElement**>;
  export <BDSPtr>, <BitMapType>, <BitMapType*>, <BitMapType**>,
	abOpcode-value, abOpcode-value-setter, filler-value,
	filler-value-setter, abResult-value, abResult-value-setter,
	abUserReference-value, abUserReference-value-setter,
	lapAddress-value, lapAddress-value-setter, lapReqCount-value,
	lapReqCount-value-setter, lapActCount-value,
	lapActCount-value-setter, lapDataPtr-value, lapDataPtr-value-setter,
	<ATLAPRec>, <ATLAPRec*>, <ATLAPRec**>, <ATLAPRecPtr>,
	<ATLAPRecHandle>, abOpcode-value, abOpcode-value-setter,
	filler-value, filler-value-setter, abResult-value,
	abResult-value-setter, abUserReference-value,
	abUserReference-value-setter, ddpType-value, ddpType-value-setter,
	ddpSocket-value, ddpSocket-value-setter, ddpAddress-value,
	ddpAddress-value-setter, ddpReqCount-value, ddpReqCount-value-setter,
	ddpActCount-value, ddpActCount-value-setter, ddpDataPtr-value,
	ddpDataPtr-value-setter, ddpNodeID-value, ddpNodeID-value-setter,
	<ATDDPRec>, <ATDDPRec*>, <ATDDPRec**>, <ATDDPRecPtr>,
	<ATDDPRecHandle>, abOpcode-value, abOpcode-value-setter,
	filler-value, filler-value-setter, abResult-value,
	abResult-value-setter, abUserReference-value,
	abUserReference-value-setter, nbpEntityPtr-value,
	nbpEntityPtr-value-setter, nbpBufPtr-value, nbpBufPtr-value-setter,
	nbpBufSize-value, nbpBufSize-value-setter, nbpDataField-value,
	nbpDataField-value-setter, nbpAddress-value, nbpAddress-value-setter,
	nbpRetransmitInfo-value, nbpRetransmitInfo-value-setter, <ATNBPRec>,
	<ATNBPRec*>, <ATNBPRec**>, <ATNBPRecPtr>, <ATNBPRecHandle>,
	abOpcode-value, abOpcode-value-setter, filler1-value,
	filler1-value-setter, abResult-value, abResult-value-setter,
	abUserReference-value, abUserReference-value-setter, atpSocket-value,
	atpSocket-value-setter, atpAddress-value, atpAddress-value-setter,
	atpReqCount-value, atpReqCount-value-setter, atpDataPtr-value,
	atpDataPtr-value-setter, atpRspBDSPtr-value,
	atpRspBDSPtr-value-setter, atpBitMap-value, atpBitMap-value-setter,
	filler2-value, filler2-value-setter, atpTransID-value,
	atpTransID-value-setter, atpActCount-value, atpActCount-value-setter,
	atpUserData-value, atpUserData-value-setter, atpXO-value,
	atpXO-value-setter, atpEOM-value, atpEOM-value-setter,
	atpTimeOut-value, atpTimeOut-value-setter, atpRetries-value,
	atpRetries-value-setter, atpNumBufs-value, atpNumBufs-value-setter,
	atpNumRsp-value, atpNumRsp-value-setter, atpBDSSize-value,
	atpBDSSize-value-setter, atpRspUData-value, atpRspUData-value-setter,
	atpRspBuf-value, atpRspBuf-value-setter, atpRspSize-value,
	atpRspSize-value-setter, <ATATPRec>, <ATATPRec*>, <ATATPRec**>,
	<ATATPRecPtr>, <ATATPRecHandle>, cmdByte-value, cmdByte-value-setter,
	startEndFlag-value, startEndFlag-value-setter, forkRefNum-value,
	forkRefNum-value-setter, rwOffset-value, rwOffset-value-setter,
	reqCount-value, reqCount-value-setter, newLineFlag-value,
	newLineFlag-value-setter, newLineChar-value,
	newLineChar-value-setter, <AFPCommandBlock>, <AFPCommandBlock*>,
	<AFPCommandBlock**>, <MPPParamBlock*>, <MPPParamBlock**>,
	<ATPParamBlock*>, <ATPParamBlock**>, <XPPParamBlock*>,
	<XPPParamBlock**>;
  export <MPPPBPtr>, <ATPPBPtr>, <XPPParmBlkPtr>,
	<MPPCompletionProcPtr>, <ATPCompletionProcPtr>,
	<XPPCompletionProcPtr>, <AttnRoutineProcPtr>, <MPPCompletionUPP>,
	<ATPCompletionUPP>, <XPPCompletionUPP>, <AttnRoutineUPP>;
  export entryLength-value, entryLength-value-setter, entryPtr-value,
	entryPtr-value-setter, <WDSElement>, <WDSElement*>, <WDSElement**>,
	nteAddress-value, nteAddress-value-setter, filler-value,
	filler-value-setter, entityData-array, entityData-array-setter,
	entityData-value, <NTElement>, <NTElement*>, <NTElement**>,
	qNext-value, qNext-value-setter, nt-value, nt-value-setter,
	<NamesTableEntry>, <NamesTableEntry*>, <NamesTableEntry**>,
	<MPPProtocolHandlerProcPtr>, <DDPSocketListenerProcPtr>,
	<MPPProtocolHandlerUPP>, <DDPSocketListenerUPP>, qLink-value,
	qLink-value-setter, qType-value, qType-value-setter, ioTrap-value,
	ioTrap-value-setter, ioCmdAddr-value, ioCmdAddr-value-setter,
	ioCompletion-value, ioCompletion-value-setter, ioResult-value,
	ioResult-value-setter, userData-value, userData-value-setter,
	reqTID-value, reqTID-value-setter, ioRefNum-value,
	ioRefNum-value-setter, csCode-value, csCode-value-setter, <MPPparms>,
	<MPPparms*>, <MPPparms**>, qLink-value, qLink-value-setter,
	qType-value, qType-value-setter, ioTrap-value, ioTrap-value-setter,
	ioCmdAddr-value, ioCmdAddr-value-setter, ioCompletion-value,
	ioCompletion-value-setter, ioResult-value, ioResult-value-setter,
	userData-value, userData-value-setter, reqTID-value,
	reqTID-value-setter, ioRefNum-value, ioRefNum-value-setter,
	csCode-value, csCode-value-setter, protType-value,
	protType-value-setter, filler-value, filler-value-setter,
	wdsPointer-value, wdsPointer-value-setter, handler-value,
	handler-value-setter, wdsPointer-value, wdsPointer-value-setter,
	handler-value, handler-value-setter, u-value, u-value-setter,
	<LAPparms>, <LAPparms*>, <LAPparms**>, qLink-value,
	qLink-value-setter, qType-value, qType-value-setter, ioTrap-value,
	ioTrap-value-setter, ioCmdAddr-value, ioCmdAddr-value-setter,
	ioCompletion-value, ioCompletion-value-setter, ioResult-value,
	ioResult-value-setter, userData-value, userData-value-setter,
	reqTID-value, reqTID-value-setter, ioRefNum-value,
	ioRefNum-value-setter, csCode-value, csCode-value-setter,
	socket-value, socket-value-setter, checksumFlag-value,
	checksumFlag-value-setter, wdsPointer-value, wdsPointer-value-setter,
	listener-value, listener-value-setter, wdsPointer-value,
	wdsPointer-value-setter, listener-value, listener-value-setter,
	u-value, u-value-setter, <DDPparms>, <DDPparms*>, <DDPparms**>,
	ntQElPtr-value, ntQElPtr-value-setter, entityPtr-value,
	entityPtr-value-setter, <NBPPtrs>, <NBPPtrs*>, <NBPPtrs**>,
	verifyFlag-value, verifyFlag-value-setter, retBuffPtr-value,
	retBuffPtr-value-setter, retBuffSize-value, retBuffSize-value-setter,
	maxToGet-value, maxToGet-value-setter, numGotten-value,
	numGotten-value-setter, retBuffPtr-value, retBuffPtr-value-setter,
	retBuffSize-value, retBuffSize-value-setter, maxToGet-value,
	maxToGet-value-setter, numGotten-value, numGotten-value-setter,
	Lookup-value, confirmAddr-value, confirmAddr-value-setter,
	newSocket-value, newSocket-value-setter, filler-value,
	filler-value-setter, confirmAddr-value, confirmAddr-value-setter,
	newSocket-value, newSocket-value-setter, filler-value,
	filler-value-setter, Confirm-value, <LookupConfirmParams>,
	<LookupConfirmParams*>, <LookupConfirmParams**>, qLink-value,
	qLink-value-setter, qType-value, qType-value-setter, ioTrap-value,
	ioTrap-value-setter, ioCmdAddr-value, ioCmdAddr-value-setter,
	ioCompletion-value, ioCompletion-value-setter, ioResult-value,
	ioResult-value-setter, userData-value, userData-value-setter,
	reqTID-value, reqTID-value-setter, ioRefNum-value,
	ioRefNum-value-setter, csCode-value, csCode-value-setter,
	interval-value, interval-value-setter, count-value,
	count-value-setter, nbpPtrs-value, nbpPtrs-value-setter, parm-value,
	parm-value-setter, <NBPparms>, <NBPparms*>, <NBPparms**>,
	qLink-value, qLink-value-setter, qType-value, qType-value-setter,
	ioTrap-value, ioTrap-value-setter, ioCmdAddr-value,
	ioCmdAddr-value-setter, ioCompletion-value,
	ioCompletion-value-setter, ioResult-value, ioResult-value-setter,
	userData-value, userData-value-setter, reqTID-value,
	reqTID-value-setter, ioRefNum-value, ioRefNum-value-setter,
	csCode-value, csCode-value-setter, newSelfFlag-value,
	newSelfFlag-value-setter, oldSelfFlag-value,
	oldSelfFlag-value-setter, <SetSelfparms>, <SetSelfparms*>,
	<SetSelfparms**>, qLink-value, qLink-value-setter, qType-value,
	qType-value-setter, ioTrap-value, ioTrap-value-setter,
	ioCmdAddr-value, ioCmdAddr-value-setter, ioCompletion-value,
	ioCompletion-value-setter, ioResult-value, ioResult-value-setter,
	userData-value, userData-value-setter, reqTID-value,
	reqTID-value-setter, ioRefNum-value, ioRefNum-value-setter,
	csCode-value, csCode-value-setter, nKillQEl-value,
	nKillQEl-value-setter, <NBPKillparms>, <NBPKillparms*>,
	<NBPKillparms**>;
  export qLink-value, qLink-value-setter, qType-value,
	qType-value-setter, ioTrap-value, ioTrap-value-setter,
	ioCmdAddr-value, ioCmdAddr-value-setter, ioCompletion-value,
	ioCompletion-value-setter, ioResult-value, ioResult-value-setter,
	userData-value, userData-value-setter, reqTID-value,
	reqTID-value-setter, ioRefNum-value, ioRefNum-value-setter,
	csCode-value, csCode-value-setter, version-value,
	version-value-setter, varsPtr-value, varsPtr-value-setter,
	DCEPtr-value, DCEPtr-value-setter, portID-value, portID-value-setter,
	configuration-value, configuration-value-setter, selfSend-value,
	selfSend-value-setter, netLo-value, netLo-value-setter, netHi-value,
	netHi-value-setter, ourAdd-value, ourAdd-value-setter,
	routerAddr-value, routerAddr-value-setter, numOfPHs-value,
	numOfPHs-value-setter, numOfSkts-value, numOfSkts-value-setter,
	numNBPEs-value, numNBPEs-value-setter, nTQueue-value,
	nTQueue-value-setter, LAlength-value, LAlength-value-setter,
	linkAddr-value, linkAddr-value-setter, zoneName-value,
	zoneName-value-setter, <GetAppleTalkInfoParm>,
	<GetAppleTalkInfoParm*>, <GetAppleTalkInfoParm**>, qLink-value,
	qLink-value-setter, qType-value, qType-value-setter, ioTrap-value,
	ioTrap-value-setter, ioCmdAddr-value, ioCmdAddr-value-setter,
	ioCompletion-value, ioCompletion-value-setter, ioResult-value,
	ioResult-value-setter, userData-value, userData-value-setter,
	reqTID-value, reqTID-value-setter, ioRefNum-value,
	ioRefNum-value-setter, csCode-value, csCode-value-setter,
	appName-value, appName-value-setter, <ATalkClosePrepParm>,
	<ATalkClosePrepParm*>, <ATalkClosePrepParm**>, MPP-value,
	MPP-value-setter, LAP-value, LAP-value-setter, DDP-value,
	DDP-value-setter, NBP-value, NBP-value-setter, SETSELF-value,
	SETSELF-value-setter, NBPKILL-value, NBPKILL-value-setter,
	GAIINFO-value, GAIINFO-value-setter, ATALKCLOSE-value,
	ATALKCLOSE-value-setter, <MPPParamBlock>;
  export qLink-value, qLink-value-setter, qType-value,
	qType-value-setter, ioTrap-value, ioTrap-value-setter,
	ioCmdAddr-value, ioCmdAddr-value-setter, ioCompletion-value,
	ioCompletion-value-setter, ioResult-value, ioResult-value-setter,
	cmdResult-value, cmdResult-value-setter, ioVRefNum-value,
	ioVRefNum-value-setter, ioRefNum-value, ioRefNum-value-setter,
	csCode-value, csCode-value-setter, sessRefnum-value,
	sessRefnum-value-setter, aspTimeout-value, aspTimeout-value-setter,
	aspRetry-value, aspRetry-value-setter, cbSize-value,
	cbSize-value-setter, cbPtr-value, cbPtr-value-setter, rbSize-value,
	rbSize-value-setter, rbPtr-value, rbPtr-value-setter, wdSize-value,
	wdSize-value-setter, wdPtr-value, wdPtr-value-setter, ccbStart-array,
	ccbStart-array-setter, ccbStart-value, <XPPPrmBlk>, <XPPPrmBlk*>,
	<XPPPrmBlk**>, qLink-value, qLink-value-setter, qType-value,
	qType-value-setter, ioTrap-value, ioTrap-value-setter,
	ioCmdAddr-value, ioCmdAddr-value-setter, ioCompletion-value,
	ioCompletion-value-setter, ioResult-value, ioResult-value-setter,
	cmdResult-value, cmdResult-value-setter, ioVRefNum-value,
	ioVRefNum-value-setter, ioRefNum-value, ioRefNum-value-setter,
	csCode-value, csCode-value-setter, aspMaxCmdSize-value,
	aspMaxCmdSize-value-setter, aspQuantumSize-value,
	aspQuantumSize-value-setter, numSesss-value, numSesss-value-setter,
	<ASPGetparmsBlk>, <ASPGetparmsBlk*>, <ASPGetparmsBlk**>, qLink-value,
	qLink-value-setter, qType-value, qType-value-setter, ioTrap-value,
	ioTrap-value-setter, ioCmdAddr-value, ioCmdAddr-value-setter,
	ioCompletion-value, ioCompletion-value-setter, ioResult-value,
	ioResult-value-setter, cmdResult-value, cmdResult-value-setter,
	ioVRefNum-value, ioVRefNum-value-setter, ioRefNum-value,
	ioRefNum-value-setter, csCode-value, csCode-value-setter,
	abortSCBPtr-value, abortSCBPtr-value-setter, <ASPAbortPrm>,
	<ASPAbortPrm*>, <ASPAbortPrm**>, qLink-value, qLink-value-setter,
	qType-value, qType-value-setter, ioTrap-value, ioTrap-value-setter,
	ioCmdAddr-value, ioCmdAddr-value-setter, ioCompletion-value,
	ioCompletion-value-setter, ioResult-value, ioResult-value-setter,
	cmdResult-value, cmdResult-value-setter, ioVRefNum-value,
	ioVRefNum-value-setter, ioRefNum-value, ioRefNum-value-setter,
	csCode-value, csCode-value-setter, sessRefnum-value,
	sessRefnum-value-setter, aspTimeout-value, aspTimeout-value-setter,
	aspRetry-value, aspRetry-value-setter, serverAddr-value,
	serverAddr-value-setter, scbPointer-value, scbPointer-value-setter,
	attnRoutine-value, attnRoutine-value-setter, <ASPOpenPrm>,
	<ASPOpenPrm*>, <ASPOpenPrm**>, <ASPOpenPrmPtr>, qLink-value,
	qLink-value-setter, qType-value, qType-value-setter, ioTrap-value,
	ioTrap-value-setter, ioCmdAddr-value, ioCmdAddr-value-setter,
	ioCompletion-value, ioCompletion-value-setter, ioResult-value,
	ioResult-value-setter, cmdResult-value, cmdResult-value-setter,
	ioVRefNum-value, ioVRefNum-value-setter, ioRefNum-value,
	ioRefNum-value-setter, csCode-value, csCode-value-setter,
	sessRefnum-value, sessRefnum-value-setter, aspTimeout-value,
	aspTimeout-value-setter, aspRetry-value, aspRetry-value-setter,
	cbSize-value, cbSize-value-setter, cbPtr-value, cbPtr-value-setter,
	rbSize-value, rbSize-value-setter, rbPtr-value, rbPtr-value-setter,
	afpAddrBlock-value, afpAddrBlock-value-setter, afpSCBPtr-value,
	afpSCBPtr-value-setter, afpAttnRoutine-value,
	afpAttnRoutine-value-setter, ccbFill-array, ccbFill-array-setter,
	ccbFill-value, <AFPLoginPrm>, <AFPLoginPrm*>, <AFPLoginPrm**>,
	qLink-value, qLink-value-setter, qType-value, qType-value-setter,
	ioTrap-value, ioTrap-value-setter, ioCmdAddr-value,
	ioCmdAddr-value-setter, ioCompletion-value,
	ioCompletion-value-setter, ioResult-value, ioResult-value-setter,
	cmdResult-value, cmdResult-value-setter, ioVRefNum-value,
	ioVRefNum-value-setter, ioRefNum-value, ioRefNum-value-setter,
	csCode-value, csCode-value-setter, xppSubCode-value,
	xppSubCode-value-setter, xppTimeout-value, xppTimeout-value-setter,
	xppRetry-value, xppRetry-value-setter, filler1-value,
	filler1-value-setter, zipBuffPtr-value, zipBuffPtr-value-setter,
	zipNumZones-value, zipNumZones-value-setter, zipLastFlag-value,
	zipLastFlag-value-setter, filler2-value, filler2-value-setter,
	zipInfoField-array, zipInfoField-array-setter, zipInfoField-value,
	<XCallParam>, <XCallParam*>, <XCallParam**>, XPP-value,
	XPP-value-setter, GETPARM-value, GETPARM-value-setter, ABORT-value,
	ABORT-value-setter, OPEN-value, OPEN-value-setter, LOGIN-value,
	LOGIN-value-setter, XCALL-value, XCALL-value-setter, <XPPParamBlock>;
  export qLink-value, qLink-value-setter, qType-value,
	qType-value-setter, ioTrap-value, ioTrap-value-setter,
	ioCmdAddr-value, ioCmdAddr-value-setter, ioCompletion-value,
	ioCompletion-value-setter, ioResult-value, ioResult-value-setter,
	userData-value, userData-value-setter, reqTID-value,
	reqTID-value-setter, ioRefNum-value, ioRefNum-value-setter,
	csCode-value, csCode-value-setter, atpSocket-value,
	atpSocket-value-setter, atpFlags-value, atpFlags-value-setter,
	addrBlock-value, addrBlock-value-setter, reqLength-value,
	reqLength-value-setter, reqPointer-value, reqPointer-value-setter,
	bdsPointer-value, bdsPointer-value-setter, <ATPparms>, <ATPparms*>,
	<ATPparms**>, qLink-value, qLink-value-setter, qType-value,
	qType-value-setter, ioTrap-value, ioTrap-value-setter,
	ioCmdAddr-value, ioCmdAddr-value-setter, ioCompletion-value,
	ioCompletion-value-setter, ioResult-value, ioResult-value-setter,
	userData-value, userData-value-setter, reqTID-value,
	reqTID-value-setter, ioRefNum-value, ioRefNum-value-setter,
	csCode-value, csCode-value-setter, atpSocket-value,
	atpSocket-value-setter, atpFlags-value, atpFlags-value-setter,
	addrBlock-value, addrBlock-value-setter, reqLength-value,
	reqLength-value-setter, reqPointer-value, reqPointer-value-setter,
	bdsPointer-value, bdsPointer-value-setter, numOfBuffs-value,
	numOfBuffs-value-setter, timeOutVal-value, timeOutVal-value-setter,
	numOfResps-value, numOfResps-value-setter, retryCount-value,
	retryCount-value-setter, intBuff-value, intBuff-value-setter,
	TRelTime-value, TRelTime-value-setter, filler0-value,
	filler0-value-setter, <SendReqparms>, <SendReqparms*>,
	<SendReqparms**>;
  export qLink-value, qLink-value-setter, qType-value,
	qType-value-setter, ioTrap-value, ioTrap-value-setter,
	ioCmdAddr-value, ioCmdAddr-value-setter, ioCompletion-value,
	ioCompletion-value-setter, ioResult-value, ioResult-value-setter,
	userData-value, userData-value-setter, reqTID-value,
	reqTID-value-setter, ioRefNum-value, ioRefNum-value-setter,
	csCode-value, csCode-value-setter, atpSocket-value,
	atpSocket-value-setter, atpFlags-value, atpFlags-value-setter,
	addrBlock-value, addrBlock-value-setter, reqLength-value,
	reqLength-value-setter, reqPointer-value, reqPointer-value-setter,
	bdsPointer-value, bdsPointer-value-setter, bitMap-value,
	bitMap-value-setter, numOfBuffs-value, numOfBuffs-value-setter,
	rspNum-value, rspNum-value-setter, bitMap-value, bitMap-value-setter,
	numOfBuffs-value, numOfBuffs-value-setter, rspNum-value,
	rspNum-value-setter, u-value, u-value-setter, <ATPmisc1>,
	<ATPmisc1*>, <ATPmisc1**>, qLink-value, qLink-value-setter,
	qType-value, qType-value-setter, ioTrap-value, ioTrap-value-setter,
	ioCmdAddr-value, ioCmdAddr-value-setter, ioCompletion-value,
	ioCompletion-value-setter, ioResult-value, ioResult-value-setter,
	userData-value, userData-value-setter, reqTID-value,
	reqTID-value-setter, ioRefNum-value, ioRefNum-value-setter,
	csCode-value, csCode-value-setter, atpSocket-value,
	atpSocket-value-setter, atpFlags-value, atpFlags-value-setter,
	addrBlock-value, addrBlock-value-setter, reqLength-value,
	reqLength-value-setter, reqPointer-value, reqPointer-value-setter,
	bdsPointer-value, bdsPointer-value-setter, filler-value,
	filler-value-setter, bdsSize-value, bdsSize-value-setter,
	transID-value, transID-value-setter, <ATPmisc2>, <ATPmisc2*>,
	<ATPmisc2**>, qLink-value, qLink-value-setter, qType-value,
	qType-value-setter, ioTrap-value, ioTrap-value-setter,
	ioCmdAddr-value, ioCmdAddr-value-setter, ioCompletion-value,
	ioCompletion-value-setter, ioResult-value, ioResult-value-setter,
	userData-value, userData-value-setter, reqTID-value,
	reqTID-value-setter, ioRefNum-value, ioRefNum-value-setter,
	csCode-value, csCode-value-setter, atpSocket-value,
	atpSocket-value-setter, atpFlags-value, atpFlags-value-setter,
	addrBlock-value, addrBlock-value-setter, reqLength-value,
	reqLength-value-setter, reqPointer-value, reqPointer-value-setter,
	bdsPointer-value, bdsPointer-value-setter, aKillQEl-value,
	aKillQEl-value-setter, <Killparms>, <Killparms*>, <Killparms**>,
	ATP-value, ATP-value-setter, SREQ-value, SREQ-value-setter,
	OTH1-value, OTH1-value-setter, OTH2-value, OTH2-value-setter,
	KILL-value, KILL-value-setter, <ATPParamBlock>,
	$uppATalkTransitionEventProcInfo, $uppMPPCompletionProcInfo,
	$uppATPCompletionProcInfo, $uppXPPCompletionProcInfo,
	$uppAttnRoutineProcInfo, $uppMPPProtocolHandlerProcInfo,
	$uppDDPSocketListenerProcInfo, OpenXPP, ASPOpenSession,
	ASPCloseSession, ASPAbortOS, ASPGetParms, ASPCloseAll, ASPUserWrite,
	ASPUserCommand, ASPGetStatus, AFPCommand, GetLocalZones, GetZoneList,
	GetMyZone, PAttachPH, PDetachPH, PWriteLAP, POpenSkt, PCloseSkt,
	PWriteDDP, PRegisterName, PLookupName, PConfirmName, PRemoveName,
	PSetSelfSend, PKillNBP, PGetAppleTalkInfo, PATalkClosePrep,
	POpenATPSkt, PCloseATPSkt, PSendRequest, PGetRequest, PSendResponse,
	PAddResponse, PRelTCB, PRelRspCB, PNSendRequest, PKillSendReq,
	PKillGetReq, ATPKillAllGetReq, BuildLAPwds, BuildDDPwds,
	NBPSetEntity, NBPSetNTE, GetBridgeAddress, BuildBDS, MPPOpen,
	LAPAddATQ, LAPRmvATQ, ATPLoad, ATPUnload, NBPExtract, GetNodeAddress,
	IsMPPOpen, IsATPOpen, ATEvent, ATPreFlightEvent;

  // from "Aliases.h":
  export $rAliasType;
  export $kARMMountVol, $kARMNoUI, $kARMMultVols, $kARMSearch,
	$kARMSearchMore, $kARMSearchRelFirst;
  export $asiZoneName, $asiServerName, $asiVolumeName, $asiAliasName,
	$asiParentName, $kResolveAliasFileNoUI, userType-value,
	userType-value-setter, aliasSize-value, aliasSize-value-setter,
	<AliasRecord>, <AliasRecord*>, <AliasRecord**>;
  export <AliasPtr>, <AliasHandle>, <AliasInfoType>, <AliasInfoType*>,
	<AliasInfoType**>, NewAlias, NewAliasMinimal,
	NewAliasMinimalFromFullPath, ResolveAlias, GetAliasInfo;
  export IsAliasFile, ResolveAliasWithMountFlags, ResolveAliasFile;
  export ResolveAliasFileWithMountFlags, FollowFinderAlias;
  export UpdateAlias;
  export <AliasFilterProcPtr>, <AliasFilterUPP>,
	$uppAliasFilterProcInfo, MatchAlias;

  // from "Collections.h":
  export $kCollectionDontWantTag, $kCollectionDontWantId,
	$kCollectionDontWantSize, $kCollectionDontWantAttributes,
	$kCollectionDontWantIndex, $kCollectionDontWantData;
  export $kCollectionNoAttributes, $kCollectionAllAttributes,
	$kCollectionUserAttributes, $kCollectionDefaultAttributes;
  export $kCollectionUser0Bit, $kCollectionUser1Bit,
	$kCollectionUser2Bit, $kCollectionUser3Bit, $kCollectionUser4Bit,
	$kCollectionUser5Bit, $kCollectionUser6Bit, $kCollectionUser7Bit,
	$kCollectionUser8Bit, $kCollectionUser9Bit, $kCollectionUser10Bit,
	$kCollectionUser11Bit, $kCollectionUser12Bit, $kCollectionUser13Bit,
	$kCollectionUser14Bit, $kCollectionUser15Bit,
	$kCollectionReserved0Bit, $kCollectionReserved1Bit,
	$kCollectionReserved2Bit, $kCollectionReserved3Bit,
	$kCollectionReserved4Bit, $kCollectionReserved5Bit,
	$kCollectionReserved6Bit, $kCollectionReserved7Bit,
	$kCollectionReserved8Bit, $kCollectionReserved9Bit,
	$kCollectionReserved10Bit, $kCollectionReserved11Bit,
	$kCollectionReserved12Bit, $kCollectionReserved13Bit,
	$kCollectionPersistenceBit, $kCollectionLockBit;
  export $kCollectionUser0Mask, $kCollectionUser1Mask,
	$kCollectionUser2Mask, $kCollectionUser3Mask, $kCollectionUser4Mask,
	$kCollectionUser5Mask, $kCollectionUser6Mask, $kCollectionUser7Mask,
	$kCollectionUser8Mask, $kCollectionUser9Mask, $kCollectionUser10Mask,
	$kCollectionUser11Mask, $kCollectionUser12Mask,
	$kCollectionUser13Mask, $kCollectionUser14Mask,
	$kCollectionUser15Mask, $kCollectionReserved0Mask,
	$kCollectionReserved1Mask, $kCollectionReserved2Mask,
	$kCollectionReserved3Mask, $kCollectionReserved4Mask,
	$kCollectionReserved5Mask, $kCollectionReserved6Mask,
	$kCollectionReserved7Mask, $kCollectionReserved8Mask,
	$kCollectionReserved9Mask, $kCollectionReserved10Mask,
	$kCollectionReserved11Mask, $kCollectionReserved12Mask,
	$kCollectionReserved13Mask, $kCollectionPersistenceMask,
	$kCollectionLockMask;
  export <MacCollection>, <MacCollection*>, <MacCollection**>,
	<CollectionTag>, <CollectionTag*>, <CollectionTag**>,
	<CollectionFlattenProcPtr>, <CollectionExceptionProcPtr>,
	<CollectionFlattenUPP>, <CollectionExceptionUPP>,
	$uppCollectionFlattenProcInfo, $uppCollectionExceptionProcInfo,
	NewCollection;
  export DisposeCollection;
  export CloneCollection;
  export CountCollectionOwners;
  export CopyCollection;
  export GetCollectionDefaultAttributes;
  export SetCollectionDefaultAttributes;
  export CountCollectionItems;
  export AddCollectionItem;
  export GetCollectionItem;
  export RemoveCollectionItem;
  export SetCollectionItemInfo;
  export GetCollectionItemInfo;
  export ReplaceIndexedCollectionItem;
  export GetIndexedCollectionItem;
  export RemoveIndexedCollectionItem;
  export SetIndexedCollectionItemInfo;
  export GetIndexedCollectionItemInfo;
  export CollectionTagExists;
  export CountCollectionTags;
  export GetIndexedCollectionTag;
  export CountTaggedCollectionItems;
  export GetTaggedCollectionItem;
  export GetTaggedCollectionItemInfo;
  export PurgeCollection;
  export PurgeCollectionTag;
  export EmptyCollection, FlattenCollection;
  export FlattenPartialCollection;
  export UnflattenCollection;
  export GetCollectionExceptionProc;
  export SetCollectionExceptionProc;
  export GetNewCollection;
  export AddCollectionItemHdl;
  export GetCollectionItemHdl;
  export ReplaceIndexedCollectionItemHdl;
  export GetIndexedCollectionItemHdl;
  export FlattenCollectionToHdl;
  export UnflattenCollectionFromHdl;

  // from "Drag.h":
  export <DragReference>, <DragReference*>, <DragReference**>,
	<ItemReference>, <ItemReference*>, <ItemReference**>, <FlavorType>,
	<FlavorType*>, <FlavorType**>;
  export <DragAttributes>, <DragAttributes*>, <DragAttributes**>,
	$kDragHasLeftSenderWindow, $kDragInsideSenderApplication,
	$kDragInsideSenderWindow;
  export <DragImageFlags>, <DragImageFlags*>, <DragImageFlags**>,
	$kDragRegionAndImage;
  export $kDragStandardTranslucency, $kDragDarkTranslucency,
	$kDragDarkerTranslucency, $kDragOpaqueTranslucency;
  export <DragRegionMessage>, <DragRegionMessage*>,
	<DragRegionMessage**>, $kDragRegionBegin, $kDragRegionDraw,
	$kDragRegionHide, $kDragRegionIdle, $kDragRegionEnd;
  export <ZoomAcceleration>, <ZoomAcceleration*>,
	<ZoomAcceleration**>, $kZoomNoAcceleration, $kZoomAccelerate,
	$kZoomDecelerate;
  export <FlavorFlags>, <FlavorFlags*>, <FlavorFlags**>,
	$flavorSenderOnly, $flavorSenderTranslated, $flavorNotSaved,
	$flavorSystemTranslated;
  export $flavorTypeHFS, $flavorTypePromiseHFS, $flavorTypeDirectory;
  export $kFlavorTypeClippingName, $kFlavorTypeClippingFilename,
	$kFlavorTypeDragToTrashOnly, $kFlavorTypeFinderNoTrackingBehavior;
  export <DragTrackingMessage>, <DragTrackingMessage*>,
	<DragTrackingMessage**>, $kDragTrackingEnterHandler,
	$kDragTrackingEnterWindow, $kDragTrackingInWindow,
	$kDragTrackingLeaveWindow, $kDragTrackingLeaveHandler;
  export fileType-value, fileType-value-setter, fileCreator-value,
	fileCreator-value-setter, fdFlags-value, fdFlags-value-setter,
	fileSpec-value, fileSpec-value-setter, <HFSFlavor>, <HFSFlavor*>,
	<HFSFlavor**>, fileType-value, fileType-value-setter,
	fileCreator-value, fileCreator-value-setter, fdFlags-value,
	fdFlags-value-setter, promisedFlavor-value,
	promisedFlavor-value-setter, <PromiseHFSFlavor>, <PromiseHFSFlavor*>,
	<PromiseHFSFlavor**>, <DragTrackingHandlerProcPtr>,
	<DragReceiveHandlerProcPtr>, <DragTrackingHandlerUPP>,
	<DragReceiveHandlerUPP>, $uppDragTrackingHandlerProcInfo,
	$uppDragReceiveHandlerProcInfo, <DragSendDataProcPtr>,
	<DragInputProcPtr>, <DragDrawingProcPtr>, <DragSendDataUPP>,
	<DragInputUPP>, <DragDrawingUPP>, $uppDragSendDataProcInfo,
	$uppDragInputProcInfo, $uppDragDrawingProcInfo,
	InstallTrackingHandler, InstallReceiveHandler, RemoveTrackingHandler,
	RemoveReceiveHandler, NewDrag, DisposeDrag, AddDragItemFlavor,
	SetDragItemFlavorData, SetDragSendProc;
  export SetDragInputProc, SetDragDrawingProc, SetDragImage,
	TrackDrag, CountDragItems, GetDragItemReferenceNumber,
	CountDragItemFlavors, GetFlavorType, GetFlavorFlags,
	GetFlavorDataSize, GetFlavorData, GetDragItemBounds,
	SetDragItemBounds, GetDropLocation, SetDropLocation,
	GetDragAttributes, GetDragMouse, SetDragMouse, GetDragOrigin,
	GetDragModifiers, ShowDragHilite, HideDragHilite, DragPreScroll,
	DragPostScroll, UpdateDragHilite, GetDragHiliteColor;
  export WaitMouseMoved;
  export ZoomRects, ZoomRegion;

  // from "Menus.h":
  export $gestaltMenuMgrAttr, $gestaltMenuMgrPresent;
  export $menuPropertyInvalid, $menuPropertyNotFoundErr;
  export $noMark;
  export $kMenuDrawMsg, $kMenuChooseMsg, $kMenuSizeMsg,
	$kMenuDrawItemMsg, $kMenuCalcItemMsg, $kMenuThemeSavvyMsg, $mDrawMsg,
	$mChooseMsg, $mSizeMsg, $mDrawItemMsg, $mCalcItemMsg;
  export $kThemeSavvyMenuResponse;
  export $textMenuProc, $hMenuCmd, $hierMenu, $mPopUpMsg,
	$mctAllItems, $mctLastIDIndic, $kMenuStdMenuProc,
	$kMenuStdMenuBarProc;
  export $kMenuNoModifiers, $kMenuShiftModifier, $kMenuOptionModifier,
	$kMenuControlModifier, $kMenuNoCommandModifier;
  export $kMenuNoIcon, $kMenuIconType, $kMenuShrinkIconType,
	$kMenuSmallIconType, $kMenuColorIconType, $kMenuIconSuiteType,
	$kMenuIconRefType;
  export menuID-value, menuID-value-setter, menuWidth-value,
	menuWidth-value-setter, menuHeight-value, menuHeight-value-setter,
	menuProc-value, menuProc-value-setter, enableFlags-value,
	enableFlags-value-setter, menuData-value, menuData-value-setter,
	<MenuInfo>, <MenuInfo*>, <MenuInfo**>;
  export <MenuPtr>, <MenuHandle>, <MenuRef>, <MenuRef*>, <MenuRef**>,
	mctID-value, mctID-value-setter, mctItem-value, mctItem-value-setter,
	mctRGB1-value, mctRGB1-value-setter, mctRGB2-value,
	mctRGB2-value-setter, mctRGB3-value, mctRGB3-value-setter,
	mctRGB4-value, mctRGB4-value-setter, <MCEntry>, <MCEntry*>,
	<MCEntry**>, <MCEntryPtr>;
  export <MCTablePtr>, <MCTableHandle>, numEntries-value,
	numEntries-value-setter, mcEntryRecs-value, mcEntryRecs-value-setter,
	<MenuCRsrc>, <MenuCRsrc*>, <MenuCRsrc**>, <MenuCRsrcPtr>,
	<MenuCRsrcHandle>, <MenuDefProcPtr>, <MenuBarDefProcPtr>,
	<MenuHookProcPtr>, <MBarHookProcPtr>, <MenuDefUPP>, <MenuBarDefUPP>,
	<MenuHookUPP>, <MBarHookUPP>, $uppMenuDefProcInfo,
	$uppMenuBarDefProcInfo, $uppMenuHookProcInfo, $uppMBarHookProcInfo,
	InitProcMenu, InitMenus, NewMenu, MacGetMenu, DisposeMenu,
	CalcMenuSize, CountMItems, GetMenuFont, SetMenuFont,
	GetMenuExcludesMarkColumn, SetMenuExcludesMarkColumn, MacAppendMenu,
	InsertResMenu, AppendResMenu, MacInsertMenuItem, DeleteMenuItem,
	InsertFontResMenu, InsertIntlResMenu, AppendMenuItemText,
	InsertMenuItemText, MenuKey, MenuSelect, PopUpMenuSelect, MenuChoice,
	MenuEvent;
  export GetMBarHeight, MacDrawMenuBar, InvalMenuBar, HiliteMenu,
	GetNewMBar, GetMenuBar, SetMenuBar, GetMenuHandle, MacInsertMenu,
	MacDeleteMenu, ClearMenuBar, SetMenuFlash, FlashMenuBar, SystemEdit,
	SystemMenu, IsMenuBarVisible, ShowMenuBar, HideMenuBar;
  export CheckItem, SetMenuItemText, GetMenuItemText, SetItemMark,
	GetItemMark, SetItemCmd, GetItemCmd, SetItemIcon, GetItemIcon,
	SetItemStyle, GetItemStyle, DisableItem, EnableItem,
	SetMenuItemCommandID, GetMenuItemCommandID, SetMenuItemModifiers,
	GetMenuItemModifiers, SetMenuItemIconHandle, GetMenuItemIconHandle,
	SetMenuItemTextEncoding, GetMenuItemTextEncoding,
	SetMenuItemHierarchicalID, GetMenuItemHierarchicalID,
	SetMenuItemFontID, GetMenuItemFontID, SetMenuItemRefCon,
	GetMenuItemRefCon, SetMenuItemRefCon2, GetMenuItemRefCon2,
	SetMenuItemKeyGlyph, GetMenuItemKeyGlyph, MacEnableMenuItem,
	DisableMenuItem, IsMenuItemEnabled, EnableMenuItemIcon,
	DisableMenuItemIcon, IsMenuItemIconEnabled;
  export DeleteMCEntries, GetMCInfo, SetMCInfo, DisposeMCInfo,
	GetMCEntry, SetMCEntries;
  export GetMenuItemProperty, GetMenuItemPropertySize,
	SetMenuItemProperty, RemoveMenuItemProperty;
  export $gestaltContextualMenuAttr, $gestaltContextualMenuUnusedBit,
	$gestaltContextualMenuTrapAvailable, $kCMHelpItemNoHelp,
	$kCMHelpItemAppleGuide, $kCMHelpItemOtherHelp, $kCMNothingSelected,
	$kCMMenuItemSelected, $kCMShowHelpSelected, InitContextualMenus,
	IsShowContextualMenuClick, ContextualMenuSelect,
	ProcessIsContextualMenuClient;

  // from "CodeFragments.h":
  export $kCFragResourceType, $kCFragResourceID,
	$kCFragLibraryFileType, $kCFragAllFileTypes;
  export <CFragArchitecture>, <CFragArchitecture*>,
	<CFragArchitecture**>, $kPowerPCCFragArch, $kMotorola68KCFragArch,
	$kAnyCFragArch, $kCompiledCFragArch;
  export <CFragVersionNumber>, <CFragVersionNumber*>,
	<CFragVersionNumber**>, $kNullCFragVersion, $kWildcardCFragVersion;
  export <CFragUsage>, <CFragUsage*>, <CFragUsage**>,
	$kImportLibraryCFrag, $kApplicationCFrag, $kDropInAdditionCFrag,
	$kStubLibraryCFrag, $kWeakStubLibraryCFrag;
  export $kIsCompleteCFrag, $kFirstCFragUpdate;
  export $kCFragGoesToEOF;
  export <CFragLocatorKind>, <CFragLocatorKind*>,
	<CFragLocatorKind**>, $kMemoryCFragLocator, $kDataForkCFragLocator,
	$kResourceCFragLocator, $kByteStreamCFragLocator,
	$kNamedFragmentCFragLocator;
  export appStackSize-value, appStackSize-value-setter,
	<CFragUsage1Union>, <CFragUsage1Union*>, <CFragUsage1Union**>,
	appSubdirID-value, appSubdirID-value-setter, libFlags-value,
	libFlags-value-setter, <CFragUsage2Union>, <CFragUsage2Union*>,
	<CFragUsage2Union**>, $kCFragLibUsageMapPrivatelyMask;
  export spaceID-value, spaceID-value-setter, forkKind-value,
	forkKind-value-setter, <CFragWhere1Union>, <CFragWhere1Union*>,
	<CFragWhere1Union**>, forkInstance-value, forkInstance-value-setter,
	<CFragWhere2Union>, <CFragWhere2Union*>, <CFragWhere2Union**>,
	$kDefaultCFragNameLen;
  export architecture-value, architecture-value-setter,
	reservedA-value, reservedA-value-setter, reservedB-value,
	reservedB-value-setter, updateLevel-value, updateLevel-value-setter,
	currentVersion-value, currentVersion-value-setter,
	oldDefVersion-value, oldDefVersion-value-setter, uUsage1-value,
	uUsage1-value-setter, uUsage2-value, uUsage2-value-setter,
	usage-value, usage-value-setter, where-value, where-value-setter,
	offset-value, offset-value-setter, length-value, length-value-setter,
	uWhere1-value, uWhere1-value-setter, uWhere2-value,
	uWhere2-value-setter, extensionCount-value,
	extensionCount-value-setter, memberSize-value,
	memberSize-value-setter, name-array, name-array-setter, name-value,
	<CFragResourceMember>, <CFragResourceMember*>,
	<CFragResourceMember**>, <CFragResourceMemberPtr>,
	extensionKind-value, extensionKind-value-setter, extensionSize-value,
	extensionSize-value-setter, <CFragResourceExtensionHeader>,
	<CFragResourceExtensionHeader*>, <CFragResourceExtensionHeader**>,
	<CFragResourceExtensionHeaderPtr>, header-value, header-value-setter,
	libKind-value, libKind-value-setter, qualifiers-array,
	qualifiers-array-setter, qualifiers-value,
	<CFragResourceSearchExtension>, <CFragResourceSearchExtension*>,
	<CFragResourceSearchExtension**>, <CFragResourceSearchExtensionPtr>,
	$kCFragResourceSearchExtensionKind;
  export reservedA-value, reservedA-value-setter, reservedB-value,
	reservedB-value-setter, reservedC-value, reservedC-value-setter,
	version-value, version-value-setter, reservedD-value,
	reservedD-value-setter, reservedE-value, reservedE-value-setter,
	reservedF-value, reservedF-value-setter, reservedG-value,
	reservedG-value-setter, reservedH-value, reservedH-value-setter,
	memberCount-value, memberCount-value-setter, firstMember-value,
	firstMember-value-setter, <CFragResource>, <CFragResource*>,
	<CFragResource**>, <CFragResourcePtr>, <CFragResourceHandle>,
	$kCurrCFragResourceVersion;
  export <CFragConnectionID>, <CFragConnectionID*>,
	<CFragConnectionID**>, <CFragClosureID>, <CFragClosureID*>,
	<CFragClosureID**>, <CFragContainerID>, <CFragContainerID*>,
	<CFragContainerID**>, <CFragContextID>, <CFragContextID*>,
	<CFragContextID**>;
  export <CFragLoadOptions>, <CFragLoadOptions*>,
	<CFragLoadOptions**>, $kReferenceCFrag, $kFindCFrag,
	$kPrivateCFragCopy;
  export $kUnresolvedCFragSymbolAddress;
  export <CFragSymbolClass>, <CFragSymbolClass*>,
	<CFragSymbolClass**>, $kCodeCFragSymbol, $kDataCFragSymbol,
	$kTVectorCFragSymbol, $kTOCCFragSymbol, $kGlueCFragSymbol;
  export GetSharedLibrary, GetDiskFragment, GetMemFragment,
	CloseConnection, FindSymbol, CountSymbols, GetIndSymbol;
  export address-value, address-value-setter, length-value,
	length-value-setter, inPlace-value, inPlace-value-setter,
	reservedA-value, reservedA-value-setter, reservedB-value,
	reservedB-value-setter, <CFragSystem7MemoryLocator>,
	<CFragSystem7MemoryLocator*>, <CFragSystem7MemoryLocator**>,
	fileSpec-value, fileSpec-value-setter, offset-value,
	offset-value-setter, length-value, length-value-setter,
	<CFragSystem7DiskFlatLocator>, <CFragSystem7DiskFlatLocator*>,
	<CFragSystem7DiskFlatLocator**>, fileSpec-value,
	fileSpec-value-setter, rsrcType-value, rsrcType-value-setter,
	rsrcID-value, rsrcID-value-setter, reservedA-value,
	reservedA-value-setter, <CFragSystem7SegmentedLocator>,
	<CFragSystem7SegmentedLocator*>, <CFragSystem7SegmentedLocator**>,
	where-value, where-value-setter, onDisk-value, onDisk-value-setter,
	inMem-value, inMem-value-setter, inSegs-value, inSegs-value-setter,
	onDisk-value, onDisk-value-setter, inMem-value, inMem-value-setter,
	inSegs-value, inSegs-value-setter, u-value, u-value-setter,
	<CFragSystem7Locator>, <CFragSystem7Locator*>,
	<CFragSystem7Locator**>, <CFragSystem7LocatorPtr>, contextID-value,
	contextID-value-setter, closureID-value, closureID-value-setter,
	connectionID-value, connectionID-value-setter, fragLocator-value,
	fragLocator-value-setter, libName-value, libName-value-setter,
	reservedA-value, reservedA-value-setter, <CFragSystem7InitBlock>,
	<CFragSystem7InitBlock*>, <CFragSystem7InitBlock**>,
	<CFragSystem7InitBlockPtr>;
  export <CFragInitBlock>, <CFragInitBlock*>, <CFragInitBlock**>,
	<CFragInitBlockPtr>, <CFragInitBlockPtr*>, <CFragInitBlockPtr**>,
	<CFragInitFunction>, <CFragTermProcedure>;
  export $kLoadCFrag;

  // from "Icons.h":
  export $kGenericDocumentIconResource,
	$kGenericStationeryIconResource, $kGenericEditionFileIconResource,
	$kGenericApplicationIconResource, $kGenericDeskAccessoryIconResource,
	$kGenericFolderIconResource, $kPrivateFolderIconResource,
	$kFloppyIconResource, $kTrashIconResource,
	$kGenericRAMDiskIconResource, $kGenericCDROMIconResource,
	$kDesktopIconResource, $kOpenFolderIconResource,
	$kGenericHardDiskIconResource, $kGenericFileServerIconResource,
	$kGenericSuitcaseIconResource, $kGenericMoverObjectIconResource,
	$kGenericPreferencesIconResource, $kGenericQueryDocumentIconResource,
	$kGenericExtensionIconResource, $kSystemFolderIconResource,
	$kHelpIconResource, $kAppleMenuFolderIconResource,
	$genericDocumentIconResource, $genericStationeryIconResource,
	$genericEditionFileIconResource, $genericApplicationIconResource,
	$genericDeskAccessoryIconResource, $genericFolderIconResource,
	$privateFolderIconResource, $floppyIconResource, $trashIconResource,
	$genericRAMDiskIconResource, $genericCDROMIconResource,
	$desktopIconResource, $openFolderIconResource,
	$genericHardDiskIconResource, $genericFileServerIconResource,
	$genericSuitcaseIconResource, $genericMoverObjectIconResource,
	$genericPreferencesIconResource, $genericQueryDocumentIconResource,
	$genericExtensionIconResource, $systemFolderIconResource,
	$appleMenuFolderIconResource, $kStartupFolderIconResource,
	$kOwnedFolderIconResource, $kDropFolderIconResource,
	$kSharedFolderIconResource, $kMountedFolderIconResource,
	$kControlPanelFolderIconResource, $kPrintMonitorFolderIconResource,
	$kPreferencesFolderIconResource, $kExtensionsFolderIconResource,
	$kFontsFolderIconResource, $kFullTrashIconResource,
	$startupFolderIconResource, $ownedFolderIconResource,
	$dropFolderIconResource, $sharedFolderIconResource,
	$mountedFolderIconResource, $controlPanelFolderIconResource,
	$printMonitorFolderIconResource, $preferencesFolderIconResource,
	$extensionsFolderIconResource, $fontsFolderIconResource,
	$fullTrashIconResource;
  export $kHuge1BitMask, $kHuge4BitData, $kHuge8BitData,
	$kHuge32BitData, $kHuge8BitMask, $kLarge1BitMask, $kLarge4BitData,
	$kLarge8BitData, $kLarge32BitData, $kLarge8BitMask, $kSmall1BitMask,
	$kSmall4BitData, $kSmall8BitData, $kSmall32BitData, $kSmall8BitMask,
	$kMini1BitMask, $kMini4BitData, $kMini8BitData, $large1BitMask,
	$large4BitData, $large8BitData, $small1BitMask, $small4BitData,
	$small8BitData, $mini1BitMask, $mini4BitData, $mini8BitData,
	$kAlignNone, $kAlignVerticalCenter, $kAlignTop, $kAlignBottom,
	$kAlignHorizontalCenter, $kAlignAbsoluteCenter, $kAlignCenterTop,
	$kAlignCenterBottom, $kAlignLeft, $kAlignCenterLeft, $kAlignTopLeft,
	$kAlignBottomLeft, $kAlignRight, $kAlignCenterRight, $kAlignTopRight,
	$kAlignBottomRight, $atNone, $atVerticalCenter, $atTop, $atBottom,
	$atHorizontalCenter, $atAbsoluteCenter, $atCenterTop,
	$atCenterBottom, $atLeft, $atCenterLeft, $atTopLeft, $atBottomLeft,
	$atRight, $atCenterRight, $atTopRight, $atBottomRight;
  export <IconAlignmentType>, <IconAlignmentType*>,
	<IconAlignmentType**>, $kTransformNone, $kTransformDisabled,
	$kTransformOffline, $kTransformOpen, $kTransformLabel1,
	$kTransformLabel2, $kTransformLabel3, $kTransformLabel4,
	$kTransformLabel5, $kTransformLabel6, $kTransformLabel7,
	$kTransformSelected, $kTransformSelectedDisabled,
	$kTransformSelectedOffline, $kTransformSelectedOpen, $ttNone,
	$ttDisabled, $ttOffline, $ttOpen, $ttLabel1, $ttLabel2, $ttLabel3,
	$ttLabel4, $ttLabel5, $ttLabel6, $ttLabel7, $ttSelected,
	$ttSelectedDisabled, $ttSelectedOffline, $ttSelectedOpen;
  export <IconTransformType>, <IconTransformType*>,
	<IconTransformType**>, $kSelectorLarge1Bit, $kSelectorLarge4Bit,
	$kSelectorLarge8Bit, $kSelectorLarge32Bit, $kSelectorLarge8BitMask,
	$kSelectorSmall1Bit, $kSelectorSmall4Bit, $kSelectorSmall8Bit,
	$kSelectorSmall32Bit, $kSelectorSmall8BitMask, $kSelectorMini1Bit,
	$kSelectorMini4Bit, $kSelectorMini8Bit, $kSelectorHuge1Bit,
	$kSelectorHuge4Bit, $kSelectorHuge8Bit, $kSelectorHuge32Bit,
	$kSelectorHuge8BitMask, $kSelectorAllLargeData,
	$kSelectorAllSmallData, $kSelectorAllMiniData, $kSelectorAllHugeData,
	$kSelectorAll1BitData, $kSelectorAll4BitData, $kSelectorAll8BitData,
	$kSelectorAll32BitData, $kSelectorAllAvailableData;
  export $svLarge1Bit, $svLarge4Bit, $svLarge8Bit, $svSmall1Bit,
	$svSmall4Bit, $svSmall8Bit, $svMini1Bit, $svMini4Bit, $svMini8Bit,
	$svAllLargeData, $svAllSmallData, $svAllMiniData, $svAll1BitData,
	$svAll4BitData, $svAll8BitData, $svAllAvailableData;
  export <IconSelectorValue>, <IconSelectorValue*>,
	<IconSelectorValue**>, <IconActionProcPtr>, <IconActionUPP>,
	$uppIconActionProcInfo, <IconAction>, <IconAction*>, <IconAction**>,
	<IconGetterProcPtr>, <IconGetterUPP>, $uppIconGetterProcInfo,
	<IconGetter>, <IconGetter*>, <IconGetter**>, iconPMap-value,
	iconPMap-value-setter, iconMask-value, iconMask-value-setter,
	iconBMap-value, iconBMap-value-setter, iconData-value,
	iconData-value-setter, iconMaskData-array, iconMaskData-array-setter,
	iconMaskData-value, <CIcon>, <CIcon*>, <CIcon**>, <CIconPtr>,
	<CIconHandle>, GetCIcon, PlotCIcon, DisposeCIcon, GetIcon, PlotIcon;
  export <IconSuiteRef>, <IconSuiteRef*>, <IconSuiteRef**>,
	<IconCacheRef>, <IconCacheRef*>, <IconCacheRef**>, <IconRef>,
	<IconRef*>, <IconRef**>, PlotIconID, NewIconSuite, AddIconToSuite,
	GetIconFromSuite, ForEachIconDo, GetIconSuite, DisposeIconSuite,
	PlotIconSuite, MakeIconCache, LoadIconCache, PlotIconMethod,
	GetLabel, PtInIconID, PtInIconSuite, PtInIconMethod, RectInIconID,
	RectInIconSuite, RectInIconMethod, IconIDToRgn, IconSuiteToRgn,
	IconMethodToRgn, SetSuiteLabel, GetSuiteLabel, GetIconCacheData,
	SetIconCacheData, GetIconCacheProc, SetIconCacheProc, PlotIconHandle,
	PlotSICNHandle, PlotCIconHandle;
  export $kSystemIconsCreator;
  export $kClipboardIcon, $kClippingUnknownTypeIcon,
	$kClippingPictureTypeIcon, $kClippingTextTypeIcon,
	$kClippingSoundTypeIcon, $kDesktopIcon, $kFinderIcon,
	$kFontSuitcaseIcon, $kFullTrashIcon, $kGenericApplicationIcon,
	$kGenericCDROMIcon, $kGenericControlPanelIcon,
	$kGenericControlStripModuleIcon, $kGenericComponentIcon,
	$kGenericDeskAccessoryIcon, $kGenericDocumentIcon,
	$kGenericEditionFileIcon, $kGenericExtensionIcon,
	$kGenericFileServerIcon, $kGenericFontIcon, $kGenericFontScalerIcon,
	$kGenericFloppyIcon, $kGenericHardDiskIcon,
	$kGenericRemovableMediaIcon, $kGenericMoverObjectIcon,
	$kGenericPCCardIcon, $kGenericPreferencesIcon,
	$kGenericQueryDocumentIcon, $kGenericRAMDiskIcon,
	$kGenericSharedLibaryIcon, $kGenericStationeryIcon,
	$kGenericSuitcaseIcon, $kGenericWORMIcon, $kInternationResourcesIcon,
	$kKeyboardLayoutIcon, $kSoundFileIcon, $kSystemSuitcaseIcon,
	$kTrashIcon, $kTrueTypeFontIcon, $kTrueTypeFlatFontIcon,
	$kTrueTypeMultiFlatFontIcon, $kInternetLocationHTTPIcon,
	$kInternetLocationFTPIcon, $kInternetLocationAppleShareIcon,
	$kInternetLocationAppleTalkZoneIcon, $kInternetLocationFileIcon,
	$kInternetLocationMailIcon, $kInternetLocationNewsIcon,
	$kInternetLocationGenericIcon, $kGenericFolderIcon, $kDropFolderIcon,
	$kMountedFolderIcon, $kOpenFolderIcon, $kOwnedFolderIcon,
	$kPrivateFolderIcon, $kSharedFolderIcon,
	$kSharingPrivsNotApplicableIcon, $kSharingPrivsReadOnlyIcon,
	$kSharingPrivsReadWriteIcon, $kSharingPrivsUnknownIcon,
	$kSharingPrivsWritableIcon;
  export $kUserFolderIcon, $kWorkgroupFolderIcon, $kGuestUserIcon,
	$kUserIcon, $kOwnerIcon, $kGroupIcon, $kAppleExtrasFolderIcon,
	$kAppleMenuFolderIcon, $kApplicationsFolderIcon,
	$kApplicationSupportFolderIcon, $kAssistantsFolderIcon,
	$kContextualMenuItemsFolderIcon, $kControlPanelDisabledFolderIcon,
	$kControlPanelFolderIcon, $kControlStripModulesFolderIcon,
	$kDocumentsFolderIcon, $kExtensionsDisabledFolderIcon,
	$kExtensionsFolderIcon, $kFavoritesFolderIcon, $kFontsFolderIcon,
	$kHelpFolderIcon, $kInternetFolderIcon, $kInternetPlugInFolderIcon,
	$kMacOSReadMeFolderIcon, $kPreferencesFolderIcon,
	$kPrinterDescriptionFolderIcon, $kPrinterDriverFolderIcon,
	$kPrintMonitorFolderIcon, $kRecentApplicationsFolderIcon,
	$kRecentDocumentsFolderIcon, $kRecentServersFolderIcon,
	$kScriptingAdditionsFolderIcon, $kSharedLibrariesFolderIcon,
	$kScriptsFolderIcon, $kShutdownItemsDisabledFolderIcon,
	$kShutdownItemsFolderIcon, $kSpeakableItemsFolder,
	$kStartupItemsDisabledFolderIcon, $kStartupItemsFolderIcon,
	$kSystemExtensionDisabledFolderIcon, $kSystemFolderIcon,
	$kTextEncodingsFolderIcon, $kAppearanceFolderIcon,
	$kUtilitiesFolderIcon, $kVoicesFolderIcon, $kColorSyncFolderIcon,
	$kInternetSearchSitesFolderIcon, $kAppleScriptBadgeIcon,
	$kLockedBadgeIcon, $kMountedBadgeIcon, $kSharedBadgeIcon,
	$kAliasBadgeIcon, $kAlertNoteIcon, $kAlertCautionIcon,
	$kAlertStopIcon, $kAppleTalkIcon, $kAppleTalkZoneIcon,
	$kAFPServerIcon, $kFTPServerIcon, $kIPFileServerIcon,
	$kAppleLogoIcon, $kAppleMenuIcon, $kBackwardArrowIcon,
	$kFavoriteItemsIcon, $kForwardArrowIcon, $kGridIcon, $kHelpIcon,
	$kKeepArrangedIcon, $kLockedIcon, $kNoFilesIcon, $kNoFolderIcon,
	$kNoWriteIcon, $kProtectedApplicationFolderIcon,
	$kProtectedSystemFolderIcon, $kRecentItemsIcon, $kShortcutIcon,
	$kSortAscendingIcon, $kSortDescendingIcon, $kUnlockedIcon,
	$kConnectToIcon;
  export $invalidIconRefErr, $noSuchIconErr, $noIconDataAvailableErr;
  export <IconServicesUsageFlags>, <IconServicesUsageFlags*>,
	<IconServicesUsageFlags**>, $kIconServicesNormalUsageFlag;
  export $kIconFamilyType;
  export elementType-value, elementType-value-setter,
	elementSize-value, elementSize-value-setter, elementData-array,
	elementData-array-setter, elementData-value, <IconFamilyElement>,
	<IconFamilyElement*>, <IconFamilyElement**>, resourceType-value,
	resourceType-value-setter, resourceSize-value,
	resourceSize-value-setter, elements-array, elements-array-setter,
	elements-value, <IconFamilyResource>, <IconFamilyResource*>,
	<IconFamilyResource**>;
  export <IconFamilyPtr>, <IconFamilyHandle>;
  export IconServicesInit;
  export IconServicesTerminate;
  export IconRefToIconFamily;
  export IconFamilyToIconSuite;
  export IconSuiteToIconFamily;
  export SetIconFamilyData;
  export GetIconFamilyData;
  export GetIconRefOwners;
  export AcquireIconRef;
  export ReleaseIconRef;
  export GetIconRefFromFile;
  export GetIconRef;
  export GetIconRefFromFolder;
  export RegisterIconRefFromIconFamily;
  export RegisterIconRefFromResource;
  export UnregisterIconRef;
  export UpdateIconRef;
  export OverrideIconRefFromResource;
  export OverrideIconRef;
  export RemoveIconRefOverride;
  export CompositeIconRef;
  export IsIconRefComposite;
  export IsValidIconRef;
  export PlotIconRef;
  export PtInIconRef;
  export RectInIconRef;
  export IconRefToRgn;
  export GetIconSizesFromIconRef;
  export FlushIconRefs;
  export FlushIconRefsByVolume;
  export SetCustomIconsEnabled;
  export GetCustomIconsEnabled;

  // from "MacWindows.h":
  export <PropertyCreator>, <PropertyCreator*>, <PropertyCreator**>,
	<PropertyTag>, <PropertyTag*>, <PropertyTag**>, <WindowClass>,
	<WindowClass*>, <WindowClass**>, $kAlertWindowClass,
	$kMovableAlertWindowClass, $kModalWindowClass,
	$kMovableModalWindowClass, $kFloatingWindowClass,
	$kDocumentWindowClass;
  export <WindowAttributes>, <WindowAttributes*>,
	<WindowAttributes**>, $kWindowNoAttributes,
	$kWindowCloseBoxAttribute, $kWindowHorizontalZoomAttribute,
	$kWindowVerticalZoomAttribute, $kWindowFullZoomAttribute,
	$kWindowCollapseBoxAttribute, $kWindowResizableAttribute,
	$kWindowSideTitlebarAttribute, $kWindowNoUpdatesAttribute,
	$kWindowNoActivatesAttribute, $kWindowStandardDocumentAttributes,
	$kWindowStandardFloatingAttributes;
  export $gestaltWindowMgrAttr, $gestaltWindowMgrPresent;
  export $errInvalidWindowPtr,
	$errUnsupportedWindowAttributesForClass, $errWindowDoesNotHaveProxy,
	$errInvalidWindowProperty, $errWindowPropertyNotFound,
	$errUnrecognizedWindowClass, $errCorruptWindowDescription,
	$errUserWantsToDragWindow, $errWindowsAlreadyInitialized,
	$errFloatingWindowsNotInitialized;
  export $kWindowDefProcType, $kStandardWindowDefinition,
	$kRoundWindowDefinition, $kFloatingWindowDefinition,
	$kDocumentWindowVariantCode, $kModalDialogVariantCode,
	$kPlainDialogVariantCode, $kShadowDialogVariantCode,
	$kMovableModalDialogVariantCode, $kAlertVariantCode,
	$kMovableAlertVariantCode, $kSideFloaterVariantCode;
  export $documentProc, $dBoxProc, $plainDBox, $altDBoxProc,
	$noGrowDocProc, $movableDBoxProc, $zoomDocProc, $zoomNoGrow,
	$rDocProc, $floatProc, $floatGrowProc, $floatZoomProc,
	$floatZoomGrowProc, $floatSideProc, $floatSideGrowProc,
	$floatSideZoomProc, $floatSideZoomGrowProc;
  export $kWindowDocumentDefProcResID, $kWindowDialogDefProcResID,
	$kWindowUtilityDefProcResID, $kWindowUtilitySideTitleDefProcResID;
  export $kWindowDocumentProc, $kWindowGrowDocumentProc,
	$kWindowVertZoomDocumentProc, $kWindowVertZoomGrowDocumentProc,
	$kWindowHorizZoomDocumentProc, $kWindowHorizZoomGrowDocumentProc,
	$kWindowFullZoomDocumentProc, $kWindowFullZoomGrowDocumentProc;
  export $kWindowPlainDialogProc, $kWindowShadowDialogProc,
	$kWindowModalDialogProc, $kWindowMovableModalDialogProc,
	$kWindowAlertProc, $kWindowMovableAlertProc;
  export $kWindowMovableModalGrowProc;
  export $kWindowFloatProc, $kWindowFloatGrowProc,
	$kWindowFloatVertZoomProc, $kWindowFloatVertZoomGrowProc,
	$kWindowFloatHorizZoomProc, $kWindowFloatHorizZoomGrowProc,
	$kWindowFloatFullZoomProc, $kWindowFloatFullZoomGrowProc;
  export $kWindowFloatSideProc, $kWindowFloatSideGrowProc,
	$kWindowFloatSideVertZoomProc, $kWindowFloatSideVertZoomGrowProc,
	$kWindowFloatSideHorizZoomProc, $kWindowFloatSideHorizZoomGrowProc,
	$kWindowFloatSideFullZoomProc, $kWindowFloatSideFullZoomGrowProc;
  export $kWindowNoPosition, $kWindowDefaultPosition,
	$kWindowCenterMainScreen, $kWindowAlertPositionMainScreen,
	$kWindowStaggerMainScreen, $kWindowCenterParentWindow,
	$kWindowAlertPositionParentWindow, $kWindowStaggerParentWindow,
	$kWindowCenterParentWindowScreen,
	$kWindowAlertPositionParentWindowScreen,
	$kWindowStaggerParentWindowScreen;
  export <WindowPositionMethod>, <WindowPositionMethod*>,
	<WindowPositionMethod**>, $kWindowCenterOnMainScreen,
	$kWindowCenterOnParentWindow, $kWindowCenterOnParentWindowScreen,
	$kWindowCascadeOnMainScreen, $kWindowCascadeOnParentWindow,
	$kWIndowCascadeOnParentWindowScreen,
	$kWindowAlertPositionOnMainScreen,
	$kWindowAlertPositionOnParentWindow,
	$kWindowAlertPositionOnParentWindowScreen;
  export $kWindowTitleBarRgn, $kWindowTitleTextRgn,
	$kWindowCloseBoxRgn, $kWindowZoomBoxRgn, $kWindowDragRgn,
	$kWindowGrowRgn, $kWindowCollapseBoxRgn, $kWindowTitleProxyIconRgn,
	$kWindowStructureRgn, $kWindowContentRgn;
  export <WindowRegionCode>, <WindowRegionCode*>,
	<WindowRegionCode**>, winRgn-value, winRgn-value-setter,
	regionCode-value, regionCode-value-setter, <GetWindowRegionRec>,
	<GetWindowRegionRec*>, <GetWindowRegionRec**>;
  export <GetWindowRegionPtr>, <GetWindowRegionRecPtr>;
  export imageGWorld-value, imageGWorld-value-setter, imageRgn-value,
	imageRgn-value-setter, outlineRgn-value, outlineRgn-value-setter,
	<SetupWindowProxyDragImageRec>, <SetupWindowProxyDragImageRec*>,
	<SetupWindowProxyDragImageRec**>, fullTitleWidth-value,
	fullTitleWidth-value-setter, titleTextWidth-value,
	titleTextWidth-value-setter, isUnicodeTitle-value,
	isUnicodeTitle-value-setter, unused-value, unused-value-setter,
	<MeasureWindowTitleRec>, <MeasureWindowTitleRec*>,
	<MeasureWindowTitleRec**>, <MeasureWindowTitleRecPtr>, $dialogKind,
	$userKind, $kDialogWindowKind, $kApplicationWindowKind;
  export $inDesk, $inNoWindow, $inMenuBar, $inSysWindow, $inContent,
	$inDrag, $inGrow, $inGoAway, $inZoomIn, $inZoomOut, $inCollapseBox,
	$inProxyIcon;
  export $wNoHit, $wInContent, $wInDrag, $wInGrow, $wInGoAway,
	$wInZoomIn, $wInZoomOut, $wInCollapseBox, $wInProxyIcon;
  export $kWindowMsgDraw, $kWindowMsgHitTest,
	$kWindowMsgCalculateShape, $kWindowMsgInitialize, $kWindowMsgCleanUp,
	$kWindowMsgDrawGrowOutline, $kWindowMsgDrawGrowBox,
	$kWindowMsgGetFeatures, $kWindowMsgGetRegion, $kWindowMsgDragHilite,
	$kWindowMsgModified, $kWindowMsgDrawInCurrentPort,
	$kWindowMsgSetupProxyDragImage, $kWindowMsgStateChanged,
	$kWindowMsgMeasureTitle, $wDraw, $wHit, $wCalcRgns, $wNew, $wDispose,
	$wGrow, $wDrawGIcon, $kWindowStateTitleChanged,
	$kWindowStateSizeChanged, $kWindowStatePositionChanged,
	$kWindowStateZOrderChanged, $kWindowStateVisibilityChanged,
	$kWindowStateHiliteChanged, $kWindowStateCollapseChanged;
  export $kWindowCanGrow, $kWindowCanZoom, $kWindowCanCollapse,
	$kWindowIsModal, $kWindowCanGetWindowRegion, $kWindowIsAlert,
	$kWindowHasTitleBar, $kWindowSupportsDragHilite,
	$kWindowSupportsModifiedBit, $kWindowCanDrawInCurrentPort,
	$kWindowCanSetupProxyDragImage, $kWindowCanMeasureTitle,
	$kWindowWantsDisposeAtProcessDeath;
  export $deskPatID;
  export $wContentColor, $wFrameColor, $wTextColor, $wHiliteColor,
	$wTitleBarColor;
  export $kMouseUpOutOfSlop;
  export wCSeed-value, wCSeed-value-setter, ctSize-value,
	ctSize-value-setter, ctTable-array, ctTable-array-setter,
	ctTable-value, <WinCTab>, <WinCTab*>, <WinCTab**>;
  export <WCTabPtr>, <WCTabHandle>, <WindowRecord*>, <WindowRecord**>,
	<WindowPeek>, port-value, port-value-setter, windowKind-value,
	windowKind-value-setter, visible-value, visible-value-setter,
	hilited-value, hilited-value-setter, goAwayFlag-value,
	goAwayFlag-value-setter, strucRgn-value, strucRgn-value-setter,
	contRgn-value, contRgn-value-setter, updateRgn-value,
	updateRgn-value-setter, windowDefProc-value,
	windowDefProc-value-setter, dataHandle-value,
	dataHandle-value-setter, titleHandle-value, titleHandle-value-setter,
	titleWidth-value, titleWidth-value-setter, controlList-value,
	controlList-value-setter, nextWindow-value, nextWindow-value-setter,
	windowPic-value, windowPic-value-setter, refCon-value,
	refCon-value-setter, <WindowRecord>, <CWindowRecord*>,
	<CWindowRecord**>, <CWindowPeek>, port-value, port-value-setter,
	windowKind-value, windowKind-value-setter, visible-value,
	visible-value-setter, hilited-value, hilited-value-setter,
	goAwayFlag-value, goAwayFlag-value-setter, strucRgn-value,
	strucRgn-value-setter, contRgn-value, contRgn-value-setter,
	updateRgn-value, updateRgn-value-setter, windowDefProc-value,
	windowDefProc-value-setter, dataHandle-value,
	dataHandle-value-setter, titleHandle-value, titleHandle-value-setter,
	titleWidth-value, titleWidth-value-setter, controlList-value,
	controlList-value-setter, nextWindow-value, nextWindow-value-setter,
	windowPic-value, windowPic-value-setter, refCon-value,
	refCon-value-setter, <CWindowRecord>, <AuxWinRec*>, <AuxWinRec**>,
	<AuxWinPtr>, <AuxWinHandle>, awNext-value, awNext-value-setter,
	awOwner-value, awOwner-value-setter, awCTable-value,
	awCTable-value-setter, reserved-value, reserved-value-setter,
	awFlags-value, awFlags-value-setter, awRefCon-value,
	awRefCon-value-setter, <AuxWinRec>, $kWindowDefinitionVersionOne,
	$kWindowDefinitionVersionTwo, $kWindowIsCollapsedState;
  export descriptionSize-value, descriptionSize-value-setter,
	windowContentRect-value, windowContentRect-value-setter,
	windowZoomRect-value, windowZoomRect-value-setter,
	windowRefCon-value, windowRefCon-value-setter,
	windowStateFlags-value, windowStateFlags-value-setter,
	windowPositionMethod-value, windowPositionMethod-value-setter,
	windowDefinitionVersion-value, windowDefinitionVersion-value-setter,
	windowDefProc-value, windowDefProc-value-setter,
	windowHasCloseBox-value, windowHasCloseBox-value-setter,
	windowDefProc-value, windowDefProc-value-setter,
	windowHasCloseBox-value, windowHasCloseBox-value-setter,
	versionOne-value, windowClass-value, windowClass-value-setter,
	windowAttributes-value, windowAttributes-value-setter,
	windowClass-value, windowClass-value-setter, windowAttributes-value,
	windowAttributes-value-setter, versionTwo-value, windowDefProc-value,
	windowDefProc-value-setter, windowHasCloseBox-value,
	windowHasCloseBox-value-setter, windowDefProc-value,
	windowDefProc-value-setter, windowHasCloseBox-value,
	windowHasCloseBox-value-setter, versionOne-value, windowClass-value,
	windowClass-value-setter, windowAttributes-value,
	windowAttributes-value-setter, windowClass-value,
	windowClass-value-setter, windowAttributes-value,
	windowAttributes-value-setter, versionTwo-value,
	windowDefinition-value, windowDefinition-value-setter,
	<BasicWindowDescription>, <BasicWindowDescription*>,
	<BasicWindowDescription**>, $kStoredWindowSystemTag,
	$kStoredBasicWindowDescriptionID, $kStoredWindowPascalTitleID,
	$kFirstWindowOfClass, $kLastWindowOfClass, userState-value,
	userState-value-setter, stdState-value, stdState-value-setter,
	<WStateData>, <WStateData*>, <WStateData**>, <WStateDataPtr>,
	<WStateDataHandle>, GetNewCWindow, NewWindow, GetNewWindow,
	NewCWindow, DisposeWindow, MacCloseWindow;
  export CreateNewWindow, CreateWindowFromResource,
	StoreWindowIntoCollection, CreateWindowFromCollection,
	GetWindowOwnerCount, CloneWindow;
  export GetWindowClass, GetWindowAttributes;
  export ShowFloatingWindows, HideFloatingWindows,
	AreFloatingWindowsVisible, FrontNonFloatingWindow;
  export SetWinColor, SetDeskCPat, SetWindowContentColor,
	GetWindowContentColor, GetWindowContentPattern,
	SetWindowContentPattern;
  export ClipAbove, SaveOld, DrawNew, PaintOne, PaintBehind, CalcVis,
	CalcVisBehind, CheckUpdate;
  export MacFindWindow, FrontWindow, BringToFront, SendBehind,
	SelectWindow;
  export InitWindows, GetWMgrPort, GetCWMgrPort, IsValidWindowPtr,
	InitFloatingWindows;
  export HiliteWindow, SetWRefCon, GetWRefCon, SetWindowPic,
	GetWindowPic, GetWVariant, GetWindowFeatures, GetWindowRegion;
  export InvalRect, InvalRgn, ValidRect, ValidRgn, BeginUpdate,
	EndUpdate, InvalWindowRgn, InvalWindowRect, ValidWindowRgn,
	ValidWindowRect;
  export DrawGrowIcon, SetWTitle, GetWTitle, SetWindowProxyFSSpec,
	GetWindowProxyFSSpec, SetWindowProxyAlias, GetWindowProxyAlias,
	SetWindowProxyCreatorAndType, GetWindowProxyIcon, SetWindowProxyIcon,
	RemoveWindowProxy, BeginWindowProxyDrag, EndWindowProxyDrag,
	TrackWindowProxyFromExistingDrag, TrackWindowProxyDrag,
	IsWindowModified, SetWindowModified, IsWindowPathSelectClick,
	WindowPathSelect;
  export HiliteWindowFrameForDrag;
  export <WindowTransitionEffect>, <WindowTransitionEffect*>,
	<WindowTransitionEffect**>, $kWindowZoomTransitionEffect;
  export <WindowTransitionAction>, <WindowTransitionAction*>,
	<WindowTransitionAction**>, $kWindowShowTransitionAction,
	$kWindowHideTransitionAction;
  export MacMoveWindow, SizeWindow, GrowWindow, DragWindow,
	ZoomWindow, IsWindowCollapsable, IsWindowCollapsed, CollapseWindow,
	CollapseAllWindows, RepositionWindow, SetWindowBounds,
	GetWindowBounds, MoveWindowStructure, ResizeWindow,
	IsWindowInStandardState, ZoomWindowIdeal, GetWindowIdealUserState,
	SetWindowIdealUserState;
  export HideWindow, MacShowWindow, ShowHide;
  export GetWindowProperty, GetWindowPropertySize, SetWindowProperty,
	RemoveWindowProperty, PinRect;
  export GetGrayRgn;
  export TrackBox, TrackGoAway;
  export DragGrayRgn, DragTheRgn;
  export GetAuxWin, <WindowDefProcPtr>, <DeskHookProcPtr>,
	<WindowDefUPP>, <DeskHookUPP>, $uppWindowDefProcInfo,
	$uppDeskHookProcInfo;

  // from "TextEdit.h":
  export <TERec*>, <TERec**>, <TEPtr>, <TEHandle>, <HighHookProcPtr>,
	<EOLHookProcPtr>, <CaretHookProcPtr>, <WidthHookProcPtr>,
	<TextWidthHookProcPtr>, <NWidthHookProcPtr>, <DrawHookProcPtr>,
	<HitTestHookProcPtr>, <TEFindWordProcPtr>, <TERecalcProcPtr>,
	<TEDoTextProcPtr>, <TEClickLoopProcPtr>, <WordBreakProcPtr>,
	<HighHookUPP>, <EOLHookUPP>, <CaretHookUPP>, <WidthHookUPP>,
	<TextWidthHookUPP>, <NWidthHookUPP>, <DrawHookUPP>, <HitTestHookUPP>,
	<TEFindWordUPP>, <TERecalcUPP>, <TEDoTextUPP>, <TEClickLoopUPP>,
	<WordBreakUPP>, destRect-value, destRect-value-setter,
	viewRect-value, viewRect-value-setter, selRect-value,
	selRect-value-setter, lineHeight-value, lineHeight-value-setter,
	fontAscent-value, fontAscent-value-setter, selPoint-value,
	selPoint-value-setter, selStart-value, selStart-value-setter,
	selEnd-value, selEnd-value-setter, active-value, active-value-setter,
	wordBreak-value, wordBreak-value-setter, clickLoop-value,
	clickLoop-value-setter, clickTime-value, clickTime-value-setter,
	clickLoc-value, clickLoc-value-setter, caretTime-value,
	caretTime-value-setter, caretState-value, caretState-value-setter,
	just-value, just-value-setter, teLength-value, teLength-value-setter,
	hText-value, hText-value-setter, hDispatchRec-value,
	hDispatchRec-value-setter, clikStuff-value, clikStuff-value-setter,
	crOnly-value, crOnly-value-setter, txFont-value, txFont-value-setter,
	txFace-value, txFace-value-setter, txMode-value, txMode-value-setter,
	txSize-value, txSize-value-setter, inPort-value, inPort-value-setter,
	highHook-value, highHook-value-setter, caretHook-value,
	caretHook-value-setter, nLines-value, nLines-value-setter,
	lineStarts-array, lineStarts-array-setter, lineStarts-value, <TERec>;
  export $teJustLeft, $teJustCenter, $teJustRight, $teForceLeft,
	$teFlushDefault, $teCenter, $teFlushRight, $teFlushLeft;
  export $fontBit, $faceBit, $sizeBit, $clrBit, $addSizeBit,
	$toggleBit;
  export $doFont, $doFace, $doSize, $doColor, $doAll, $addSize,
	$doToggle;
  export $EOLHook, $DRAWHook, $WIDTHHook, $HITTESTHook, $nWIDTHHook,
	$TextWidthHook;
  export $intEOLHook, $intDrawHook, $intWidthHook, $intHitTestHook,
	$intNWidthHook, $intTextWidthHook, $intInlineInputTSMTEPreUpdateHook,
	$intInlineInputTSMTEPostUpdateHook;
  export $teFAutoScroll, $teFTextBuffering, $teFOutlineHilite,
	$teFInlineInput, $teFUseWhiteBackground, $teFUseInlineInput,
	$teFInlineInputAutoScroll;
  export $teBitClear, $teBitSet, $teBitTest;
  export $teWordSelect, $teWordDrag, $teFromFind, $teFromRecal;
  export $teFind, $teHighlight, $teDraw, $teCaret;
  export <CharsPtr>, <CharsPtr*>, <CharsPtr**>, <CharsHandle>,
	startChar-value, startChar-value-setter, styleIndex-value,
	styleIndex-value-setter, <StyleRun>, <StyleRun*>, <StyleRun**>,
	stCount-value, stCount-value-setter, stHeight-value,
	stHeight-value-setter, stAscent-value, stAscent-value-setter,
	stFont-value, stFont-value-setter, stFace-value, stFace-value-setter,
	stSize-value, stSize-value-setter, stColor-value,
	stColor-value-setter, <STElement>, <STElement*>, <STElement**>;
  export <STPtr>, <STHandle>, lhHeight-value, lhHeight-value-setter,
	lhAscent-value, lhAscent-value-setter, <LHElement>, <LHElement*>,
	<LHElement**>;
  export <LHPtr>, <LHHandle>, scrpStartChar-value,
	scrpStartChar-value-setter, scrpHeight-value,
	scrpHeight-value-setter, scrpAscent-value, scrpAscent-value-setter,
	scrpFont-value, scrpFont-value-setter, scrpFace-value,
	scrpFace-value-setter, scrpSize-value, scrpSize-value-setter,
	scrpColor-value, scrpColor-value-setter, <ScrpSTElement>,
	<ScrpSTElement*>, <ScrpSTElement**>;
  export scrpNStyles-value, scrpNStyles-value-setter,
	scrpStyleTab-value, scrpStyleTab-value-setter, <StScrpRec>,
	<StScrpRec*>, <StScrpRec**>;
  export <StScrpPtr>, <StScrpHandle>, nullScrap-value,
	nullScrap-value-setter, <NullStRec>, <NullStRec*>, <NullStRec**>;
  export <NullStPtr>, <NullStHandle>, nRuns-value, nRuns-value-setter,
	nStyles-value, nStyles-value-setter, styleTab-value,
	styleTab-value-setter, lhTab-value, lhTab-value-setter,
	teRefCon-value, teRefCon-value-setter, nullStyle-value,
	nullStyle-value-setter, runs-array, runs-array-setter, runs-value,
	<TEStyleRec>, <TEStyleRec*>, <TEStyleRec**>;
  export <TEStylePtr>, <TEStyleHandle>, tsFont-value,
	tsFont-value-setter, tsFace-value, tsFace-value-setter, tsSize-value,
	tsSize-value-setter, tsColor-value, tsColor-value-setter,
	<TextStyle>, <TextStyle*>, <TextStyle**>, <TextStylePtr>,
	<TextStyleHandle>;
  export <TEIntHook>, <TEIntHook*>, <TEIntHook**>,
	$uppHighHookProcInfo, $uppEOLHookProcInfo, $uppCaretHookProcInfo,
	$uppWidthHookProcInfo, $uppTextWidthHookProcInfo,
	$uppNWidthHookProcInfo, $uppDrawHookProcInfo,
	$uppHitTestHookProcInfo, $uppTEFindWordProcInfo,
	$uppTERecalcProcInfo, $uppTEDoTextProcInfo, $uppTEClickLoopProcInfo,
	$uppWordBreakProcInfo, $teFUseTextServices;
  export TEScrapHandle;
  export TEGetScrapLength, TEInit, TENew, TEDispose, TESetText,
	TEGetText, TEIdle, TESetSelect, TEActivate, TEDeactivate, TEKey,
	TECut, TECopy, TEPaste, TEDelete, TEInsert, TESetAlignment, TEUpdate,
	TETextBox, TEScroll, TESelView, TEPinScroll, TEAutoView, TECalText,
	TEGetOffset, TEGetPoint, TEClick, TEStyleNew, TESetStyleHandle,
	TEGetStyleHandle, TEGetStyle, TEStylePaste, TESetStyle,
	TEReplaceStyle, TEGetStyleScrapHandle, TEStyleInsert, TEGetHeight,
	TEContinuousStyle, TEUseStyleScrap, TECustomHook, TENumStyles,
	TEFeatureFlag, TEGetHiliteRgn, TESetScrapLength, TEFromScrap,
	TEToScrap, TESetClickLoop, TESetWordBreak;

  // from "Controls.h":
  export $_ControlDispatch, $gestaltControlMgrAttr,
	$gestaltControlMgrPresent, $kControlDefProcType,
	$kControlTemplateResourceType, $kControlColorTableResourceType,
	$kControlDefProcResourceType, $kControlTabListResType,
	$kControlListDescResType, controlRect-value,
	controlRect-value-setter, controlValue-value,
	controlValue-value-setter, controlVisible-value,
	controlVisible-value-setter, fill-value, fill-value-setter,
	controlMaximum-value, controlMaximum-value-setter,
	controlMinimum-value, controlMinimum-value-setter,
	controlDefProcID-value, controlDefProcID-value-setter,
	controlReference-value, controlReference-value-setter,
	controlTitle-value, controlTitle-value-setter, <ControlTemplate>,
	<ControlTemplate*>, <ControlTemplate**>, <ControlTemplatePtr>,
	<ControlTemplateHandle>;
  export <ControlRecord*>, <ControlRecord**>, <ControlPtr>,
	<ControlHandle>, <ControlRef>, <ControlRef*>, <ControlRef**>,
	<ControlPartCode>, <ControlPartCode*>, <ControlPartCode**>,
	<ControlActionProcPtr>, <ControlActionUPP>, nextControl-value,
	nextControl-value-setter, contrlOwner-value,
	contrlOwner-value-setter, contrlRect-value, contrlRect-value-setter,
	contrlVis-value, contrlVis-value-setter, contrlHilite-value,
	contrlHilite-value-setter, contrlValue-value,
	contrlValue-value-setter, contrlMin-value, contrlMin-value-setter,
	contrlMax-value, contrlMax-value-setter, contrlDefProc-value,
	contrlDefProc-value-setter, contrlData-value,
	contrlData-value-setter, contrlAction-value,
	contrlAction-value-setter, contrlRfCon-value,
	contrlRfCon-value-setter, contrlTitle-value,
	contrlTitle-value-setter, <ControlRecord>, $uppControlActionProcInfo,
	$cFrameColor, $cBodyColor, $cTextColor, $cThumbColor,
	$kNumberCtlCTabEntries;
  export ccSeed-value, ccSeed-value-setter, ccRider-value,
	ccRider-value-setter, ctSize-value, ctSize-value-setter,
	ctTable-array, ctTable-array-setter, ctTable-value, <CtlCTab>,
	<CtlCTab*>, <CtlCTab**>;
  export <CCTabPtr>, <CCTabHandle>, acNext-value, acNext-value-setter,
	acOwner-value, acOwner-value-setter, acCTable-value,
	acCTable-value-setter, acFlags-value, acFlags-value-setter,
	acRefCon-value, acRefCon-value-setter, <AuxCtlRec>, <AuxCtlRec*>,
	<AuxCtlRec**>;
  export <AuxCtlPtr>, <AuxCtlHandle>, mHandle-value,
	mHandle-value-setter, mID-value, mID-value-setter,
	<PopupPrivateData>, <PopupPrivateData*>, <PopupPrivateData**>,
	<PopupPrivateDataPtr>, <PopupPrivateDataHandle>,
	$errMessageNotSupported, $errDataNotSupported,
	$errControlDoesntSupportFocus, $errWindowDoesntSupportFocus,
	$errUnknownControl, $errCouldntSetFocus, $errNoRootControl,
	$errRootAlreadyExists, $errInvalidPartCode, $errControlsAlreadyExist,
	$errControlIsNotEmbedder, $errDataSizeMismatch,
	$errControlHiddenOrDisabled, $errWindowRegionCodeInvalid,
	$errCantEmbedIntoSelf, $errCantEmbedRoot, $errItemNotControl,
	$controlInvalidDataVersionErr, $controlPropertyInvalid,
	$controlPropertyNotFoundErr, $controlHandleInvalidErr;
  export $pushButProc, $checkBoxProc, $radioButProc, $scrollBarProc,
	$popupMenuProc;
  export $kControlSupportsNewMessages, $kControlFocusNoPart,
	$kControlFocusNextPart, $kControlFocusPrevPart;
  export <ControlFocusPart>, <ControlFocusPart*>,
	<ControlFocusPart**>, $kControlEntireControl,
	$kControlKeyFilterBlockKey, $kControlKeyFilterPassKey;
  export <ControlKeyFilterResult>, <ControlKeyFilterResult*>,
	<ControlKeyFilterResult**>, $kControlKeyScriptBehaviorAllowAnyScript,
	$kControlKeyScriptBehaviorPrefersRoman,
	$kControlKeyScriptBehaviorRequiresRoman;
  export <ControlKeyScriptBehavior>, <ControlKeyScriptBehavior*>,
	<ControlKeyScriptBehavior**>, $kControlFontBigSystemFont,
	$kControlFontSmallSystemFont, $kControlFontSmallBoldSystemFont,
	$kControlUseFontMask, $kControlUseFaceMask, $kControlUseSizeMask,
	$kControlUseForeColorMask, $kControlUseBackColorMask,
	$kControlUseModeMask, $kControlUseJustMask, $kControlUseAllMask,
	$kControlAddFontSizeMask, $kControlAddToMetaFontMask;
  export flags-value, flags-value-setter, font-value,
	font-value-setter, size-value, size-value-setter, style-value,
	style-value-setter, mode-value, mode-value-setter, just-value,
	just-value-setter, foreColor-value, foreColor-value-setter,
	backColor-value, backColor-value-setter, <ControlFontStyleRec>,
	<ControlFontStyleRec*>, <ControlFontStyleRec**>;
  export <ControlFontStylePtr>, $kControlFontStyleTag,
	$kControlKeyFilterTag;
  export $kControlSupportsGhosting, $kControlSupportsEmbedding,
	$kControlSupportsFocus, $kControlWantsIdle, $kControlWantsActivate,
	$kControlHandlesTracking, $kControlSupportsDataAccess,
	$kControlHasSpecialBackground, $kControlGetsFocusOnClick,
	$kControlSupportsCalcBestRect, $kControlSupportsLiveFeedback,
	$kControlHasRadioBehavior, $kControlAutoToggles,
	$kControlSupportsGetRegion, $kControlMsgDrawGhost,
	$kControlMsgCalcBestRect, $kControlMsgHandleTracking,
	$kControlMsgFocus, $kControlMsgKeyDown, $kControlMsgIdle,
	$kControlMsgGetFeatures, $kControlMsgSetData, $kControlMsgGetData,
	$kControlMsgActivate, $kControlMsgSetUpBackground,
	$kControlMsgCalcValueFromPos, $kControlMsgTestNewMsgSupport,
	$kControlMsgSubValueChanged, $kControlMsgSubControlAdded,
	$kControlMsgSubControlRemoved, $kControlMsgApplyTextColor,
	$kControlMsgGetRegion, startPt-value, startPt-value-setter,
	modifiers-value, modifiers-value-setter, action-value,
	action-value-setter, <ControlTrackingRec>, <ControlTrackingRec*>,
	<ControlTrackingRec**>;
  export <ControlTrackingPtr>, modifiers-value,
	modifiers-value-setter, keyCode-value, keyCode-value-setter,
	charCode-value, charCode-value-setter, <ControlKeyDownRec>,
	<ControlKeyDownRec*>, <ControlKeyDownRec**>;
  export <ControlKeyDownPtr>, tag-value, tag-value-setter, part-value,
	part-value-setter, size-value, size-value-setter, dataPtr-value,
	dataPtr-value-setter, <ControlDataAccessRec>,
	<ControlDataAccessRec*>, <ControlDataAccessRec**>;
  export <ControlDataAccessPtr>, height-value, height-value-setter,
	width-value, width-value-setter, baseLine-value,
	baseLine-value-setter, <ControlCalcSizeRec>, <ControlCalcSizeRec*>,
	<ControlCalcSizeRec**>;
  export <ControlCalcSizePtr>, depth-value, depth-value-setter,
	colorDevice-value, colorDevice-value-setter, <ControlBackgroundRec>,
	<ControlBackgroundRec*>, <ControlBackgroundRec**>;
  export <ControlBackgroundPtr>, depth-value, depth-value-setter,
	colorDevice-value, colorDevice-value-setter, active-value,
	active-value-setter, <ControlApplyTextColorRec>,
	<ControlApplyTextColorRec*>, <ControlApplyTextColorRec**>;
  export <ControlApplyTextColorPtr>, region-value,
	region-value-setter, part-value, part-value-setter,
	<ControlGetRegionRec>, <ControlGetRegionRec*>,
	<ControlGetRegionRec**>;
  export <ControlGetRegionPtr>, <ControlKeyFilterProcPtr>,
	<ControlKeyFilterUPP>, $uppControlKeyFilterProcInfo,
	$kControlBevelButtonSmallBevelProc,
	$kControlBevelButtonNormalBevelProc,
	$kControlBevelButtonLargeBevelProc;
  export $kControlBevelButtonAlignSysDirection,
	$kControlBevelButtonAlignCenter, $kControlBevelButtonAlignLeft,
	$kControlBevelButtonAlignRight, $kControlBevelButtonAlignTop,
	$kControlBevelButtonAlignBottom, $kControlBevelButtonAlignTopLeft,
	$kControlBevelButtonAlignBottomLeft,
	$kControlBevelButtonAlignTopRight,
	$kControlBevelButtonAlignBottomRight;
  export <ControlButtonGraphicAlignment>,
	<ControlButtonGraphicAlignment*>, <ControlButtonGraphicAlignment**>,
	$kControlBevelButtonAlignTextSysDirection,
	$kControlBevelButtonAlignTextCenter,
	$kControlBevelButtonAlignTextFlushRight,
	$kControlBevelButtonAlignTextFlushLeft;
  export <ControlButtonTextAlignment>, <ControlButtonTextAlignment*>,
	<ControlButtonTextAlignment**>,
	$kControlBevelButtonPlaceSysDirection,
	$kControlBevelButtonPlaceNormally,
	$kControlBevelButtonPlaceToRightOfGraphic,
	$kControlBevelButtonPlaceToLeftOfGraphic,
	$kControlBevelButtonPlaceBelowGraphic,
	$kControlBevelButtonPlaceAboveGraphic;
  export <ControlButtonTextPlacement>, <ControlButtonTextPlacement*>,
	<ControlButtonTextPlacement**>,
	$kControlBevelButtonSmallBevelVariant,
	$kControlBevelButtonNormalBevelVariant,
	$kControlBevelButtonLargeBevelVariant,
	$kControlBevelButtonMenuOnRight, $kControlBehaviorPushbutton,
	$kControlBehaviorToggles, $kControlBehaviorSticky,
	$kControlBehaviorMultiValueMenu, $kControlBehaviorOffsetContents,
	$kControlBehaviorCommandMenu, $kControlContentTextOnly,
	$kControlContentIconSuiteRes, $kControlContentCIconRes,
	$kControlContentPictRes, $kControlContentIconSuiteHandle,
	$kControlContentCIconHandle, $kControlContentPictHandle,
	$kControlContentIconRef;
  export <ControlContentType>, <ControlContentType*>,
	<ControlContentType**>, $kControlBevelButtonContentTag,
	$kControlBevelButtonTransformTag, $kControlBevelButtonTextAlignTag,
	$kControlBevelButtonTextOffsetTag,
	$kControlBevelButtonGraphicAlignTag,
	$kControlBevelButtonGraphicOffsetTag,
	$kControlBevelButtonTextPlaceTag, $kControlBevelButtonMenuValueTag,
	$kControlBevelButtonMenuHandleTag,
	$kControlBevelButtonCenterPopupGlyphTag,
	$kControlBevelButtonLastMenuTag, $kControlBevelButtonMenuDelayTag,
	$kControlBevelButtonScaleIconTag, contentType-value,
	contentType-value-setter, resID-value, resID-value-setter,
	cIconHandle-value, cIconHandle-value-setter, iconSuite-value,
	iconSuite-value-setter, iconRef-value, iconRef-value-setter,
	picture-value, picture-value-setter, resID-value, resID-value-setter,
	cIconHandle-value, cIconHandle-value-setter, iconSuite-value,
	iconSuite-value-setter, iconRef-value, iconRef-value-setter,
	picture-value, picture-value-setter, u-value, u-value-setter,
	<ControlButtonContentInfo>, <ControlButtonContentInfo*>,
	<ControlButtonContentInfo**>, <ControlButtonContentInfoPtr>,
	$kControlSliderProc, $kControlSliderLiveFeedback,
	$kControlSliderHasTickMarks, $kControlSliderReverseDirection,
	$kControlSliderNonDirectional;
  export $kControlTriangleProc, $kControlTriangleLeftFacingProc,
	$kControlTriangleAutoToggleProc,
	$kControlTriangleLeftFacingAutoToggleProc;
  export $kControlTriangleLastValueTag, $kControlProgressBarProc;
  export $kControlProgressBarIndeterminateTag,
	$kControlLittleArrowsProc, $kControlChasingArrowsProc,
	$kControlTabLargeProc, $kControlTabSmallProc,
	$kControlTabLargeNorthProc, $kControlTabSmallNorthProc,
	$kControlTabLargeSouthProc, $kControlTabSmallSouthProc,
	$kControlTabLargeEastProc, $kControlTabSmallEastProc,
	$kControlTabLargeWestProc, $kControlTabSmallWestProc;
  export $kControlTabContentRectTag, $kControlTabEnabledFlagTag,
	$kControlTabFontStyleTag, $kControlTabInfoTag;
  export $kControlTabInfoVersionZero;
  export version-value, version-value-setter, iconSuiteID-value,
	iconSuiteID-value-setter, name-value, name-value-setter,
	<ControlTabInfoRec>, <ControlTabInfoRec*>, <ControlTabInfoRec**>,
	$kControlSeparatorLineProc;
  export $kControlGroupBoxTextTitleProc,
	$kControlGroupBoxCheckBoxProc, $kControlGroupBoxPopupButtonProc,
	$kControlGroupBoxSecondaryTextTitleProc,
	$kControlGroupBoxSecondaryCheckBoxProc,
	$kControlGroupBoxSecondaryPopupButtonProc;
  export $kControlGroupBoxMenuHandleTag,
	$kControlGroupBoxFontStyleTag, $kControlGroupBoxTitleRectTag,
	$kControlImageWellProc;
  export $kControlImageWellContentTag, $kControlImageWellTransformTag,
	$kControlPopupArrowEastProc, $kControlPopupArrowWestProc,
	$kControlPopupArrowNorthProc, $kControlPopupArrowSouthProc,
	$kControlPopupArrowSmallEastProc, $kControlPopupArrowSmallWestProc,
	$kControlPopupArrowSmallNorthProc, $kControlPopupArrowSmallSouthProc,
	$kControlPlacardProc, $kControlClockTimeProc,
	$kControlClockTimeSecondsProc, $kControlClockDateProc,
	$kControlClockMonthYearProc, $kControlClockNoFlags,
	$kControlClockIsDisplayOnly, $kControlClockIsLive;
  export $kControlClockLongDateTag, $kControlClockFontStyleTag,
	$kControlUserPaneProc, $kControlUserItemDrawProcTag,
	$kControlUserPaneDrawProcTag, $kControlUserPaneHitTestProcTag,
	$kControlUserPaneTrackingProcTag, $kControlUserPaneIdleProcTag,
	$kControlUserPaneKeyDownProcTag, $kControlUserPaneActivateProcTag,
	$kControlUserPaneFocusProcTag, $kControlUserPaneBackgroundProcTag;
  export <ControlUserPaneDrawProcPtr>,
	<ControlUserPaneHitTestProcPtr>, <ControlUserPaneTrackingProcPtr>,
	<ControlUserPaneIdleProcPtr>, <ControlUserPaneKeyDownProcPtr>,
	<ControlUserPaneActivateProcPtr>, <ControlUserPaneFocusProcPtr>,
	<ControlUserPaneBackgroundProcPtr>, <ControlUserPaneDrawUPP>,
	<ControlUserPaneHitTestUPP>, <ControlUserPaneTrackingUPP>,
	<ControlUserPaneIdleUPP>, <ControlUserPaneKeyDownUPP>,
	<ControlUserPaneActivateUPP>, <ControlUserPaneFocusUPP>,
	<ControlUserPaneBackgroundUPP>, $uppControlUserPaneDrawProcInfo,
	$uppControlUserPaneHitTestProcInfo,
	$uppControlUserPaneTrackingProcInfo, $uppControlUserPaneIdleProcInfo,
	$uppControlUserPaneKeyDownProcInfo,
	$uppControlUserPaneActivateProcInfo,
	$uppControlUserPaneFocusProcInfo,
	$uppControlUserPaneBackgroundProcInfo, $kControlEditTextProc,
	$kControlEditTextPasswordProc, $kControlEditTextInlineInputProc;
  export $kControlEditTextStyleTag, $kControlEditTextTextTag,
	$kControlEditTextTEHandleTag, $kControlEditTextKeyFilterTag,
	$kControlEditTextSelectionTag, $kControlEditTextPasswordTag,
	$kControlEditTextKeyScriptBehaviorTag, $kControlEditTextLockedTag,
	$kControlEditTextFixedTextTag, $kControlEditTextValidationProcTag,
	$kControlEditTextInlinePreUpdateProcTag,
	$kControlEditTextInlinePostUpdateProcTag;
  export selStart-value, selStart-value-setter, selEnd-value,
	selEnd-value-setter, <ControlEditTextSelectionRec>,
	<ControlEditTextSelectionRec*>, <ControlEditTextSelectionRec**>;
  export <ControlEditTextSelectionPtr>,
	<ControlEditTextValidationProcPtr>, <ControlEditTextValidationUPP>,
	$uppControlEditTextValidationProcInfo, $kControlStaticTextProc,
	$kControlStaticTextStyleTag, $kControlStaticTextTextTag,
	$kControlStaticTextTextHeightTag, $kControlStaticTextTruncTag,
	$kControlPictureProc, $kControlPictureNoTrackProc, $kControlIconProc,
	$kControlIconNoTrackProc, $kControlIconSuiteProc,
	$kControlIconSuiteNoTrackProc;
  export $kControlIconRefProc, $kControlIconRefNoTrackProc,
	$kControlIconTransformTag, $kControlIconAlignmentTag,
	$kControlIconResourceIDTag, $kControlIconContentTag,
	$kControlWindowHeaderProc, $kControlWindowListViewHeaderProc,
	$kControlListBoxProc, $kControlListBoxAutoSizeProc;
  export $kControlListBoxListHandleTag, $kControlListBoxKeyFilterTag,
	$kControlListBoxFontStyleTag, $kControlListBoxDoubleClickTag,
	$kControlListBoxLDEFTag, $kControlPushButtonProc,
	$kControlCheckBoxProc, $kControlRadioButtonProc,
	$kControlPushButLeftIconProc, $kControlPushButRightIconProc,
	$kControlCheckBoxAutoToggleProc, $kControlRadioButtonAutoToggleProc;
  export $kControlPushButtonDefaultTag;
  export $kControlPushButtonCancelTag, $kControlScrollBarProc,
	$kControlScrollBarLiveProc, $kControlPopupButtonProc,
	$kControlPopupFixedWidthVariant, $kControlPopupVariableWidthVariant,
	$kControlPopupUseAddResMenuVariant, $kControlPopupUseWFontVariant,
	$kControlPopupButtonMenuHandleTag, $kControlPopupButtonMenuIDTag,
	$kControlPopupButtonExtraHeightTag;
  export $kControlRadioGroupProc, $kControlScrollTextBoxProc,
	$kControlScrollTextBoxAutoScrollProc;
  export $kControlScrollTextBoxDelayBeforeAutoScrollTag,
	$kControlScrollTextBoxDelayBetweenAutoScrollTag,
	$kControlScrollTextBoxAutoScrollAmountTag,
	$kControlScrollTextBoxContentsTag;
  export <ControlVariant>, <ControlVariant*>, <ControlVariant**>,
	$kControlNoVariant, $kControlUsesOwningWindowsFontVariant,
	$kControlNoPart, $kControlLabelPart, $kControlMenuPart,
	$kControlTrianglePart, $kControlEditTextPart, $kControlPicturePart,
	$kControlIconPart, $kControlClockPart, $kControlListBoxPart,
	$kControlListBoxDoubleClickPart, $kControlImageWellPart,
	$kControlRadioGroupPart, $kControlButtonPart, $kControlCheckBoxPart,
	$kControlRadioButtonPart, $kControlUpButtonPart,
	$kControlDownButtonPart, $kControlPageUpPart, $kControlPageDownPart,
	$kControlIndicatorPart, $kControlDisabledPart, $kControlInactivePart;
  export $kControlClockHourDayPart, $kControlClockMinuteMonthPart,
	$kControlClockSecondYearPart, $kControlClockAMPMPart,
	$kControlStructureMetaPart, $kControlContentMetaPart;
  export $kControlCheckBoxUncheckedValue,
	$kControlCheckBoxCheckedValue, $kControlCheckBoxMixedValue,
	$kControlRadioButtonUncheckedValue, $kControlRadioButtonCheckedValue,
	$kControlRadioButtonMixedValue, $popupFixedWidth,
	$popupVariableWidth, $popupUseAddResMenu, $popupUseWFont,
	$popupTitleBold, $popupTitleItalic, $popupTitleUnderline,
	$popupTitleOutline, $popupTitleShadow, $popupTitleCondense,
	$popupTitleExtend, $popupTitleNoStyle, $popupTitleLeftJust,
	$popupTitleCenterJust, $popupTitleRightJust, $noConstraint,
	$hAxisOnly, $vAxisOnly, NewControl, GetNewControl, DisposeControl,
	KillControls, HiliteControl, ShowControl, HideControl;
  export IsControlActive, IsControlVisible, ActivateControl,
	DeactivateControl, SetControlVisibility;
  export DrawControls, Draw1Control, UpdateControls;
  export GetBestControlRect, SetControlFontStyle,
	DrawControlInCurrentPort, SetUpControlBackground,
	SetUpControlTextColor;
  export DragControl, TestControl, FindControl, FindControlUnderMouse;
  export HandleControlKey, IdleControls;
  export MoveControl, SizeControl, SetControlTitle, GetControlTitle,
	GetControlValue, SetControlValue, GetControlMinimum,
	SetControlMinimum, GetControlMaximum, SetControlMaximum;
  export GetControlViewSize, SetControlViewSize, GetControl32BitValue,
	SetControl32BitValue, GetControl32BitMaximum, SetControl32BitMaximum,
	GetControl32BitMinimum, SetControl32BitMinimum, IsValidControlHandle,
	GetControlProperty, GetControlPropertySize, SetControlProperty,
	RemoveControlProperty;
  export GetControlRegion;
  export GetControlVariant, SetControlAction, GetControlAction,
	SetControlReference, GetControlReference, GetAuxiliaryControlRecord,
	SetControlColor, GetBevelButtonMenuValue, SetBevelButtonMenuValue,
	GetBevelButtonMenuHandle, GetBevelButtonContentInfo,
	SetBevelButtonContentInfo, SetBevelButtonTransform,
	SetBevelButtonGraphicAlignment, SetBevelButtonTextAlignment,
	SetBevelButtonTextPlacement, GetImageWellContentInfo,
	SetImageWellContentInfo, SetImageWellTransform, GetTabContentRect,
	SetTabEnabled, SetDisclosureTriangleLastValue, SendControlMessage,
	DumpControlHierarchy, CreateRootControl, GetRootControl,
	EmbedControl, AutoEmbedControl, GetSuperControl, CountSubControls,
	GetIndexedSubControl, SetControlSupervisor;
  export GetKeyboardFocus, SetKeyboardFocus, AdvanceKeyboardFocus,
	ReverseKeyboardFocus, ClearKeyboardFocus;
  export GetControlFeatures, SetControlData, GetControlData,
	GetControlDataSize;
  export <ControlDefProcMessage>, <ControlDefProcMessage*>,
	<ControlDefProcMessage**>, $drawCntl, $testCntl, $calcCRgns,
	$initCntl, $dispCntl, $posCntl, $thumbCntl, $dragCntl, $autoTrack,
	$calcCntlRgn, $calcThumbRgn, $drawThumbOutline, <ControlDefProcPtr>,
	<ControlDefUPP>, $uppControlDefProcInfo, $kDrawControlEntireControl,
	$kDrawControlIndicatorOnly, $kDragControlEntireControl,
	$kDragControlIndicator, limitRect-value, limitRect-value-setter,
	slopRect-value, slopRect-value-setter, axis-value, axis-value-setter,
	<IndicatorDragConstraint>, <IndicatorDragConstraint*>,
	<IndicatorDragConstraint**>, <IndicatorDragConstraintPtr>,
	<IndicatorDragConstraintHandle>;

  // from "Dialogs.h":
  export $gestaltDialogMgrAttr, $gestaltDialogMgrPresent,
	$dialogNoTimeoutErr;
  export $kControlDialogItem, $kButtonDialogItem,
	$kCheckBoxDialogItem, $kRadioButtonDialogItem,
	$kResourceControlDialogItem, $kStaticTextDialogItem,
	$kEditTextDialogItem, $kIconDialogItem, $kPictureDialogItem,
	$kUserDialogItem, $kItemDisableBit;
  export $ctrlItem, $btnCtrl, $chkCtrl, $radCtrl, $resCtrl, $statText,
	$editText, $iconItem, $picItem, $userItem, $itemDisable;
  export $kStdOkItemIndex, $kStdCancelItemIndex, $ok, $cancel;
  export $kStopIcon, $kNoteIcon, $kCautionIcon, $stopIcon, $noteIcon,
	$cautionIcon;
  export <DITLMethod>, <DITLMethod*>, <DITLMethod**>, $overlayDITL,
	$appendDITLRight, $appendDITLBottom;
  export <StageList>, <StageList*>, <StageList**>, <DialogRef>,
	<DialogRef*>, <DialogRef**>, window-value, window-value-setter,
	items-value, items-value-setter, textH-value, textH-value-setter,
	editField-value, editField-value-setter, editOpen-value,
	editOpen-value-setter, aDefItem-value, aDefItem-value-setter,
	<DialogRecord>, <DialogRecord*>, <DialogRecord**>;
  export <DialogPeek>, boundsRect-value, boundsRect-value-setter,
	procID-value, procID-value-setter, visible-value,
	visible-value-setter, filler1-value, filler1-value-setter,
	goAwayFlag-value, goAwayFlag-value-setter, filler2-value,
	filler2-value-setter, refCon-value, refCon-value-setter,
	itemsID-value, itemsID-value-setter, title-value, title-value-setter,
	<DialogTemplate>, <DialogTemplate*>, <DialogTemplate**>;
  export <DialogTPtr>, <DialogTHndl>, boundsRect-value,
	boundsRect-value-setter, itemsID-value, itemsID-value-setter,
	stages-value, stages-value-setter, <AlertTemplate>, <AlertTemplate*>,
	<AlertTemplate**>;
  export <AlertTPtr>, <AlertTHndl>, <DialogItemIndexZeroBased>,
	<DialogItemIndexZeroBased*>, <DialogItemIndexZeroBased**>,
	<DialogItemIndex>, <DialogItemIndex*>, <DialogItemIndex**>,
	<DialogItemType>, <DialogItemType*>, <DialogItemType**>,
	<SoundProcPtr>, <ModalFilterProcPtr>, <UserItemProcPtr>, <SoundUPP>,
	<ModalFilterUPP>, <UserItemUPP>, $uppSoundProcInfo,
	$uppModalFilterProcInfo, $uppUserItemProcInfo, $kAlertStopAlert,
	$kAlertNoteAlert, $kAlertCautionAlert, $kAlertPlainAlert;
  export <AlertType>, <AlertType*>, <AlertType**>,
	$kAlertDefaultOKText, $kAlertDefaultCancelText,
	$kAlertDefaultOtherText, $kAlertStdAlertOKButton,
	$kAlertStdAlertCancelButton, $kAlertStdAlertOtherButton,
	$kAlertStdAlertHelpButton;
  export $kDialogFlagsUseThemeBackground,
	$kDialogFlagsUseControlHierarchy, $kDialogFlagsHandleMovableModal,
	$kDialogFlagsUseThemeControls;
  export $kAlertFlagsUseThemeBackground,
	$kAlertFlagsUseControlHierarchy, $kAlertFlagsAlertIsMovable,
	$kAlertFlagsUseThemeControls, $kDialogFontNoFontStyle,
	$kDialogFontUseFontMask, $kDialogFontUseFaceMask,
	$kDialogFontUseSizeMask, $kDialogFontUseForeColorMask,
	$kDialogFontUseBackColorMask, $kDialogFontUseModeMask,
	$kDialogFontUseJustMask, $kDialogFontUseAllMask,
	$kDialogFontAddFontSizeMask, $kDialogFontUseFontNameMask,
	$kDialogFontAddToMetaFontMask;
  export movable-value, movable-value-setter, helpButton-value,
	helpButton-value-setter, filterProc-value, filterProc-value-setter,
	defaultText-value, defaultText-value-setter, cancelText-value,
	cancelText-value-setter, otherText-value, otherText-value-setter,
	defaultButton-value, defaultButton-value-setter, cancelButton-value,
	cancelButton-value-setter, position-value, position-value-setter,
	<AlertStdAlertParamRec>, <AlertStdAlertParamRec*>,
	<AlertStdAlertParamRec**>;
  export <AlertStdAlertParamPtr>;
  export InitDialogs, ErrorSound, NewDialog, GetNewDialog,
	NewColorDialog, CloseDialog, DisposeDialog, ModalDialog,
	IsDialogEvent, DialogSelect, DrawDialog, UpdateDialog,
	HideDialogItem, ShowDialogItem, FindDialogItem, DialogCut,
	DialogPaste, DialogCopy, DialogDelete, Alert, StopAlert, NoteAlert,
	CautionAlert, GetDialogItem, SetDialogItem, ParamText,
	SelectDialogItemText, GetDialogItemText, SetDialogItemText,
	GetAlertStage, SetDialogFont, ResetAlertStage;
  export AppendDITL, CountDITL, ShortenDITL, StdFilterProc,
	GetStdFilterProc, SetDialogDefaultItem, SetDialogCancelItem,
	SetDialogTracksCursor;
  export NewFeaturesDialog, AutoSizeDialog, StandardAlert,
	GetDialogItemAsControl, MoveDialogItem, SizeDialogItem,
	AppendDialogItemList, SetDialogTimeout, GetDialogTimeout,
	SetModalDialogEventMask, GetModalDialogEventMask, CouldDialog,
	FreeDialog, CouldAlert, FreeAlert;

  // Useful extensions from first.dylan
  export \open-accessor-definer;
end module carbon-interface;
